2004-12-31  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_rss.c (raptor_rss10_serialize_terminate): Free all
	namespaces, now they are not stacked explicitly.  Free namespace
	stack.
	(raptor_rss10_build_xml_names): Use raptor_new_namespace and don't
	start the rdf namespace.
	(raptor_rss10_build_xml_names): Use raptor_new_namespace and don't
	start the namespaces
	((raptor_rss10_serialize_end): Make a namespace stack here, with
	only xml: defined.

	* raptor/raptor_xml_writer.c
	(raptor_xml_writer_start_namespace_full): Deleted.
	(main): Declare the foo namespace but don't start it, so that the
	xml writer will do that.

	* raptor/raptor_xml_writer.c: Optionally declare a namespace stack
	internally.
	(raptor_new_xml_writer): Add optional raptor_namespace_stack
	parameter, if NULL declare one internally.

	* rasqal/rasqal_query.c (rasqal_query_results_write): Added,
	writing query results in form of
	http://www.w3.org/TR/2004/WD-rdf-sparql-XMLres-20041221/

	* rasqal/sparql_parser.y: Undef RASQAL_DEBUG 2 always

	* raptor/turtle_lexer.l, raptor/turtle_parser.y: Delete unused WS
	token

	* raptor/raptor_xml_writer.c, raptor/raptor_sax2.c,
	raptor/raptor_rss.c, raptor/raptor_rdfxml.c,
	raptor/raptor_internal.h, raptor/raptor.h, raptor/libraptor.3:
	Rename raptor_sax2_element to raptor_xml_element throughout.

	* raptor/raptor_internal.h: Added feature_start_uri to
	raptor_serializer

	* raptor/raptor_serialize.c (raptor_free_serializer): Tidy up any
	feature_start_uri set.
	(raptor_serializer_set_feature_string): Added, handling
	feature_start_uri.  created from a passed in string.
	(raptor_serializer_get_feature_string): Added, handling
	feature_start_uri as a returned shared string.

	* raptor/raptor_parse.c (raptor_parser_set_feature_string): Added,
	always failing.
	(raptor_parser_get_feature_string): Added, always failing.

	* raptor/raptor.h: Added feature RAPTOR_FEATURE_START_URI Added
	prototypes for raptor_parser_set_feature_string,
	raptor_parser_get_feature_string,
	raptor_serializer_set_feature_string,
	raptor_serializer_get_feature_string and raptor_feature_value_type

	* raptor/raptor_feature.c: Added flag bits for string valued
	features.  Added startUri (RAPTOR_FEATURE_START_URI) with a string
	value.
	(raptor_feature_value_type): Added, to return value of a feature.

2004-12-30  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/libraptor.3: Added SAX2 XML Element and XML Writer
	classes.

	* raptor/raptor_internal.h, raptor/raptor.h: Moved
	raptor_sax2_element and raptor_xml_writer to public API.

	* raptor/libraptor.3: Added rss-1.0 to raptor_new_serializer
	description.

	* raptor/libraptor.3: More updates for 1.4.3

2004-12-29  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage_sqlite.c: Make get_contexts fail rather than
	do useless things.

	* librdf/rdf_storage_sqlite.c: Moved GET_COLUMN* defines to top.
	Deleted all index_contexts - always supported.
	(librdf_storage_sqlite_statement_helper): Work when statement=NULL.
	(librdf_storage_sqlite_add_statements): Handle when max=4 for
	contexts.
	(librdf_storage_sqlite_serialise): Debug prepared query.
	(librdf_storage_sqlite_context_add_statement): Handle when max=4 for
	contexts.
	librdf_storage_sqlite_context_serialise_stream_context updated to add
	sqlite fields.
	(librdf_storage_sqlite_context_serialise): Implemented, based on
	librdf_storage_sqlite_serialise and related functions.

	* librdf/rdf_storage_sqlite.c
	(librdf_storage_sqlite_context_add_statement): Kill fixme, done.

	* librdf/rdf_storage_sqlite.c (librdf_storage_sqlite_set_helper):
	Add length arg.
	(librdf_storage_sqlite_uri_helper,
	librdf_storage_sqlite_blank_helper,
	librdf_storage_sqlite_literal_helper): Pass length to
	librdf_storage_sqlite_set_helper.
	(librdf_storage_sqlite_statement_helper): Do context nodes.
	(librdf_storage_sqlite_add_statements): Do context node field when
	present.
	(librdf_storage_sqlite_statement_operator_helper): Added, with
	content mostly from librdf_storage_sqlite_contains_statement.
	(librdf_storage_sqlite_contains_statement): Use above.
	(librdf_storage_sqlite_serialise,
	librdf_storage_sqlite_find_statements): Always free stringbuffer.
	(librdf_storage_sqlite_context_add_statement): Do context node field
	when present.
	(librdf_storage_sqlite_context_remove_statement): Implemented using
	librdf_storage_sqlite_statement_operator_helper.

	* librdf/rdf_storage_sqlite.c:
	Added sqlite_DB define for another 2/3 hide
	(librdf_storage_sqlite_serialise): Use raptor_stringbuffer_length(sb)
	for request length.

	* librdf/rdf_storage_sqlite.c:
	Alter GET_COLUMN* defines to take vm arg.

	* librdf/rdf_storage_sqlite.c:
	Fix sqlite_FREE and GET_COLUMN defines for sqlite API v3

	* librdf/rdf_storage_sqlite.c: casts for c++

	* librdf/rdf_storage_sqlite.c:
	Replace all use of fields with unsigned char* fields.

	* librdf/rdf_storage_sqlite.c (sqlite_string_escape):
	Emit 'string' - 2 more chars.
	(librdf_storage_sqlite_uri_helper,
	librdf_storage_sqlite_blank_helper): Malloc expressions based on
	actual lengths.
	(librdf_storage_sqlite_literal_helper): Remove ''s

	* librdf/rdf_storage_sqlite.c (librdf_storage_sqlite_set_helper):
	Take unsigned values string.
	(librdf_storage_sqlite_get_helper): Take unsigned expression string.
	(librdf_storage_sqlite_uri_helper): Use unsigned expression.
	(librdf_storage_sqlite_literal_helper): Use stringbuffer to build
	expression.
	(librdf_storage_sqlite_contains_statement): use stringbuffer to build
	request.

	* librdf/rdf_storage_sqlite.c (librdf_storage_sqlite_open):
	Auto-set new if file is missing.

	* librdf/rdf_storage_sqlite.c: Revert over EXEC named change.

	* librdf/rdf_storage_sqlite.c:
	Add macros sqlite_STATEMENT, sqlite_EXEC, sqlite_CLOSE, sqlite_FREE
	to hide more V2/V3 differences.
	(librdf_storage_sqlite_open): For V2 open failing, set rc.

	* librdf/rdf_storage_sqlite.c (librdf_storage_sqlite_get_next_common):
	Free temporary datatype uri

	* librdf/rdf_node.c (librdf_node_to_counted_string):
	Free temporary datatype_uri_string.

	* librdf/rdf_storage_sqlite.c
	(librdf_storage_sqlite_serialise_finished): Free any statement,
	context node.
	librdf_storage_sqlite_find_statements_stream_context add to store
	query_statement
	(librdf_storage_sqlite_find_statements): Store query statement.
	(librdf_storage_sqlite_find_statements_finished): Free any query
	statement, statement or context node.

	* librdf/rdf_storage_sqlite.c: Change context parts pzTail, ppVm
	to zTail, vm and for sqlite V2 use vm not vm & ppVm.

	* librdf/rdf_storage_sqlite.c: Use SQLITE_API with 2 or 3 to
	distinguish apis

	* configure.ac: Added --with-sqlite-version to choose V2 or
	V3. pkg-config gets the details.

	* librdf/rdf_storage_sqlite.c: Casts for c++

	* librdf/rdf_serializer_raptor.c
	(librdf_serializer_raptor_set_namespace): Cast for c++

2004-12-28  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage_sqlite.c (librdf_storage_sqlite_exec):
	Turn fprintf to debug message.
	(librdf_storage_sqlite_get_next_common): turn printing all column
	data into debug messages.
	(librdf_storage_sqlite_find_statements): Turn fprintf to debug
	message.

	* configure.ac: Set -g -DLIBRDF_DEBUG in maintainer mode - was
	lost somehow.

	* librdf/rdf_storage_sqlite.c: code style

	* librdf/rdf_storage_sqlite.c (sqlite_construct_select_helper):
	Added, to build serialise and find_statements query parts.
	(librdf_storage_sqlite_serialise): Move most of query building into
	sqlite_construct_select_helper and now call it.
	(librdf_storage_sqlite_find_statements): Use
	sqlite_construct_select_helper to build guts of query, then add
	the WHERE ...

	* librdf/rdf_storage_sqlite.c (librdf_storage_sqlite_serialise):
	Use raptor_stringbuffer to construct big request.
	(librdf_storage_sqlite_get_next_common): Add pointer to statement,
	context_node args.
	Fill in statement and context node from column values.
	Debug print out column names, values.
	(librdf_storage_sqlite_serialise_end_of_stream,
	librdf_storage_sqlite_serialise_next_statement,
	librdf_storage_sqlite_find_statements_next_statement, ): Update
	call to librdf_storage_sqlite_get_next_common.

2004-12-27  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage_sqlite.c (librdf_storage_sqlite_get_helper,
	librdf_storage_sqlite_add_statements,
	librdf_storage_sqlite_context_add_statement): Use
	raptor_stringbuffer to construct requests.

	* librdf/rdf_storage_sqlite.c (librdf_storage_sqlite_set_helper):
	Use raptor_stringbuffer to construct request.

	* librdf/rdf_storage_sqlite.c: Added TRIPLE_NONE node_type
	(librdf_storage_sqlite_node_helper): Fail with NULL node.
	(librdf_storage_sqlite_statement_helper): Handle NULL nodes, set
	ID to -1, type to TRIPLE_NONE.
	(librdf_node_to_sqlite_string): Deleted, not used.
	(librdf_storage_sqlite_find_statements): Use raptor_stringbuffer to
	construct request.

	* librdf/rdf_storage_sqlite.c (librdf_storage_sqlite_literal_helper):
	Use IDs for datatype URI.
	(librdf_storage_sqlite_open): Make uriindex.

	* librdf/rdf_storage_sqlite.c (sqlite_string_escape):
	Escape ' as '' not \'
	(librdf_storage_sqlite_uri_helper): Renamed from
	librdf_storage_sqlite_store_uri_helper
	(librdf_storage_sqlite_blank_helper): Renamed from
	librdf_storage_sqlite_store_blank_helper
	(librdf_storage_sqlite_literal_helper): Added
	(librdf_storage_sqlite_node_helper): Use
	librdf_storage_sqlite_literal_helper.
	(librdf_storage_sqlite_open): If new, unlink the file so no need
	to do DROP TABLE.

	* librdf/rdf_storage_sqlite.c (librdf_storage_sqlite_init):
	is_new flag set right, really really.
	Added data-driven table descriptions - table_info, NTABLES,
	sqlite_table_numbers, sqlite_tables, triple_part, triple_node_type,
	triples_fields.
	Reorder helper functions.
	(sqlite_string_escape): Now always obeys raw_len and nul-terminates
	the output.
	(librdf_storage_sqlite_exec): Debug print all SQL exec
	(librdf_storage_sqlite_set_helper,
	librdf_storage_sqlite_get_helper): Added, using table info.
	(librdf_storage_sqlite_store_uri_helper): Added, returns or makes an
	ID for the given URI.
	(librdf_storage_sqlite_store_blank_helper): Added, returns or makes an
	ID for the given blank node ID.
	(librdf_storage_sqlite_node_helper): Added, turns a librdf_node into
	appropriate table IDs, node type and returns to user.
	(librdf_storage_sqlite_statement_helper): Uses
	librdf_storage_sqlite_node_helper to get node ids, types and field
	names for all of a statement.
	(librdf_storage_sqlite_open): Use data tables for DROP TABLE,
	CREATE TABLE
	(librdf_storage_sqlite_size): Use librdf_storage_sqlite_exec only.
	(librdf_storage_sqlite_add_statements): Updated dummy INSERT for
	new schema.
	(librdf_storage_sqlite_contains_statement): Use
	librdf_storage_sqlite_statement_helper to build query.
	(librdf_storage_sqlite_context_add_statement): Use
	librdf_storage_sqlite_statement_helper to build INSERT.  Ignores
	context fields for now.

2004-12-26  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* utils/rdfproc.c: Added size command calling librdf_model_size.

	* librdf/rdf_storage_sqlite.c: Handle sqlite3 and sqlite2
	(librdf_storage_sqlite_init): Init is_new correctly.
	(librdf_storage_sqlite_open): Create tables, indexes when new.
	(librdf_storage_sqlite_get_1int_callback): Grab count value from
	argv[0]
	(librdf_storage_sqlite_size): Works.
	(librdf_storage_sqlite_add_statements): Dummy INSERT works.
	(librdf_storage_sqlite_contains_statement): Dummy sql added.
	librdf_storage_sqlite_serialise_stream_context added sqlite3 fields
	(librdf_storage_sqlite_serialise,
	librdf_storage_sqlite_get_next_common,
	librdf_storage_sqlite_serialise_finished): sqlite3 support
	librdf_storage_sqlite_find_statements_stream_context added sqlite3
	fields
	(librdf_storage_sqlite_find_statements,
	librdf_storage_sqlite_find_statements_finished): sqlite3 support
	(librdf_storage_sqlite_context_add_statement): Dummy INSERT added.
	(librdf_init_storage_sqlite): Storage name now 'sqlite'.

2004-12-25  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* configure.ac: Check for sqlite3.h or sqlite.h after getting
	sqlite paths.

	* configure.ac: Use pkg-config sqlite3 or pkg-config sqlite2

	* librdf/rdf_serializer.c, librdf/rdf_model.c (main):
	Cast for size_t to int

	* librdf/rdf_concepts.c: Removed librdf_concept_labels - never used.

	* raptor/raptor_rss.c (raptor_rss_parser_processNode):
	Turn <guid isPermaLink="true">val</guid>
	into <guid rdf:resource="val"/>
	(raptor_rss10_emit_item): Always serialize rss:items at the end of
	an rss channel.

	* raptor/raptor_xml_writer.c, raptor/raptor_xml.c,
	raptor/raptor_utf8.c, raptor/raptor_sax2.c, raptor/raptor_rss.c,
	raptor/raptor_general.c: Casts for c++.  Rename variables
	namespace to nspace.

2004-12-24  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_www_test.c (main): Cast for size_t

2004-12-23  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_rss.c (raptor_rss10_serialize_statement):
	Fix item URI check to use correct
	URI.  In debugging unknown typed node, print type URI.

	* raptor/raptor_rss.c (raptor_rss10_serialize_statement):
	Do not look in items with no URI.
	(raptor_rss10_build_xml_names): Do not make qnames for types with no
	namespace.

	* raptor/raptor_rss.c (raptor_rss10_build_items):
	Do nothing if there is no seq_uri

	* raptor/raptor_rss.c (raptor_init_serializer_rss10):
	Give rss 1.0 a URI

	* librdf/rdf_serializer.c (librdf_get_serializer_factory):
	Ensure that if mime_type or type_uri are
	not NULL, the factory must have a non-NULL item and it must match.

	* librdf/rdf_serializer.c (librdf_get_serializer_factory):
	Ensure that if mime_type or type_uri are
	not NULL, the factory must have a non-NULL item and it must match.

	* librdf/rdf_parser.c (librdf_get_parser_factory):
	Ensure that if mime_type or type_uri are
	not NULL, the factory must have a non-NULL item and it must match.

2004-12-21  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage_mysql.c (librdf_storage_mysql_init): Applied
	patch from Morten to only use mysql_real_escape_string if a
	connection was made.
	(librdf_storage_mysql_find_statements_in_context_next_statement):
	Do not call librdf_storage_mysql_find_statements_in_context_finished
	when errors happen, the iterator class will do that on destruction.
	(librdf_storage_mysql_get_contexts_next_context): Do not call
	librdf_storage_mysql_get_contexts_finished when errors happen, the
	iterator class will do that on destruction.

	* raptor/raptor_rss.c: Added rss_namespace_prefix_strings to list
	namespaces to declare.  raptor_rss10_serializer_context gains
	raptor_namespace_stack nstack field.
	(raptor_rss10_serialize_init): Init the namespace stack.
	(raptor_rss10_serialize_terminate): Clean namespace stack and any
	defined qnames.
	(raptor_rss10_emit_item): Padding.
	(raptor_rss10_serialize_end): Write namespace decls using stack.

	* raptor/raptor_rss.c: Rename some destructors more normally:
	(raptor_free_rss_item): Renamed from raptor_item_free.
	(raptor_free_rss_items): Renamed from raptor_rss_items_free.
	(raptor_rss10_move_statements, raptor_rss10_store_statement):
	Record field counts per item.
	(raptor_rss10_build_items): Find the rdf:_<n> items and put them
	into a raptor sequence.
	(raptor_rss10_emit_item): Skeleton rss item writer.
	(raptor_rss10_serialize_end): Make the final structures and do the
	serializing in skeleton form.

2004-12-20  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_rss.c: Added seq_uri to
	raptor_rss10_serializer_context
	(raptor_rss10_serialize_terminate): Tidy seq_uri
	(raptor_rss10_move_statements, raptor_rss10_store_statement):
	Ignore checking fields with no URI.
	(raptor_rss10_serialize_statement): For rdf:Seq node, store the
	URI or blank node - as fake URI.  Make fake object node correctly
	for general statements.

	* raptor/raptor_rss.c (raptor_rss_common_init):	Prevent 2x
	initialising.
	(raptor_item_free): Free type URI
	(raptor_rss10_serialize_terminate): Call raptor_rss_common_terminate.
	(raptor_rss10_move_statements): Use RAPTOR_IDENTIFIER_TYPE_PREDICATE
	set raptor_sequence_set_at destroy overwritten object.
	(raptor_rss10_store_statement): Use RAPTOR_IDENTIFIER_TYPE_PREDICATE
	Make fake URIs from blank node strings and free them.

	* raptor/raptor_general.c (raptor_free_statement):
	Handle more statement part types.

	* raptor/raptor_rss.c: RAPTOR_RSS_FIELDS_SIZE now stops before
	UNKNOWN for real field names.
	(raptor_rss10_move_statements): Added, to move statements from the
	sequence of triples to below a typed node once a new typed node of
	the given type appears.
	(raptor_rss10_store_statement): Added, to store a given statement
	either below an existing typed node or in a sequence of triples if
	it can't be found one.

	* raptor/raptor_rss.c (raptor_rss10_serialize_statement): iostream
	write turned into debug.

2004-12-19  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_uri.c (raptor_uri_print): Cast for gcc

	* raptor/raptor_rss.c: Use raptor_uri in raptor_rss_item.
	(raptor_rss_context_init, raptor_rss_context_terminate): Added and
	used in parser and serializer init and terminate.
	(raptor_rss10_serialize_init): Initialise list of triples, items.
	(raptor_rss10_serialize_terminate): Tidy up triples, items.
	(raptor_rss10_serialize_statement): Look for known typed nodes,
	identify ones matching rss 1.0 model and also look for the rdf:Seq.
	Store other triples for later.
	(raptor_rss10_serialize_end): Added skeleton.

2004-12-18  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_uri.c (raptor_uri_print): Added.

	* raptor/raptor.h: Added raptor_uri_print

	* raptor/raptor_general.c (raptor_statement_copy):
	Added statement copy constructor
	(raptor_free_statement): Added statement destructor.

	* raptor/raptor_internal.h:
	Added raptor_statement_copy and raptor_free_statement

	* raptor/raptor_rss.c:
	Moved parser namespace URIs to common code rss_namespace_uris.
	(raptor_rss_common_init, raptor_rss_common_terminate): Added to
	initialise and free up common rss items - namespace URIs, URIs for
	types and uris for properties.
	Added skeleton RSS 1.0 serializer
	(raptor_rss10_serialize_init, raptor_rss10_serialize_terminate,
	raptor_rss10_serialize_statement,
	raptor_rss10_serialize_finish_factory,
	raptor_rss10_serializer_register_factory,
	raptor_init_serializer_rss10): Added skeleton RSS 1.0 serializer
	factory and methods.

	* raptor/raptor_general.c (raptor_init):
	Added call to raptor_init_serializer_rss10

	* raptor/raptor_internal.h: Added raptor_init_serializer_rss10

	* raptor/raptor_rss.c (raptor_rss_parse_recognise_syntax):
	Add atom checks.

2004-12-17  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* raptor/tests/Makefile.am: Added
	RDF_MAYFAIL_XML_TEST_FILES,RDF_MAYFAIL_XML_OUT_FILES and rule
	check-mayfail-xml-rdf to run checks that may fail due to XML
	parser bugs.

	* raptor/raptor_iostream.c, raptor/raptor_nfc.c,
	raptor/raptor_rdfxml.c, raptor/raptor_sax2.c,
	raptor/raptor_serialize.c: Initialising possibly using
	uninitialised vars

	* raptor/raptor.h, raptor/raptor_internal.h,
	raptor/raptor_iostream.c, raptor/raptor_namespace.c,
	raptor/raptor_rdfxml.c, raptor/raptor_serialize.c,
	raptor/raptor_xml_writer.c, raptor/rdfdump.c: Casts for c++

	* raptor/raptor_rdfxml.c: Fix using wrong element name in warnings.

	* raptor/raptor_rdfxml.c (raptor_xml_start_element_handler):
	Use raptor_sax2_element_set_attributes.

	* raptor/raptor_xml_writer.c (raptor_xml_writer_empty_element): Added.
	(raptor_xml_writer_start_element, raptor_xml_writer_end_element):
	Updated raptor_iostream_write_sax2_element calls
	(main): Add attributes and test writing empty element.

	* raptor/raptor_internal.h: Added raptor_sax2_element_set_attributes
	Added is_empty arg to raptor_iostream_write_sax2_element
	Added raptor_xml_writer_empty_element

	* raptor/raptor_sax2.c (raptor_sax2_element_set_attributes): Added.
	(raptor_print_sax2_element): tidy
	(raptor_iostream_write_sax2_element): Added is_empty arg
	and use it for <foo... /> form.

2004-12-14  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* raptor/libraptor.3: Updated for 1.4.3 so far

	* raptor/tests/turtle/README.txt,
	raptor/tests/turtle/rdfq-results.out,
	raptor/tests/turtle/test-00.out, raptor/tests/turtle/Makefile.am:
	Switch to base URI http://www.w3.org/2001/sw/DataAccess/df1/tests/

	* raptor/tests/turtle/bad-08.ttl, raptor/tests/turtle/bad-09.ttl,
	raptor/tests/turtle/bad-10.ttl, raptor/tests/turtle/bad-11.ttl,
	raptor/tests/turtle/bad-12.ttl, raptor/tests/turtle/bad-13.ttl,
	raptor/tests/turtle/manifest-bad.ttl,
	raptor/tests/turtle/manifest.ttl, raptor/tests/turtle/test-13.out,
	raptor/tests/turtle/test-13.ttl, raptor/tests/turtle/Makefile.am,
	raptor/tests/turtle/bad-04.ttl, raptor/tests/turtle/bad-05.ttl,
	raptor/tests/turtle/bad-06.ttl, raptor/tests/turtle/bad-07.ttl:
	Import more bad turtle tests, initial manifest files

	* raptor/raptor_namespace.c (raptor_iostream_write_namespace):
	Handle ns->uri is NULL and no prefix, i.e. emitting xmlns=""

	* raptor/raptor_namespace.c (raptor_namespaces_format): Handle
	ns->uri is NULL and no prefix, i.e. emitting xmlns=""

2004-12-08  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_uri.c (librdf_new_uri_relative_to_base): Ask for 1
	more char for new URI buffer for raptor_uri_resolve_uri_reference
	to allow inserting of a missing "/" path.

	* librdf/rdf_uri.c (librdf_new_uri_relative_to_base): Ask for 1
	more char for new URI buffer for raptor_uri_resolve_uri_reference
	to allow inserting of a missing "/" path.

	* raptor/raptor_uri.c (raptor_default_new_uri_relative_to_base):
	Ask for 1 more char for new URI to allow inserting of a missing
	"/" path.

	* raptor/raptor_rfc2396.c (raptor_uri_resolve_uri_reference): Add
	debug message.  When adding a missing path "/", set the path_len
	and the uri_len to match.
	(main): Added test when a missing abs / path is added.

	* rasqal/tests/rdql/testsuite/Makefile.am (check-rdql-correct):
	Set PATH then use -s $(srcdir) rather than
	lots of envariable passing.

	* rasqal/tests/rdql/testsuite/check-rdql:
	Merged in changes from check-sparql - use -s . argument now.

	* configure.ac:
	Delete changing PATH here for OSX. A bad idea as it makes the
	configure environment different from the user's.
	Added /opt/local to BDB search path for darwinports.

	* rasqal/rasqal_engine.c (rasqal_engine_execute_init):
	Init current_graph_pattern only if there
	are graph patterns.
	(rasqal_engine_get_next_result): Handle 0 graph patterns.

	* rasqal/tests/sparql/syntax/Makefile.am: Added manifest.n3
	Invoke check-sparql-correct test

	* rasqal/tests/sparql/syntax/manifest.n3: Test manifest

	* rasqal/tests/sparql/syntax/result-0triples.n3:
	select with 0 triples result

	* rasqal/tests/sparql/syntax/Makefile.am: Added 0triples.rq

	* rasqal/tests/sparql/syntax/0triples.rq: Zero graph pattern triples

	* rasqal/tests/sparql/syntax/data.n3: typo

	* raptor/raptor_sequence.c (raptor_sequence_set_at,
	raptor_sequence_get_at): Check for non-negative idx

	* raptor/raptor_sequence.c (raptor_sequence_get_at):
	Fix index offset check

2004-12-07  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_parser.y (PatternElementForms): Handle empty
	GraphPattern1 (NULL sequences)

	* rasqal/tests/sparql/part1/dawg-data-01.n3,
	rasqal/tests/sparql/part1/dawg-query-002,
	rasqal/tests/sparql/simple/dawg-tp-04.rq,
	rasqal/tests/sparql/simple/dawg-data-01.n3: foaf:knowns to
	foaf:knows

2004-12-02  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* raptor/rdfdump.c: Make a raptor_sequence of namespace
	declarations declared by '-f xmlns:foo="bar"' and then add them to
	the serializer when initialised.
	(rdfdump_free_namespace_decl): Added, to provide a helper to
	cleanup.

	* raptor/raptor_serialize.c (raptor_serialize_set_namespace): Call
	factory method declare_namespace.
	(raptor_rdfxml_serialize_declare_namespace): Copy the passed in
	namespace prefix, URI before storing the namespace.
	(raptor_rdfxml_serialize_start): Delete the namespace sequence
	contents as the namespaces are declared on the namespace stack,
	which is the new owner of the namespaces.

	* raptor/raptor_namespace.c
	(raptor_new_namespace_parts_from_string): Added, to decode things
	like "xmlns:foo='bar'" into prefix, uri strings.

	* raptor/raptor.h: Added prototype for
	raptor_new_namespace_parts_from_string.
	raptor_sequence_free_handler prototype changed to return void

2004-11-30  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/examples/ex2-1a-result.n3,
	rasqal/tests/sparql/examples/ex2-2a-result.n3,
	rasqal/tests/sparql/examples/ex2-3a-result.n3,
	rasqal/tests/sparql/examples/ex2-4a-result.n3,
	rasqal/tests/sparql/examples/ex3-result.n3: .

	* raptor/raptor_serialize.c (raptor_rdfxml_serialize_init): Add a
	sequence of user-declared namespaces.
	(raptor_rdfxml_serialize_terminate): Tidy sequence.
	(raptor_rdfxml_serialize_declare_namespace): Use sequence to store
	declared namespaces.
	(raptor_rdfxml_serialize_start): Declare used-defined namespaces
	and start them in the namespace stack.

	* raptor/raptor_namespace.c (raptor_new_namespace_from_uri): Added
	with raptor_new_namespace code.
	(raptor_new_namespace): Now a wrapper around
	raptor_new_namespace_from_uri.
	(raptor_namespace_copy): Use raptor_new_namespace_from_uri.

	* raptor/raptor_qname.c (raptor_iostream_write_qname):
	Added to write a qname to an iostream.

	* raptor/raptor.h: Add prototypes for raptor_iostream_write_qname,
	raptor_new_namespace_from_uri

	* raptor/raptor_rdfxml.c (raptor_xml_start_element_handler,
	raptor_xml_end_element_handler, raptor_xml_comment_handler,
	raptor_start_element_grammar, raptor_end_element_grammar,
	raptor_cdata_grammar): Update the use of xml_writer for building
	parseType="Literal" content to use an iostream. Use more sax2
	methods rather than direct access to internals - still some left.
	(raptor_xml_parse_init, raptor_xml_parse_start,
	raptor_xml_parse_terminate, raptor_inscope_xml_language,
	raptor_inscope_base_uri): Move expat/libxml details to
	raptor_new_sax2, raptor_sax2_parse_start, raptor_free_sax2,
	raptor_sax2_inscope_xml_language, raptor_sax2_inscope_base_uri
	respectively.
	(raptor_xml_parse_chunk_): Deleted, moved to
	raptor_sax2_parse_chunk

	* raptor/raptor_xml_writer.c: Change to output to an iostream not
	build up a stringbuffer.
	(raptor_new_xml_writer): Add iostream arg, delete never-used
	canonicalize.
	(raptor_free_xml_writer): Remvoe stringbuffer.
	(raptor_xml_writer_start_element, raptor_xml_writer_end_element):
	Delete stringbuffer and use raptor_iostream_write_sax2_element.
	(raptor_xml_writer_cdata): Delete stringbuffer and use
	raptor_iostream_write_xml_escaped_string.
	(raptor_xml_writer_raw): Added to write just the bytes.
	(raptor_xml_writer_comment): Fixed to emit <!-- and -->
	(raptor_xml_writer_as_string): Deleted.
	(main): Added with test case.

	* raptor/raptor_sax2.c (raptor_new_sax2, raptor_free_sax2,
	raptor_sax2_inscope_xml_language, raptor_sax2_inscope_base_uri,
	raptor_sax2_get_depth, raptor_sax2_inc_depth,
	raptor_sax2_dec_depth, raptor_sax2_parse_start,
	raptor_sax2_parse_chunk, raptor_sax2_element_get_element): Added.
	(raptor_iostream_write_sax2_element): Renamed from
	raptor_format_sax2_element and now writing to a raptor_iostream
	with no allocing/freeing buffers.

	* raptor/raptor_xml.c (raptor_iostream_write_xml_escaped_string):
	Added, to write an
	XML-escaped version of a string to an iostream

2004-11-29  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_namespace.c (raptor_iostream_write_namespace):
	Added to write a namespace to a raptor_iostream

	* raptor/raptor.h: Added raptor_iostream_write_namespace

	* raptor/Makefile.am: Added raptor_xml_writer_test

	* raptor/raptor_expat.c (raptor_expat_init): Take void* user data

	* raptor/raptor_internal.h: raptor_exp_init takes void*
	Add user_data to raptor_sax2
	Added prototypes or raptor_new_sax2, raptor_free_sax2,
	raptor_sax2_parse_start, raptor_sax2_parse_chunk,
	raptor_sax2_parse_handle_errors, raptor_sax2_get_depth,
	raptor_sax2_inc_depth, raptor_sax2_dec_depth,
	raptor_sax2_inscope_xml_language, raptor_sax2_inscope_base_uri,
	raptor_sax2_element_get_element, raptor_iostream_write_sax2_element
	Deleted raptor_format_sax2_element, raptor_xml_writer_as_string and
	raptor_xml_writer_write_to_iostream
	Changed raptor_new_xml_writer to write to a raptor_iostream

	* raptor/raptor.h: Added raptor_iostream_write_xml_escaped_string
	and raptor_namespace_write

	* rasqal/rasqal_expr.c (rasqal_expression_evaluate):
	UMINUS, PLUS, MINUX, STAR, SLASH are
	now done with floating literals.

	* rasqal/rasqal_internal.h: Export rasqal_literal_as_floating

	* rasqal/rasqal_literal.c (rasqal_new_floating_literal):
	Changed to take a double arg
	(rasqal_literal_as_floating): Export.
	(rasqal_literal_compare): Improve promotion. Promote to float where
	needed, especially assuming strings could be a float.

	* rasqal/sparql_lexer.l, rasqal/rdql_lexer.l:
	Do sscanf here and call rasqal_new_floating_literal with the double.

	* rasqal/rasqal.h: rasqal_new_floating_literal takes a double arg

	* rasqal/tests/sparql/check-sparql,
	rasqal/tests/rdql/testsuite/check-rdql: diff backwards

	* rasqal/tests/sparql/part1/dawg-result-002.n3,
	rasqal/tests/sparql/part1/dawg-result-003.n3,
	rasqal/tests/sparql/simple/result-tp-01.n3,
	rasqal/tests/sparql/simple/result-tp-02.n3,
	rasqal/tests/sparql/simple/result-tp-03.n3,
	rasqal/tests/sparql/simple/result-tp-04.n3,
	rasqal/tests/sparql/part1/dawg-result-001.n3: Update to DAWG
	latest results removing rs:size triples.

	* rasqal/rasqal_literal.c (rasqal_literal_as_integer): For
	RASQAL_LITERAL_STRING, also try to evaluate it as a double with
	strtod, then return that cast to int if it worked.

	* rasqal/sparql_parser.y, rasqal/rdql_parser.y (UnaryExpression):
	Make unary plus and minus work; removes 2
	shift/reduce conflicts.

	* rasqal/rasqal_expr.c:
	(rasqal_free_expression, rasqal_expression_foreach,
	rasqal_expression_evaluate, rasqal_expression_print):
	Added RASQAL_EXPR_UMINUS support.
	rasqal_op_labels: added uminus

	* rasqal/rasqal.h: Added RASQAL_EXPR_UMINUS

2004-11-26  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_internal.h: Added prototype for
	raptor_xml_writer_write_to_iostream

	* raptor/raptor_xml_writer.c
	(raptor_xml_writer_write_to_iostream): Added

	* raptor/raptor.h: Added prototype for
	raptor_iostream_write_stringbuffer

	* raptor/raptor_iostream.c: (raptor_iostream_write_stringbuffer) Added

	* configure.ac, rasqal/configure.ac, raptor/configure.ac:
	--with-dmalloc default is now no

	* librdf/Makefile.am: Remove rdf_storage_tstore.h rdf_storage_mysql.h

2004-11-25  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* raptor/configure.ac: If expat_source is empty, set it to auto so
	no path-to-source is added to libs, includes

2004-11-23  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* raptor/tests/ex-55.out, raptor/tests/ex-55.rdf: ex-55

	* raptor/tests/Makefile.am: Added ex-55

	* librdf/rdf_storage_mysql.h, librdf/rdf_storage_tstore.h: Deleted

	* configure.ac:
	Rip out STORAGE_OBJS code and make all storage modules have
	available/enabled set.  memory is always available and required
	file, hashes are always available and enabled by default.
	Test for sqlite.h
	Reduce mysql min to 3.23.56 - should go lower.

2004-11-22  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* librdf/Makefile.am:
	Use STORAGE_ conditionals instead of @STORAGE_OBJS@

	* librdf/rdf_storage.c:
	Delete rdf_storage_hashes.h and rdf_storage_list.h includes, they are
	called from rdf_storage.h already.
	(librdf_init_storage) Use STORAGE_ defines.

	* librdf/rdf_storage_sqlite.c:
	don't sleep now, this should be fixed later

	* librdf/rdf_storage.h: Use STORAGE_ defines.
	Delete rdf_storage_tstore.h and rdf_storage_mysql.h includes

	* librdf/rdf_storage.c (librdf_init_storage):
	Added call to librdf_init_storage_sqlite

	* librdf/Makefile.am: Added rdf_storage_sqlite.c

	* librdf/rdf_storage.h: added librdf_init_storage_sqlite prototype

	* librdf/rdf_storage_sqlite.c: sqlite storage

2004-11-21  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_engine.c (rasqal_new_graph_pattern_from_triples):
	Init current column to -1 so no execution or tidy happens.
	(rasqal_free_graph_pattern): Clean up until reach start_column, not 0.
	(rasqal_graph_pattern_init): Do triple init work only if there are
	triples.

	* rasqal/sparql_parser.y: s/puts/fputs(..., stdout)/

	* rasqal/rasqal_engine.c (rasqal_new_graph_pattern_from_sequence):
	Fold sequence of 1 graph
	pattern into the return value, tidying up.
	(rasqal_graph_pattern_print): Print just the triple columns that are
	used.  Print flags using words.
	(rasqal_graph_pattern_get_next_match): Note failing not-implemented
	sequence of graph_patterns.
	(rasqal_engine_prepare): Do not invoke rasqal_query_order_triples -
	does not make sense to do with the graph_pattern code.
	(rasqal_engine_get_next_result): Note failing not-implemented
	sequence of graph_patterns.
	Debug message when an optional graph pattern failed to patch.

	* rasqal/rasqal_expr.c (rasqal_variable_set_value):
	Debug fatal error when there is no name.

2004-11-20  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_engine.c (rasqal_new_graph_pattern_from_sequence):
	lose triples argument
	(rasqal_graph_pattern_get_next_match, rasqal_engine_get_next_result):
	Check and fail for sequence of graph_patterns.

	* rasqal/rasqal_internal.h:
	Update rasqal_new_graph_pattern_from_sequence to lose triples argument

	* rasqal/rdql_parser.y (rasqal_rdql_query_engine_prepare):
	Use rasqal_new_graph_pattern_from_triples

	* rasqal/rasqal_query.c (rasqal_new_query): Init triples here.
	(rasqal_query_print): Print graph_patterns

	* rasqal/rasqal_internal.h:
	Add graph_patterns sequence to rasqal_graph_pattern.
	Added prototypes for rasqal_new_graph_pattern_from_triples and
	rasqal_new_graph_pattern_from_sequence

	* rasqal/rasqal_engine.c (rasqal_new_graph_pattern_from_triples):
	Renamed from rasqal_new_graph_pattern
	(rasqal_new_graph_pattern_from_sequence): Added to handle a graph
	pattern as a sequence of graph patterns.
	(rasqal_free_graph_pattern): Handle cleanup for sequence.
	(rasqal_graph_pattern_print): Handle sequence and simplify.
	(rasqal_engine_execute_init): Abort with messsage if sequence has a
	NULL graph pattern in it.

2004-11-19  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_engine.c (rasqal_engine_execute_init):
	Init current_graph_pattern.
	(rasqal_engine_get_next_result): Attempt to walk through graph_patterns
	without failing on optional ones.

	* rasqal/rasqal_internal.h:
	Added current_graph_pattern to rasqal_query.

	* rasqal/sparql_lexer.l (sparql_token_print): Added UNION token

	* rasqal/sparql_parser.y: Added UNION token

	* rasqal/sparql_lexer.l: Added UNION|union keyword

	* rasqal/sparql_parser.y (rasqal_sparql_query_engine_prepare): Add
	graph pqttern of all triples found.

	* rasqal/rdql_parser.y (rasqal_rdql_query_engine_prepare): Add
	graph pqttern of all triples found.

	* rasqal/rasqal_engine.c (rasqal_new_graph_pattern):
	No triples_size.  Don't init triple_meta
	here but on each execution.
	(rasqal_free_graph_pattern, rasqal_graph_pattern_get_next_match):
	update triple_meta offset
	(rasqal_graph_pattern_init): Added, to init for execution.
	(rasqal_graph_pattern_print): Added for debug printing.
	(rasqal_engine_execute_init): Use query->graph_patterns - init them
	with rasqal_graph_pattern_init
	(rasqal_engine_execute_finish): Do not delete query->graph_pattern.
	(rasqal_engine_get_next_result): Pick 0th item from
	query->graph_patterns to execute.

	* rasqal/rasqal_query.c (rasqal_new_query, rasqal_free_query):
	Init/free
	query->graph-patterns sequence

	* rasqal/rasqal_internal.h:
	Delete triples_count from rasqal_graph_pattern.
	Only use exactly what's needed - end-start+1 columns
	Added rasqal_graph_pattern_init and rasqal_graph_pattern_print
	prototypes

	* configure.ac: Doc fix, --with-mysql works for mysql 3/4

	* rasqal/sparql_parser.y (PatternElementForms):
	'SOURCE * ...' Warn this is ignored.
	'Source VarOrURI ...' Set triple origin from the literal
	(UnaryExpressionNotPlusMinus): Delete ignored ArgList for now.

	* rasqal/rasqal_internal.h: Added rasqal_graph_pattern_adjust prototype

	* rasqal/rasqal_engine.c (rasqal_new_graph_pattern,
	rasqal_free_graph_pattern): Docs, code tidy.
	(rasqal_graph_pattern_adjust): Added, to shift graph pattern
	columns.
	(rasqal_graph_pattern_get_next_match): Code tidy.

2004-11-17  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* raptor/examples/grapper.c:
	Extensively updated to use GTK 2.4, 2.5 features when available.
	Triples/Errors windows have a scalable pane between them
	Triple columns can be sorted by clicking, width resized.
	All known parser features are available on the preferences menu.
	Added parser guessing button.
	Moved syntax menu to top of display.
	Updated about box fields to include more info when possible to
	display.

	* rasqal/rasqal_engine.c (rasqal_engine_get_next_result):
	More code tweaks

	* rasqal/rasqal_engine.c (rasqal_engine_get_next_result):
	Evaluate constraint_expression

2004-11-16  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_internal.h, rasqal/rasqal_engine.c:
	pattern_graph to graph_pattern

	* rasqal/rasqal_engine.c (rasqal_engine_get_next_result):
	Inner loop logic tidying.

	* rasqal/rasqal_engine.c (rasqal_engine_get_next_result):
	triples_size deleted, never used.

	* rasqal/rasqal_engine.c: source re-ordering

	* rasqal/rasqal_engine.c (rasqal_engine_prepare): set flags here.
	(rasqal_engine_execute_init): Always init a new pattern_graph.

	* rasqal/rasqal_engine.c (rasqal_engine_execute_init,
	rasqal_engine_run): Remove remaining use of query->column field.

	* rasqal/rasqal_internal.h: rasqal_query remove column field

	* rasqal/rasqal.h: words

	* rasqal/rasqal_engine.c:
	(rasqal_engine_execute_init); Added pattern_graph field, using
	rasqal_new_pattern_graph
	(rasqal_engine_execute_finish): Tidy up, deleting pattern_graph.
	(rasqal_graph_pattern_get_next_triple): Renamed from
	rasqal_engine_get_next_triple_pattern_result and using
	rasqal_pattern_graph argument.
	(rasqal_new_pattern_graph): tidy.
	(rasqal_free_pattern_graph): Delete the triple_meta array.
	(rasqal_engine_get_next_result): Use
	rasqal_graph_pattern_get_next_triple and evaluate the constraints
	here.

	* rasqal/rasqal_internal.h: rasqal_query rename to pattern_graph field

	* rasqal/rasqal_internal.h: rasqal_pattern_graph add column
	Remove rasqal_triple_meta field from rasqal_query
	and add graph_pattern field

	* rasqal/rasqal_internal.h: Update rasqal_new_pattern_graph prototype.

	* rasqal/rasqal_expr.c: Replace calloc() with RASQAL_CALLOC(type,...)

	* rasqal/rasqal_internal.h: Added rasqal_pattern_flags enum.
	Added rasqal_pattern_graph
	Added rasqal_new_pattern_graph, rasqal_free_pattern_graph prototypes.

	* rasqal/rasqal_engine.c (rasqal_new_pattern_graph,
	rasqal_free_pattern_graph): Added.

	* rasqal/rasqal_engine.c (rasqal_engine_get_next_triple_pattern_result):
	Added, split
	off from rasqal_engine_get_next_result.

	* rasqal/sparql_parser.y (rasqal_sparql_query_engine_prepare):
	Call rasqal_engine_prepare.

	* rasqal/rdql_parser.y (rasqal_rdql_query_engine_prepare):
	Call rasqal_engine_prepare.

	* rasqal/rasqal_engine.c (rasqal_engine_prepare):
	Added, split some bits from
	rasqal_engine_execute_init that were just query preparation, rather
	than execution.

	* rasqal/rasqal_internal.h: Added rasqal_engine_prepare prototype

2004-11-12  Dave Beckett <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_parser.y (PatternElementForms):
	Set triple optional flags.

	* rasqal/rasqal_expr.c: Added rasqal_triple_flag_strings consts
	(rasqal_triple_print): Use rasqal_triple_flag_strings to print flags
	out.

	* rasqal/roqet.c: Cast for c++

	* rasqal/rasqal_engine.c (rasqal_engine_execute_init): Set triple flags
	RASQAL_TRIPLE_FLAGS_EXACT rather than triple meta is_exact.
	(rasqal_engine_get_next_result): Use triple flags
	RASQAL_TRIPLE_FLAGS_EXACT rather than using triple meta is_exact.

	* rasqal/rasqal_expr.c (rasqal_triple_set_flags,
	rasqal_triple_get_flags): Added

	* rasqal/rasqal.h: Added enum rasqal_triple_flags
	Added flags field to rasqal_triple.
	Added prototypes for rasqal_triple_set_flags and
	rasqal_triple_get_flags

	* raptor/rapper.1: Updated -f for serializer features

2004-11-11  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_parser.y (GraphPattern):
	Only join non-empty PatternElement
	(PatternElement.1): Return something.
	(PatternElementForms): Return NULL for AND Expression part.

2004-11-10  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_parser.y (rasqal_init_query_engine_sparql):
	URL now http://www.w3.org/TR/rdf-sparql-query/

	* rasqal/sparql_parser.y (rasqal_init_query_engine_sparql): No alias.

	* rasqal/sparql_parser.y: typo

	* rasqal/rdql_lexer.l, rasqal/rdql_parser.y,
	rasqal/sparql_lexer.l, rasqal/sparql_parser.y: Rename terminals:
	PLUS MINUS STAR SLASH REM TILDE BANG to be the single symbol they
	are.

	* rasqal/rdql_parser.y, rasqal/rdql_lexer.l:
	Rename terminals: COMMA LPAREN RPAREN VARPREFIX to be the single
	symbol they are.

	* rasqal/sparql_lexer.l:
	Rename terminals: COMMA LPAREN RPAREN LSQUARE RSQUARE LCURLY RCURLY
	VARPREFIX AMP to be the single symbol they are.

	* rasqal/sparql_parser.y: Enable YYERROR_VERBOSE for now
	Rename terminals: COMMA LPAREN RPAREN LSQUARE RSQUARE LCURLY RCURLY
	VARPREFIX AMP to be the single symbol they are.

	* rasqal/sparql_parser.y: Removed ()s for groups

	* rasqal/sparql_parser.y: Added {}s for groups

	* rasqal/tests/sparql/syntax/Makefile.am,
	rasqal/tests/sparql/syntax/groups.rq: Added groups.rq

	* librdf/rdf_serializer_raptor.c
	(librdf_serializer_raptor_set_namespace):
	raptor_serialize_set_namespace

	* utils/rdfproc.c: Init partial_statement, uri_string

	* librdf/rdf_serializer_raptor.c
	(librdf_serializer_raptor_set_namespace):
	raptor_serialize_set_namespace, typo

	* utils/rdfproc.c: Init partial_statement, uri_string

	* configure.ac: Need raptor 1.4.3 and rasqal 0.9.5

	* raptor/raptor_sequence.c (raptor_sequence_join):
	Copy pointers correctly

	* rasqal/rdql_parser.y (ConstraintClause): Don't add constraint
	sequence here.
	(CommaAndConstraintClause): Instead, add constraints here.

	* rasqal/sparql_parser.y (GraphPattern): Use raptor_sequence_join

	* rasqal/rdql_parser.y (Query): Don't set contraints here.
	(ConstraintClause): Use rasqal_query_add_constraint.

	* rasqal/configure.ac: require raptor 1.4.3

	* raptor/raptor_sequence.c (raptor_sequence_join):
	Added, to move all items between two
	sequences leaving one empty.

	* raptor/raptor.h: Added raptor_sequence_join

	* librdf/rdf_serializer.c (librdf_serializer_set_namespace):
	Note may not be implemented.

	* librdf/rdf_query_results.c (librdf_query_results_as_stream):
	Docs, note implemented.

	* librdf/rdf_serializer_raptor.c
	(librdf_serializer_raptor_get_feature,
	librdf_serializer_raptor_set_feature): Added to use new serializer
	features.
	(librdf_serializer_raptor_set_namespace): Added calling
	raptor_serializer_set_namespace which should work sometime.

	* raptor/raptor.h: Added raptor_serialize_set_namespace

	* raptor/raptor_serialize.c (raptor_serialize_set_namespace):
	Added, not implemented.

	* librdf/rdf_query_results.c (librdf_free_query_results): Add docs.

	* raptor/raptor_rss.c (raptor_rss_parse_recognise_syntax):
	Boost in recognising xml rss

	* rasqal/rasqal.h, librdf/redland.h, librdf/rdf_utf8.h,
	librdf/rdf_node.h, librdf/rdf_model.h, librdf/rdf_list.h,
	librdf/librdf.h: Applied patch from René Puls to allow for Redland
	public headers to be in a different directory structure. If
	LIBRDF_OBJC_FRAMEWORK is defined, the headers are in a Redland
	subdirectory.  Only applies to public Redland header files that
	#include other public header files.  rasqal.h includes raptor.h so
	needs modifying also.

	* librdf/rdf_storage_mysql.c, librdf/rdf_storage_hashes.c,
	librdf/rdf_storage_file.c: Changed sync methods to return an int
	status.

	* librdf/rdf_storage.c (librdf_storage_sync): Changed to return an
	int.  API change but most C won't care much.

	* librdf/rdf_storage.h: sync factory method returns a status int
	API CHANGE: librdf_storage_sync returns an int

	* librdf/rdf_model_storage.c (librdf_model_storage_sync):
	Changed to return an int.

	* librdf/rdf_model.c (librdf_model_sync):
	Changed to return an int.  API change but most C won't care much.

	* librdf/rdf_model.h: sync factory method returns a status int
	API CHANGE: librdf_model_sync returns an int

2004-11-09  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* Redland.i: Add base_uri argumemt to librdf_new_query

	* utils/rdfproc.c: Add NULL base_URI arg to librdf_new_query calls.

	* librdf/rdf_query_triples.c (librdf_query_triples_init):
	Add new base_uri argument, not used.

	* librdf/rdf_query_rasqal.c (librdf_query_rasqal_init): Use new
	base_uri argument and store that, not language URI.

	* librdf/rdf_query.h:
	Update query factory init method to add base_uri argument.
	API CHANGE: Add base_uri argument to librdf_new_query and
	librdf_new_query_from_factory

	* librdf/rdf_query.c (librdf_new_query, librdf_new_query_from_factory):
	Add optional base_uri argument.  Stop overloading query language
	identifier URI and base URI.
	(main): Update test to match.

	* librdf/rdf_query.c (librdf_get_query_factory):
	librdf_uri_equals test was negated

2004-11-08  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage_mysql.c (librdf_storage_mysql_init): Return
	failure early if connection failed.

	* raptor/rdfdump.c: allow -f to set serializer features

	* raptor/raptor_feature.c (raptor_features_enumerate_common): return -1

2004-11-07  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_uri.c (raptor_uri_path_make_relative_path):
	C style, indenting, const unsigned char.  Remove a small memcpy.
	(raptor_uri_to_relative_counted_uri_string) C style, indentng, docs.
	Remove a large if {} block.  Rename 'reference' var since libxml2
	defines it (SEP).  Use buildresult to make empty string result.

	* raptor/raptor_serialize.c (raptor_rdfxml_serialize_statement):
	use feature feature_relative_uris to decide when to emit an
	absolute or relative URI, the latter using
	raptor_uri_to_relative_uri_string.

	* raptor/raptor_uri.c:
	Added raptor relative URI generating code patch from René Puls
	(raptor_uri_path_common_base_length): Added. Helper to return the
	common base length of two paths
	(raptor_uri_path_make_relative_path): Added. Helper to build the
	result relative URI string from already analysed parts.
	(raptor_uri_to_relative_counted_uri_string): Added. Get the relative
	URI string between a base and reference URI.
	(raptor_uri_to_relative_uri_string): Added.  Wrapper about the above.
	(assert_uri_to_relative): Added.  Helper for tests for above.
	(main): Added relative URI string generation tests.

	* raptor/raptor.h:
	Added prototypes for raptor_uri_to_relative_counted_uri_string and
	raptor_uri_to_relative_uri_string

	* librdf/rdf_storage_mysql.c
	(librdf_storage_mysql_find_statements_with_options): Ensure
	subject, predicate and object are initialised.

	* librdf/rdf_query_triples.c (librdf_query_triples_init):
	Ensure subject, predicate are
	initialised.  Free them only if they are set.

	* librdf/rdf_node.c (librdf_node_to_counted_string): Init
	datatype_uri_string, language_len.

	* raptor/raptor_rss.c (raptor_rss_parser_processNode): Add cast
	for name when returned from xmlTextReaderConstLocalName.

	* raptor/raptor_rss.c (raptor_rss_parser_processNode):
	Always declare name as xmlChar*

2004-11-06  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/rdfdump.c: Tidy help messages about features, other words.

	* raptor/raptor_parse.c (raptor_feature_from_uri):
	Moved to raptor_feature.c

	* raptor/raptor.h:
	Moved raptor_feature_from_uri to separate section, not just parsers

	* raptor/raptor_internal.h: Deleted raptor_feature_from_uri_common

	* raptor/raptor_feature.c (raptor_feature_from_uri):
	Defined here, no need for
	raptor_feature_from_uri_common

	* raptor/rdfdump.c:
	In feature help code, list parser and serializer features
	separately, using new raptor_features_enumerate.

	* raptor/raptor_serialize.c (raptor_serializer_features_enumerate):
	Added, a wrapper around
	raptor_features_enumerate_common.
	(raptor_serializer_set_feature): Added.
	(raptor_serializer_get_feature): Added.

	* raptor/raptor_parse.c: Moved raptor_features_list to raptor_feature.c
	(raptor_features_enumerate): Changed to be a wrapper around
	raptor_features_enumerate_common now containing the body of the code.
	(raptor_feature_from_uri): Changed to be a wraper around
	raptor_feature_from_uri_common now containing the body of the code.

	* raptor/raptor_internal.h:
	Added feature_relative_uris for raptor_serializer.
	Added prototypes for raptor_features_enumerate_common and
	raptor_feature_from_uri_common

	* raptor/raptor.h: Added RAPTOR_FEATURE_RELATIVE_URIS for serializing.
	Added prototypes for raptor_serializer_features_enumerate,
	raptor_serializer_set_feature and raptor_serializer_get_feature

	* raptor/Makefile.am: Added raptor_feature.c

	* raptor/raptor_feature.c:
	Moved common raptor_feature code from raptor_parse.c

	* raptor/raptor_rss.c:
	Added <none> entry to raptor_rss_fields_info so that when indexed
	with RAPTOR_RSS_FIELDS_NONE, does not access invalid data.
	Fixes for xmlReader API for older libxml2s:
	Added node type defines for <2.5.9
	Use xmlTextReaderLocalName, xmlTextReaderNamespaceUri instead of the
	Const versions with additional corresponding xmlFree()s for <2.6.0

2004-11-02  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_raptor.c (ordinal_as_uri): Utterly broken

	* rasqal/tests/sparql/check-sparql (run_test):
	Take array of data files and use them to invoke roqet
	Tidy some rapper invoking.
	Add more debug messages.

	* rasqal/sparql_parser.y (GraphPattern):
	Merge the two sequences to make one sequence of triples.
	(PatternElement): Pass on PatternElementForms sequence
	(GraphPattern1:) Make a new triple sequence and pass on
	PatternElementForms.

	* rasqal/roqet.c (main): Add sources before prepare.

	* rasqal/roqet.c (main):
	Form a list of files/source URIs to add using a
	raptor_sequence and add them once the query is created.

	* librdf/win32_rdf_config.h, configure.ac: Bumped version to
	0.9.20

	* rasqal/configure.ac, rasqal/win32_rasqal_config.h: Bumped
	version to 0.9.5

2004-11-01  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/configure.ac, raptor/win32_raptor_config.h: Bumped
	version to 1.4.3

	* Snapshotted redland_0_9_19 for 0.9.19 release

	* LICENSE-2.0.txt, LICENSE.html, MPL.html, Makefile.am, NOTICE,
	README.html, TODO.html, librdf/redland.spec.in: LGPL / Apache 2.0
	license - remove MPL MPL.html add Apache2 LICENSE-2.0.txt NOTICE

	* Switched to LGPL / Apache 2.0 license in the sources
	CVS tags before: redland_license_lgpl_mpl,
	and after: redland_license_lgpl_apache2

	* rasqal/configure.ac, configure.ac: Need raptor 1.4.2

	* raptor/win32_raptor_config.h, raptor/configure.ac: Bumped
	version to 1.4.2

	* raptor/raptor_xml_writer.c (raptor_xml_writer_cdata):
	Return when raptor_xml_escape_string fails.

	* raptor/raptor_xml.c (raptor_xml_escape_string):
	Return -1 on UTF-8 encoding failure

	* raptor/raptor_xml.c: docs

	* utils/rdfproc.c (log_handler):
	Check level against fatal, not facility.

	* librdf/rdf_serializer_raptor.c, librdf/rdf_serializer.c,
	librdf/rdf_query_rasqal.c, librdf/rdf_query.c,
	librdf/rdf_parser.c, librdf/rdf_model.c, librdf/rdf_init.c: Casts
	for C++

2004-10-29  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/configure.ac: Minimum raptor 1.4.1

	* rasqal/rasqal_raptor.c (ordinal_as_uri): Helper, added to
	Properly calculate uri_string from rdf:_n ordinals
	(raptor_statement_as_rasqal_triple): Use above for subject,
	predicate, object

	* rasqal/rasqal_expr.c (rasqal_free_triple):
	Handle a partially constructed triple.

2004-10-28  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_xml.c (raptor_xml_escape_string): Ensure an empty
	string is copied out; write a NUL.

	* rasqal/sparql_parser.y, rasqal/rdql_parser.y,
	rasqal/rasqal_query_test.c: Casts for C++

	* raptor/libraptor.3: int return on raptor_xml_escape_string in body

	* raptor/libraptor.3: 1.4.1 raptor_xml_escape_string return value
	now int, <0 on failure.

	* raptor/raptor_xml_writer.c (raptor_xml_writer_cdata):
	Use int for raptor_xml_escape_string
	return variables and use error return <0

	* raptor/raptor_serialize.c:
	(raptor_rdfxml_serialize_write_xml_attribute,
	raptor_rdfxml_serialize_statement) Use int for
	raptor_xml_escape_string return variables.  Handle empty string
	attribute when len=0.

	* raptor/raptor_sax2.c (raptor_format_sax2_element):
	Use int for raptor_xml_escape_string return.

	* raptor/raptor.h: raptor_xml_escape_string changed return value to int

	* raptor/raptor_xml.c (raptor_xml_escape_string):
	Return value now int, <0 on failure to
	allow escaping an empty string to return 0 bytes required.
	(main): Add empty string escaping test.  Check for failure of first
	raptor_xml_escape_string call.

	* raptor/raptor_rss.c (raptor_rss_parser_processNode):
	Fix url attribute failing for
	non-enclosure.

	* rasqal/tests/sparql/check-sparql: Use PATH to find programs.
	(run-test): More debug messages
	Add -s $srcdir arg to find manifest

	* rasqal/tests/sparql/syntax/Makefile.am,
	rasqal/tests/sparql/simple/Makefile.am,
	rasqal/tests/sparql/part1/Makefile.am,
	rasqal/tests/sparql/examples/Makefile.am: Invoke check-sparql with
	PATH set and -s $(srcdir) arg

	* rasqal/tests/sparql/simple/manifest.n3,
	rasqal/tests/sparql/part1/manifest.n3: Update to latest DAWG
	tests, no file:

	* rasqal/sparql_lexer.l, rasqal/rdql_lexer.l:
	Remove YY_INPUT since it never worked.
	(main): Read query string into a buffer and use *_lexer__scan_buffer

	* rasqal/sparql_parser.y (main):
	Use full rasqal_init/finish sequence since setup and cleanup
	is rather complex now.

2004-10-27  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_parser.y (sparql_parse):
	Added workaround to crash when regex is at very end
	of input, by appending a space to the parsed query string.

	* rasqal/rdql_parser.y (rdql_parse):
	Added workaround to crash when regex is at very end of
	input, by appending a space to the parsed query string.

	* raptor/raptor_rfc2396.c (raptor_new_uri_detail):
	Do not add schema_len twice to dest pointer;
	stop buffer overrun

	* rasqal/tests/sparql/check-sparql,
	rasqal/tests/rdql/testsuite/check-rdql: OK to assume raptor 1.4.0

	* rasqal/roqet.1: updated RDQL URL

	* rasqal/tests/sparql/syntax/data.n3: skeleton data file

	* rasqal/tests/sparql/syntax/Makefile.am: Added check-bad-sparql rule
	Added nojam.rq bad test

	* rasqal/tests/sparql/syntax/nojam.rq: failure with ? and non var

	* rasqal/rdql_lexer.l:
	Restore ID state which is used to allow things like ?select.
	However, make sure ID state is left on errors.

	* rasqal/sparql_lexer.l:
	In <ID> state with unknown token, return to INITIAL and report the
	error.

	* rasqal/rdql_lexer.l:
	Remove ID state - not used and jams parser with non-matched chars in
	<ID> state.

	* rasqal/tests/sparql/Makefile.am: Added syntax dir

	* rasqal/sparql_parser.y (VarOrURIList):
	Fix calls to rasqal_new_variable_literal.

	* rasqal/configure.ac: Added dir tests/sparql/syntax

	* rasqal/tests/sparql/syntax/Makefile.am,
	rasqal/tests/sparql/syntax/describe1.rq: syntax tests for SPARQL

	* rasqal/tests/sparql/examples/Makefile.am: Remove check-sparql-works

	* rasqal/tests/rdql/testsuite/Makefile.am: Remove check-rdql-works

	* rasqal/rasqal_internal.h:
	Note that describe is a sequence of rasqal_literal*

	* rasqal/sparql_parser.y (VarOrURIList):
	Build a list of rasqal_literal*

2004-10-26  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/roqet.c: fix file reading

	* rasqal/roqet.c: Tidy up after failure to get query document

	* rasqal/rasqal_raptor.c (rasqal_raptor_error_handler):
	Added to pass on raptor parser errors
	to rasqal, and onwards.
	(rasqal_raptor_new_triples_source): On failure to parser, abort and
	tidy up.

	* raptor/raptor_locator.c (raptor_format_locator):
	Only print line if > 0

	* rasqal/rasqal_query.c (rasqal_free_query):
	Tidy up any half-constructed rasqal_expression
	sequence when query parsing/execution fails.

	* rasqal/sparql_lexer.l (sparql_token_free):
	Free raptor_uri objects in URI_LITERAL.  Debug function.

	* rasqal/rdql_lexer.l (rdql_token_free):
	Free raptor_uri objects in URI_LITERAL.  Debug function.

	* rasqal/rdql_parser.y (main):
	Use full rasqal_init/finish sequence since setup and cleanup
	is rather complex now.

	* rasqal/rasqal_engine.c (rasqal_new_triples_source):
	Do not abort when no explict list of
	sources are given.

	* rasqal/sparql_lexer.l: More renames

	* rasqal/rdql_lexer.l:
	Rename static functions to have rdql_ prefix to aid setting
	breakpoints in debugging.
	(<PATTERN>.): Only return PATTERN_LITERAL if rdql_copy_regex_token worked.
	(rdql_copy_regex_token): Report EOF in regex rather than continue.
	(rdql_copy_string_token): Fix debug message parameters.

	* rasqal/sparql_lexer.l:
	Rename static functions to have sparql_ prefix to aid setting
	breakpoints in debugging.
	(<PATTERN>.): Only return PATTERN_LITERAL if sparql_copy_regex_token
	worked.
	(sparql_copy_regex_token): Report EOF in regex rather than continue.

	* rasqal/rasqal-config.1: zap ASCII 160

	* rasqal/rasqal-config.1, raptor/raptor-config.1:
	Fix --libtool-libs desc

2004-10-25  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_query_rasqal.c (librdf_query_rasqal_execute):
	Fix for rasqal bug in
	rasqal_new_triples_source that refuses to run if query->sources is
	NULL.  Remove this when rasqal 0.9.4 is out.

	* rasqal/win32_rasqal_config.h, rasqal/configure.ac:
	Bumped version to 0.9.4

	* rasqal/configure.ac: Use AC_TRY_LINK correctly for regcomp test.

	* rasqal/configure.ac:
	Use AC_TRY_LINK for regcomp test; no need to run it.

	* rasqal/roqet.c: Many casts for c++
	(roqet_xml_print_xml_attribute, roqet_query_results_print_as_xml):
	Use type raptor_simple_message_handler for error callbacks.

	* rasqal/rasqal_expr.c: Casts for C++

	* rasqal/rasqal_expr.c (rasqal_prefix_print): Handle NULL prefix

	* rasqal/configure.ac:
	Do a 'return 0' after regcomp check to ensure the program exits ok

	* rasqal/tests/rdql/testsuite/check-rdql: Handle empty list of vars

	* rasqal/Makefile.am:
	Execute rasqal_query_test specially, passing in full path to
	$(srcdir)/data/dc.rdf

	* rasqal/rasqal_query_test.c:
	Pass in data file as an argument and allocate the query string with
	path to the file burnt in.

	* rasqal/roqet.c:
	(roqet_xml_print_xml_attribute, roqet_query_results_print_as_xml):
	Move experimental XML output code here.

	* rasqal/Makefile.am: Remove rasqal_xml.c from library for now.

	* rasqal/rasqal.h:
	Remove rasqal_query_results_print_as_xml from pre-release public API

	* rasqal/sparql_parser.y (FromClauseOpt):
	Store the list of sources got from URIList
	(URIList): Use rasqal_literal_as_uri to make a list of raptor_uri*
	from individual rasqal_literal* made by term URI.

	* rasqal/rasqal_literal.c (rasqal_literal_as_uri):
	Added for getting a URI out of a literal.

	* rasqal/rasqal_internal.h: Added rasqal_literal_as_uri

	* rasqal/sparql_parser.y (sparql_query_error_full):
	Added, allowing varags.
	(Literal, URI): Use above to report failure to expand qnames
	immediately.

	* rasqal/sparql_parser.y (Literal, URI):
	Invoke rasqal_literal_expand_qname when handling a
	QNAME_LITERAL, RASQAL_LITERAL_QNAME.
	(sparql_parse): Check for unexpanded QNames.  SPARQL does the
	expansion in order, so do not invoke expansions here.

	* rasqal/rasqal_literal.c (rasqal_literal_has_qname):
	Added, for checking when a QName is
	leftover.

	* rasqal/rasqal_internal.h: Added rasqal_engine_sequence_has_qname,
	rasqal_engine_constraints_has_qname, rasqal_literal_has_qname,
	rasqal_expression_has_qname

	* rasqal/rasqal_expr.c (rasqal_expression_has_qname):
	Added for use with
	rasqal_expression_foreach to check for a leftover QName.

	* rasqal/rasqal_engine.c (rasqal_engine_sequence_has_qname,
	rasqal_engine_constraints_has_qname): Added, for checking when a
	QName is leftover.

	* rasqal/roqet.c: Set the raptor_www error_handler

	* rasqal/rasqal.h: Added rasqal_prefix depth field.

	* rasqal/rasqal_engine.c (rasqal_engine_declare_prefix):
	Use query->prefix_depth and increment

	* rasqal/rasqal_query.c (rasqal_query_add_prefix):
	Undeclare older prefixes with the same prefix.

	* rasqal/rasqal_internal.h: Added prefix_depth to rasqal_query_s
	Added rasqal_engine_undeclare_prefix prototype

2004-10-24  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/examples/Makefile.am: Added missing ex-24a files

	* rasqal/roqet.c (main):
	C99 fix - Move FILE*fh declaration to start of block.

	* rasqal/librasqal.3: Updates for 0.9.3

	* librdf/rdf_query.c (librdf_query_register_factory):
	Take a uri_string argument.

	* librdf/rdf_query.h:
	Modify librdf_query_register_factory to take a uri_string

	* utils/rdfproc.c:
	Allow query command to give '-' for default query language name.

	* librdf/rdf_query_rasqal.c (librdf_query_rasqal_constructor):
	Use rasqal_languages_enumerate to
	register all languages that rasqal has.

	* rasqal/roqet.c (main):
	Use raptor_www_fetch_to_string from raptor 1.4.0

	* raptor/win32_raptor_config.h, raptor/configure.ac: Bumped
	version to 1.4.1

	* raptor/libraptor.3: typo

	* raptor/raptor_rss.c: Added generation of triples for RSS
	enclosures based on a patch from Suzan Foster.  Changes made
	include correcting the enclosures namespace, tidying some memory
	leaks and printing some debug information.

	* raptor/raptor_serialize.c (raptor_rdfxml_serialize_statement):
	Make rdf:_<n> 'ordinal' properties serialize correctly.

	* raptor/raptor_www_test.c (main):
	Use raptor_www_fetch_to_string for testing.

	* raptor/raptor_iostream.c (raptor_string_iostream_finish): Code tidy.

	* raptor/libraptor.3, raptor/raptor.h: Added
	raptor_www_fetch_to_string

	* raptor/raptor_www.c (raptor_www_fetch_to_string_write_bytes):
	Added handler for following function:
	(raptor_www_fetch_to_string): Added, to get content back as a string.

	* rasqal/roqet.c:
	(roqet_get_www_content); Use raptor_stringbuffer_copy_to_string.

	* rasqal/configure.ac: enable sparql for regular users

2004-10-23  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/libraptor.3: Updates for 1.4.0

	* raptor/raptor.h, raptor/raptor_iostream.c: s/fh/handle/ for clarity.

	* rasqal/configure.ac, rasqal/Makefile.am: Added rasqal.rdf.in

	* rasqal/rasqal.rdf.in: Rasqal DOAP description

	* raptor/raptor.spec.in:
	Update descriptions to include serializers

2004-10-21  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/Makefile.am, rasqal/rasqal.spec.in,
	rasqal/LICENSE-2.0.txt, NOTICE: LGPL / Apache 2.0 license

	* rasqal/tests/sparql/simple/Makefile.am, rasqal/docs/build-docs,
	rasqal/tests/Makefile.am, rasqal/tests/rdql/Makefile.am,
	rasqal/tests/rdql/testsuite/Makefile.am,
	rasqal/tests/rdql/testsuite/check-rdql,
	rasqal/tests/sparql/Makefile.am, rasqal/tests/sparql/check-sparql,
	rasqal/tests/sparql/examples/Makefile.am,
	rasqal/tests/sparql/part1/Makefile.am, rasqal/docs/Makefile.am,
	rasqal/sparql_parser.y, rasqal/win32_rasqal_config.h,
	rasqal/rdql_parser.y, rasqal/roqet.c, rasqal/sparql_common.h,
	rasqal/sparql_lexer.l, rasqal/Makefile.am, rasqal/configure.ac,
	rasqal/rasqal-config.in, rasqal/rasqal-src-config.in,
	rasqal/rasqal.h, rasqal/rasqal.spec.in, rasqal/rasqal_engine.c,
	rasqal/rasqal_expr.c, rasqal/rasqal_general.c,
	rasqal/rasqal_internal.h, rasqal/rasqal_literal.c,
	rasqal/rasqal_query.c, rasqal/rasqal_query_test.c,
	rasqal/rasqal_raptor.c, rasqal/rasqal_redland.c,
	rasqal/rasqal_xml.c, rasqal/rdql_common.h, rasqal/rdql_lexer.l:
	LGPL / Apache 2.0 license

	* rasqal/win32/rasqal.dsp, rasqal/win32/rasqal.dsw:
	win32 updates including sparql (not tested)

	* librdf/rdf_parser_raptor.c
	(librdf_parser_raptor_new_statement_handler): Do not copy datatype
	URIs for new statements.

	* raptor/raptor_namespace.c: less namespace debugs

	* raptor/raptor_xml_writer.c: less cdata debugs

	* raptor/raptor_namespace.c: Make most namespace debug messages
	appear only if #ifdef RAPTOR_DEBUG_VERBOSE

	* raptor/raptor_rdfxml.c:
	Make most rdf/xml parsing debug messages appear only if
	#ifdef RAPTOR_DEBUG_VERBOSE

	* librdf/rdf_serializer.c
	(librdf_serializer_serialize_model_to_counted_string,
	librdf_serializer_serialize_model_to_string): Do not require a
	base_uri.

	* examples/example6.c:
	Redland example code using model methods load and to_string

	* librdf/rdf_serializer_raptor.c
	(librdf_serializer_raptor_serialize_statement): Convert statement
	object URI correctly.
	(librdf_serializer_raptor_serialize_model_to_counted_string): Zap
	string, string_length before starting.

	* raptor/raptor_serialize.c:
	(raptor_serialize_start, raptor_serialize_start_to_filename,
	raptor_serialize_start_to_string,
	raptor_serialize_start_to_file_handle,
	raptor_serialize_statement, raptor_serialize_end):
	Fail if no iostream is made or available.

	* raptor/raptor_iostream.c (raptor_new_iostream_to_string):
	Docs, zap string and length before
	starting.

	* examples/Makefile.am: Added example6.c

	* raptor/raptor_serialize.c (raptor_rdfxml_serialize_statement):
	Print datatype URIs correctly.

2004-10-20  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_query_rasqal.c:
	Update redland support to rasqal changes after addition of origin.

	* rasqal/rasqal_redland.c (rasqal_redland_bind_match):
	Take array of 4 bindings.

	* rasqal/rasqal_redland.c:
	Update redland support to changes after addition of origin.

	* rasqal/rasqal_general.c:
	Added rasqal_initialising and rasqal_finishing statics
	(rasqal_init, rasqal_finish): Use the above to prevent
	recursion in these methods when rasqal uses redland using rasqal.

	* rasqal/configure.ac:
	use $srcdir not .. when looking for raptor sources nearby

	* configure.ac: rasqal minimum version 0.9.3

	* raptor/configure.ac, raptor/win32_raptor_config.h: 1.4.0

	* configure.ac, rasqal/configure.ac: raptor minimum version 1.4.0

	* rasqal/roqet.c: cast for fprintf

	* librdf/rdf_model.h:
	Change librdf_model_to_counted_string and librdf_model_to_string to
	return unsigned char*

	* librdf/rdf_model.c
	(librdf_model_to_counted_string,librdf_model_to_string): Return
	unsigned char*

	* Redland.i: Added librdf_serializer_serialize_model_to_string

	* Redland.i: Added librdf_model_to_string

	* librdf/rdf_model.c (librdf_model_to_counted_string,
	librdf_model_to_string): Added.
	(main): Added test for above.

	* librdf/rdf_model.h:
	Added librdf_model_to_counted_string, librdf_model_to_string

	* librdf/rdf_serializer_raptor.c:
	Added errors, warnings counting in context.
	(librdf_serializer_raptor_error_handler,
	librdf_serializer_raptor_warning_handler): Added, called by raptor
	serializing code.
	(librdf_serializer_raptor_serialize_model_to_file_handle): Link to
	error, warning handlers above.
	(librdf_serializer_raptor_serialize_model_to_counted_string): Added.
	(librdf_serializer_raptor_register_factory): Update for new factory
	method names.

	* librdf/rdf_serializer.c
	(librdf_serializer_serialize_model_to_counted_string): Added to
	return string length.
	(main): Test serialize to string.

	* librdf/rdf_serializer.h:
	Rename factory method to serialize_model_to_counted_string
	Added librdf_serializer_serialize_model_to_counted_string

	* librdf/rdf_serializer.c (main):
	rdf/xml bad predicate URI is now an error

	* raptor/raptor_internal.h:
	Added warning_user_data, warning_handler to serializer
	Added prototypes for raptor_serializer_warning and
	raptor_serializer_warning_varargs

	* raptor/raptor_serialize.c (raptor_serializer_warning,
	raptor_serializer_warning_varargs): Added
	(raptor_serializer_set_warning_handler): Added

	* raptor/raptor.h: Added raptor_serializer_set_warning_handler

	* librdf/rdf_serializer.c (main):
	Use librdf_serializer_serialize_model_to_file_handle

	* raptor/configure.ac, rasqal/configure.ac, configure.ac: autoconf mode

	* raptor/rdfdump.c: default serializer simple

	* utils/rdfproc.c: allow base URI to serialize command

	* librdf/rdf_serializer_rdfxml.c: Deleted. raptor does all this now

	* librdf/Makefile.am: Remove rdf_serializer_rdfxml.c

	* librdf/rdf_serializer.h:
	Renamed factory method serialize_model to
	serialize_model_to_file_handle.
	Added factory method serialize_model_to_string.
	Deprecated librdf_serializer_serialize_model
	Added librdf_serializer_serialize_model_to_file_handle as new name
	Added librdf_serializer_serialize_model_to_string

	* librdf/rdf_serializer.c (librdf_serializer_serialize_model):
	Deprecate name.
	(librdf_serializer_serialize_model_to_file_handle): Added, new name
	for above.
	(librdf_serializer_serialize_model_to_string): Added.
	(librdf_init_serializer): Let raptor make all

	* librdf/rdf_storage_file.c (librdf_storage_file_sync): Use
	librdf_serializer_serialize_model_to_file_handle not deprecated
	librdf_serializer_serialize_model

	* librdf/rdf_serializer_raptor.c: Converted to use raptor_serializer.
	(librdf_serializer_raptor_serialize_model_to_file_handle): Renamed
	from librdf_serializer_raptor_serialize_model.
	(librdf_serializer_raptor_serialize_model_to_string): Added.
	(librdf_serializer_raptor_constructor): Register from raptor's
	enumeration of serializers.

	* raptor/raptor_serialize.c (raptor_rdfxml_serialize_statement):
	Handle URI subject, object right.

	* raptor/raptor_serialize.c (raptor_serialize_start_to_filename,
	raptor_serialize_start_to_string,
	raptor_serialize_start_to_file_handle): Don't enforce base URI is
	required.

2004-10-19  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor.h:
	Updated raptor_new_iostream_to_string with malloc_handler argument

	* raptor/raptor_serialize.c (raptor_serialize_start_to_string): Update
	raptor_new_iostream_to_string for malloc_handler argument

	* raptor/raptor_iostream.c (raptor_string_iostream_finish):
	Use passed-in malloc_handler to
	make string, raptor_stringbuffer_copy_to_string to copy directly in.
	(raptor_new_iostream_to_string): Add optional malloc_handler argument
	so caller can control allocation.
	(main): Update tests for above.

	* raptor/raptor.h: Added raptor_stringbuffer_copy_to_string

	* raptor/raptor_stringbuffer.c (raptor_stringbuffer_copy_to_string):
	Added to allow exporting to
	externally alloced buffers - handy for cross-library/heap work.
	(main): Added test for above.

	* raptor/raptor_general.c (raptor_init): Don't register 'simple' type.

	* configure.ac: Raptor minimum version 1.3.4 for serializer

	* redland-src-config.in: pick up raptor libs for --libs

	* raptor/raptor_iostream.c, raptor/raptor_namespace.c,
	raptor/raptor_serialize.c, raptor/raptor_iostream.c: Casts for C++

	* raptor/tests/Makefile.am, raptor/tests/turtle/Makefile.am:
	Replace direct dependency on $(top_builddir)/rapper with build-rapper
	so re-compile check is forced before testing.

	* raptor/raptor.h, raptor/raptor_namespace.c,
	raptor/raptor_serialize.c: Fix a bunch of constitency typos in
	namespace URIs

	* raptor/raptor_internal.h:
	Add locator, error_user_data and error_handler to raptor_serializer.
	Add raptor_init_serializer_rdfxml, raptor_serializer_error,
	raptor_serializer_simple_error and raptor_serializer_error_varargs.

	* raptor/raptor_namespace.c:
	Export raptor_xml_namespace_uri, raptor_rdf_namespace_ms_uri,
	raptor_rdf_namespace_schema_uri,
	raptor_xmlschema_datatypes_namespace_uri, raptor_owl_namespace_uri,
	raptor_rdf_namespace_ms_uri_len

	* raptor/raptor_general.c (raptor_init):
	Call raptor_init_serializer_rdfxml

	* raptor/raptor.h:
	Export raptor_xml_namespace_uri, raptor_rdf_namespace_ms_uri,
	raptor_rdf_namespace_schema_uri,
	raptor_xmlschema_datatypes_namespace_uri, raptor_owl_namespace_uri,
	raptor_rdf_namespace_ms_uri_len
	Add raptor_serializer_set_error_handler,
	raptor_serializer_get_locator

	* raptor/raptor_serialize.c: Added RDF/XML serializer.
	Added locator to serializer.
	(raptor_serializer_error, raptor_serializer_simple_error,
	raptor_serializer_error_varargs): Added internal support for errors.
	(raptor_serializer_set_error_handler, raptor_serializer_get_locator):
	Added public methods

2004-10-18  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_iostream.c: (main) casts for fprintf

	* raptor/rdfdump.c:
	Remove ad-hoc serializing code and use raptor_serializer.
	Update help and usage messages to use raptor_serializers_enumerate

	* raptor/raptor_internal.h:
	Added raptor_serializer_factory and declarations for factories
	raptor_init_serializer_ntriples, raptor_init_serializer_simple and
	raptor_delete_serializer_factories

	* raptor/raptor_general.c (raptor_init):
	Call raptor_init_serializer_ntriples and
	raptor_init_serializer_simple

	* raptor/raptor.h: Added raptor_serializer class and methods:
	raptor_serializers_enumerate, raptor_serializer_syntax_name_check,
	raptor_new_serializer, raptor_free_serializer,
	raptor_serialize_start, raptor_serialize_start_to_filename,
	raptor_serialize_start_to_string,
	raptor_serialize_start_to_file_handle,
	raptor_serialize_statement, raptor_serialize_end,
	raptor_serializer_get_iostream.
	Added new raptor_iostream class constructor raptor_new_iostream_to_sink
	and methods: raptor_iostream_write_end, raptor_iostream_write_string,
	raptor_iostream_write_counted_string,
	raptor_iostream_get_bytes_written_count,
	raptor_iostream_write_decimal, raptor_iostream_format_hexadecimal

	* raptor/Makefile.am: Added raptor_serialize.c
	Added $(LIBS) to rfc2396 tests for -ldmalloc when present

	* raptor/raptor_serialize.c: Serializers

	* raptor/raptor_iostream.c (raptor_iostream_write_counted_string):
	Added as a wrapper.

	* raptor/raptor_iostream.c (raptor_iostream_format_hexadecimal):
	Added for writing
	field-formatted hex.

	* raptor/raptor_iostream.c (raptor_iostream_get_bytes_written_count):
	Renamed from raptor_get_bytes_written_count
	(raptor_iostream_write_decimal): Added to print a decimal to the
	iostream.

	* raptor/raptor_iostream.c (raptor_new_iostream_to_file_handle):
	Do not fclose at end.
	(raptor_string_iostream_finish): Free malloced context.
	(raptor_iostream_write_string): Helper to write C string.

	* raptor/raptor_iostream.c: Added sink iostream
	(raptor_sink_iostream_write_byte, raptor_sink_iostream_write_bytes):
	Added.
	(raptor_new_iostream_to_sink): Added to create a throwaway data
	iostream.
	(raptor_free_iostream): Ensure write_end is always called once only.
	(main): Test sink.

	* raptor/raptor_iostream.c:
	Added ended flag, once write_end is done, all further calls fail.
	(raptor_filename_iostream_finish): Removed; write_end does this.
	(raptor_filename_iostream_write_end): Added to fclose() on end
	(raptor_string_iostream_finish): More checks when stringbuffer is
	empty.
	(raptor_new_iostream_to_string): Handle error tidy up better.
	(raptor_iostream_write_end): Added.
	(main): Code tidy.

	* raptor/raptor_iostream.c: casts for c++

	* raptor/raptor.h: Added raptor_iostream class and methods.

	* raptor/Makefile.am: Added raptor_iostream.c and raptor_iostream_test

	* raptor/raptor_iostream.c: Raptor I/O stream class

	* raptor/n3_lexer.l, raptor/n3_parser.y, raptor/turtle_lexer.l,
	raptor/turtle_parser.y, rasqal/rdql_lexer.l, rasqal/rdql_parser.y,
	rasqal/sparql_lexer.l, rasqal/sparql_parser.y: Rename rather
	generic define ERROR to ERROR_TOKEN to help win32.

	* rasqal/rdql_lexer.l, rasqal/sparql_lexer.l: words

	* rasqal/rasqal_engine.c (rasqal_set_triples_source_factory):
	Export this, to match rasqal.h
	and add docs.

2004-10-17  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/roqet.c: Tidy some #defines
	(main): Don't print all of huge query_string on errors.

	* rasqal/roqet.1: formatting

2004-10-16  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/check-sparql:
	Destroy duff relative file: URIs only

	* rasqal/tests/sparql/check-sparql: validate $roqet path
	No Data::Dumper

	* rasqal/roqet.c: Remove extra print of query URI

	* rasqal/roqet.c (roqet_get_www_content): Remove goto

	* rasqal/roqet.1: Update for options changes.  Note SPARQL support.

	* raptor/rapper.1: die .UE

	* rasqal/roqet.c (roqet_error_handler): Added, used by www fetching.
	(roqet_get_www_write_bytes): Added, used by roqet_get_www_content
	(roqet_get_www_content): Added, creates a big string of a URI
	content using the raptor_www class routines to retrieve it
	and raptor_stringbuffer to assemble it.
	(main): Use roqet_get_www_content to retrieve queries from URIs.

	* rasqal/sparql_lexer.l, rasqal/sparql_parser.y:
	Deleted FOR and USING tokens

	* rasqal/sparql_parser.y: Remove PatternLiteral

	* rasqal/tests/sparql/examples/Makefile.am,
	rasqal/tests/sparql/examples/ex2-1a-result.n3,
	rasqal/tests/sparql/examples/ex2-1a.n3,
	rasqal/tests/sparql/examples/ex2-1a.rq,
	rasqal/tests/sparql/examples/ex2-1b.rq,
	rasqal/tests/sparql/examples/ex2-1c.rq,
	rasqal/tests/sparql/examples/ex2-1d.n3,
	rasqal/tests/sparql/examples/ex2-1e.rq,
	rasqal/tests/sparql/examples/ex2-1f.n3,
	rasqal/tests/sparql/examples/ex2-2a-result.n3,
	rasqal/tests/sparql/examples/ex2-2a.n3,
	rasqal/tests/sparql/examples/ex2-2a.rq,
	rasqal/tests/sparql/examples/ex2-3a-result.n3,
	rasqal/tests/sparql/examples/ex2-3a.n3,
	rasqal/tests/sparql/examples/ex2-3a.rq,
	rasqal/tests/sparql/examples/ex2-4a-result.n3,
	rasqal/tests/sparql/examples/ex2-4a.n3,
	rasqal/tests/sparql/examples/ex2-4a.rq,
	rasqal/tests/sparql/examples/ex3-result.n3,
	rasqal/tests/sparql/examples/ex3.n3,
	rasqal/tests/sparql/examples/ex3.rq,
	rasqal/tests/sparql/examples/manifest.n3: SPARQL examples from
	query WD

	* rasqal/tests/rdql/Makefile.am,
	rasqal/tests/rdql/testsuite/Makefile.am,
	rasqal/tests/sparql/Makefile.am,
	rasqal/tests/sparql/part1/Makefile.am,
	rasqal/tests/sparql/simple/Makefile.am: Use indirect rules for the
	lexer, parser tests for rdql, sparql and roqet

	* rasqal/configure.ac: Added tests/sparql/examples/Makefile

	* rasqal/sparql_parser.y:
	Added SPARQL URI token replacing URI_LITERAL | QNAME_LITERAL for
	clarity.
	Makes several List tokens shorter

	* rasqal/sparql_parser.y (VarOrURIList, VarList): Made left recursive.
	(VarOrURI): Don't allow a QName.

	* rasqal/rdql_parser.y (TriplePatternList): rewrite as left recursive

	* rasqal/rdql_parser.y (VarList): rewrite as left recursive

	* rasqal/roqet.c (main):
	When adding source_uri as a triple source, URI is now
	managed by the query, so drop the source_uri pointer.

2004-10-15  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_parser.y (PrefixDeclOpt):
	Actually use query->prefixes list.

	* rasqal/sparql_parser.y (PrefixDeclOpt):
	Add new prefix to existing prefixes list.
	(main): Update test code to initialise/free static query.prefixes.

	* rasqal/rdql_parser.y (Query): Do not initialise query->prefixes.
	(PrefixDeclList): Shift new prefixes to existing prefixes list.
	(main): Update test code to initialise/free static query.prefixes.

	* rasqal/rasqal_query.c (rasqal_new_query):
	Init query->prefixes here rather than in each QL
	implementation.

	* rasqal/sparql_parser.y: Remove prefix from %union - not needed

	* rasqal/rasqal_internal.h, rasqal/sparql_lexer.l,
	rasqal/sparql_parser.y: Updated SPARQL parser to approximately
	http://www.w3.org/TR/2004/WD-rdf-sparql-query-20041012/#grammar

	* librdf/rdf_serializer.c (main):
	Add serializer error and warning report tests

	* librdf/rdf_query_rasqal.c (librdf_query_rasqal_results_get_bindings):
	Casts for variable names array.

	* librdf/rdf_serializer_rdfxml.c
	(rdf_serializer_rdfxml_print_xml_attribute): Take serializer arg.
	Use librdf_log directly to give a better error message since
	raptor_xml_escape_string only dies on UTF-8 errors.
	(librdf_serializer_print_statement_as_rdfxml): Replcae
	librdf_serializer_warning with direct librdf_log call as above.

	* librdf/rdf_serializer.h:
	Deleted librdf_serializer_error and librdf_serializer_warning

	* librdf/rdf_serializer.c (librdf_serializer_error,
	librdf_serializer_warning): Deleted.

	* librdf/rdf_serializer_rdfxml.c
	(rdf_serializer_rdfxml_print_as_xml_content): Deleted and inlined.
	Use raptor_xml_escape_string to properly escape UTF-8.

	* librdf/rdf_serializer_rdfxml.c
	(rdf_serializer_rdfxml_print_xml_attribute): Add an error return
	value and pass on failures.
	librdf_serializer_print_statement_as_rdfxml): Add an error return
	value and pass on failures.  Try to slightly recover from errors.

	* librdf/rdf_serializer_rdfxml.c
	(librdf_serializer_rdfxml_serialize_model): Use raptor_free_memory.

	* raptor/raptor_xml.c (raptor_xml_escape_string):
	Call error_handler correctly.

2004-10-12  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/part1/Makefile.am:
	Use EXPECTED_SPARQL_CORRECT_FAILURES and count the list at run time

2004-10-10  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_parser.y, rasqal/sparql_lexer.l,
	rasqal/rdql_parser.y, rasqal/rdql_lexer.l,
	rasqal/rasqal_query_test.c, rasqal/rasqal_expr.c: Use
	rasqal_basename to make 'program' in test code messages.

	* rasqal/rasqal_engine.c (rasqal_engine_execute_finish):
	Do a terminating loop through columns.

	* rasqal/rasqal_internal.h: Added rasqal_basename prototype

	* rasqal/rasqal_general.c (rasqal_basename): Added utility function

	* rasqal/rasqal_query_test.c (main):
	Check prepares and multiple executes work.

	* rasqal/win32/rasqal.dsp: Rename parser, lexer files
	Add sparql

	* rasqal/win32_rasqal_config.h: Add RDQL and SPARQL defines

	* rasqal/rasqal_expr.c: Make all RASQAL_INLINE functions static.

	* rasqal/rasqal_expr.c: RASQAL_INLINE at start of line

2004-10-08  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_parser.y, rasqal/sparql_lexer.l,
	rasqal/sparql_common.h, rasqal/rasqal_internal.h,
	rasqal/rasqal_general.c, rasqal/Makefile.am: BRQL to SPARQL

2004-10-07  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* Redland.i: Export librdf_world_get_feature and
	librdf_world_set_feature

	* librdf/rdf_init.h: Update librdf_world_get_feature and
	librdf_world_set_feature to use librdf_node*

	* librdf/rdf_init.c (librdf_world_get_feature): Document and
	change to return librdf_node*
	(librdf_world_set_feature): Document and change to use
	librdf_node* value.

2004-09-30  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/check-sparql: -warnings, new perl only

	* rasqal/roqet.c: On query failure (prepare or execute) tidy and
	exit

	* rasqal/tests/rdql/testsuite/Makefile.am: count expected failures
	the old way

	* rasqal/tests/rdql/testsuite/check-rdql,
	rasqal/tests/sparql/check-sparql: Handle query parsing, execution
	errors

	* rasqal/tests/rdql/testsuite/Makefile.am: Handle test failures
	with/without a regex library

	* rasqal/tests/sparql/simple/Makefile.am,
	rasqal/tests/sparql/part1/Makefile.am: echo messages for correct,
	works targets

	* rasqal/tests/sparql/check-sparql: A few more fixes predicting
	optional results working.  Unique test works

	* rasqal/tests/rdql/testsuite/check-rdql,
	rasqal/tests/sparql/check-sparql: Handle missing vars or with
	undef value

	* rasqal/tests/sparql/part1/Makefile.am,
	rasqal/tests/sparql/simple/Makefile.am: Use check-sparql to run
	queries driven by manifests and check results are correct.  Enable
	this in check-local

	* rasqal/tests/sparql/check-sparql: Read manifest

	* rasqal/tests/sparql/simple/Makefile.am:
	Remove expected test failures code.

	* rasqal/tests/sparql/Makefile.am: Added check-sparql

	* rasqal/tests/sparql/check-sparql: run sparql tests

	* rasqal/tests/rdql/testsuite/check-rdql: Relative to root is ../../..
	use -d on roqet to dump query
	Added -d flag here to run in debug mode

	* rasqal/roqet.c: Added -d/--dump-query to print query to stdout

	* rasqal/tests/sparql/Makefile.am: sparql tests

	* rasqal/Makefile.am: sparql parser/lexer tests

	* rasqal/brql_parser.y: sparql label

	* rasqal/Makefile.am: BRQL to SPARQL

	* rasqal/rasqal_general.c: brql to sparql

	* rasqal/tests/sparql/part1/Makefile.am,
	rasqal/tests/sparql/simple/Makefile.am: list files

	* rasqal/configure.ac: Added sparql subdirs

	* rasqal/tests/sparql/part1/Makefile.am,
	rasqal/tests/sparql/part1/dawg-data-01.n3,
	rasqal/tests/sparql/part1/dawg-query-001,
	rasqal/tests/sparql/part1/dawg-query-002,
	rasqal/tests/sparql/part1/dawg-query-003,
	rasqal/tests/sparql/part1/dawg-result-001.n3,
	rasqal/tests/sparql/part1/dawg-result-002.n3,
	rasqal/tests/sparql/part1/dawg-result-003.n3,
	rasqal/tests/sparql/part1/manifest.n3: sparql part1 tests

	* rasqal/tests/sparql/simple/Makefile.am,
	rasqal/tests/sparql/simple/data-01.n3,
	rasqal/tests/sparql/simple/data-02.n3,
	rasqal/tests/sparql/simple/dawg-data-01.n3,
	rasqal/tests/sparql/simple/dawg-tp-01.rq,
	rasqal/tests/sparql/simple/dawg-tp-02.rq,
	rasqal/tests/sparql/simple/dawg-tp-03.rq,
	rasqal/tests/sparql/simple/dawg-tp-04.rq,
	rasqal/tests/sparql/simple/manifest.n3,
	rasqal/tests/sparql/simple/result-tp-01.n3,
	rasqal/tests/sparql/simple/result-tp-02.n3,
	rasqal/tests/sparql/simple/result-tp-03.n3,
	rasqal/tests/sparql/simple/result-tp-04.n3: Added sparql simple tests

	* rasqal/configure.ac: brql to sparql

	* rasqal/tests/Makefile.am: brql to sparql

	* rasqal/tests/brql/D.n3, rasqal/tests/brql/E.n3,
	rasqal/tests/brql/Makefile.am, rasqal/tests/brql/Q-C-1,
	rasqal/tests/brql/Q-C-2, rasqal/tests/brql/Q-D-1,
	rasqal/tests/brql/Q-D-2, rasqal/tests/brql/Q-D-3,
	rasqal/tests/brql/Q-F2F3-1, rasqal/tests/brql/Q-F2F3-2,
	rasqal/tests/brql/Q-OPT-1, rasqal/tests/brql/Q-OPT-2,
	rasqal/tests/brql/Q-S-1, rasqal/tests/brql/Q-S-2,
	rasqal/tests/brql/Q-SOURCE-1, rasqal/tests/brql/Q-SOURCE-2:
	Deleted

	* rasqal/Makefile.am: Add rasqal_xml.c

	* rasqal/roqet.c: Use rasqal_query_results_print_as_xml

	* rasqal/rasqal.h: Added rasqal_query_results_print_as_xml

	* rasqal/rasqal_xml.c: Rasqal XML

	* rasqal/roqet.c (roqet_print_results_as_xml):
	If xml, don't print datatype attribute.

	* rasqal/roqet.c: indent

	* rasqal/roqet.c (roqet_print_results_as_xml): no need to
	malloc/free when escaped string is same len as original.

	* rasqal/roqet.c: debug

	* rasqal/roqet.c (roqet_print_results_as_xml): Print XML Literals
	raw.

	* rasqal/roqet.c: Added OUTPUT_FORMAT_XML experiment
	(roqet_print_xml_attribute): Added, based on
	librdf_serialize_rdfxml code.
	(roqet_print_results_as_xml): Added, printing an entire result
	stream to the given handle in XML.
	(main): Added the xml output format.

	* rasqal/rasqal_literal.c, rasqal/rasqal.h: Export
	rasqal_literal_print_type

	* rasqal/roqet.c: source_uri check

	* rasqal/brql_parser.y: brql to sparqal (keeping alias)

	* rasqal/roqet.c: terminology s/data/source/ -d/-s --data/--source

	* rasqal/rasqal_query.c (rasqal_query_add_source,
	 rasqal_query_get_source): Handle NULL query->sources and
	 initialise it first time when adding.
	(rasqal_query_add_variable, rasqal_query_get_variable,
	rasqal_query_has_variable, rasqal_query_set_variable): Handle NULL
	query->selects and initialise it first time when adding.
	(rasqal_query_add_triple, rasqal_query_get_triple):Handle NULL
	query->triples and initialise it first time when adding.
	(rasqal_query_add_constraint, rasqal_query_get_constraint): Handle
	NULL query->constraints and initialise it first time when adding.
	(rasqal_query_add_prefix, rasqal_query_get_prefix): Handle NULL
	query->prefixes and initialise it first time when adding.

	* rasqal/roqet.c: Added -d URI to specify a data URI to load
	before running the query.

2004-09-29  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* Redland.i:
	Added REDLAND_TYPEMAP_I protecting redland-typemap.i early on

2004-09-26  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/brql_parser.y:
	(TriplePatternList) Append constraint to right sequence.

	* rasqal/brql_parser.y: Merged CommaAndConstraintClause into
	TriplePatternList to remove another shift/reduce conflict with
	AND.

	* rasqal/brql_parser.y: CommaAndConstraintClause tidy

	* rasqal/brql_parser.y: Removed SOURCE alias for FROM, reducing a
	shift/reduce cnflict

	* rasqal/brql_parser.y: URIList tidy

	* rasqal/fix-bison: Delete yyerrlab1 label only if used in a goto

	* rasqal/tests/brql/Q-F2F3-1, rasqal/tests/brql/Q-F2F3-2: F2F3
	bits

	* rasqal/rasqal_general.c: debug messages

	* rasqal/tests/brql/Q-SOURCE-1, rasqal/tests/brql/Q-SOURCE-2:
	PREFIX syntax

	* rasqal/rasqal.h: rasqal_triples_source_s: remove source_index.
	rasqal_triples_source_factory: remove UI from new_triples_source
	method.

	* rasqal/rasqal_redland.c:
	rasqal_redland_triples_source_user_data: Add source_uris array of
	size source_uris_count and source_index to use it when loading
	data.
	(rasqal_redland_new_triples_source): Walk through each source URI
	in turn and load data.
	(rasqal_redland_free_triples_source): Tidy up new array of uris.

	* rasqal/rasqal_raptor.c (rasqal_raptor_new_triples_source,
	rasqal_raptor_free_triples_source): Allocate and free source_uris
	and source_literals array.

	* rasqal/rasqal_redland.c (rasqal_redland_new_triples_source):
	Handle 0 sources

	* rasqal/rasqal_raptor.c:
	rasqal_raptor_triples_source_user_data: Add source_uris and
	source_literals array of size source_uris_count and source_index to
	use it when loading data.
	(rasqal_raptor_statement_handler): set origin URI as pointer into
	URI literals array.
	(rasqal_raptor_new_triples_source): Remove URI arg.  Walk through
	each source URI in turn and load data.
	(rasqal_raptor_triple_match): Remove URi arg, use origin_uri from
	triple.
	(rasqal_raptor_free_triples_source): Tidy up new arrays of data.
	(rasqal_raptor_bind_match): Update call to triple_match with no URI
	argument.

	* rasqal/rasqal_engine.c (rasqal_new_triples_source):
	Do not assume there is just one URI
	source.
	(rasqal_triples_source_next_source): Deleted.
	(rasqal_engine_get_next_result): Remove call to
	rasqal_triples_source_next_source - sources are not applied in order.

	* rasqal/brql_parser.y: expect 4
	(TriplePatternList): Rewrite and add SOURCE, OPTIONAL
	(ConstraintClause): Removed, now in TriplePatternList
	(URIList): No commas

	* rasqal/Makefile.am:
	Added fix-bison.  Use it for rdql and brql parsers.

	* rasqal/fix-bison: fix-bison

2004-09-24  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor-config.1: Restore deleted content

2004-09-22  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage.c (librdf_storage_context_add_statement,
	librdf_storage_context_add_statements): With a NULL context, call
	the non-context method as documented.  Fix NULL statement pointer
	checks.

2004-09-20  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/win32_raptor_config.h,
	raptor/configure.ac: Bumped version to 1.3.4

	* raptor/examples/Makefile.am, raptor/examples/grapper.c,
	raptor/examples/raptor_abort.c, raptor/raptor_locator.c,
	raptor/raptor_namespace.c, raptor/raptor_nfc.c,
	raptor/raptor_nfc.h, raptor/raptor_nfc_test.c,
	raptor/raptor_parse.c, raptor/raptor_qname.c,
	raptor/raptor_rdfxml.c, raptor/raptor_rfc2396.c,
	raptor/raptor_rss.c, raptor/raptor_sax2.c,
	raptor/raptor_sequence.c, raptor/raptor_set.c,
	raptor/raptor_stringbuffer.c, raptor/raptor_uri.c,
	raptor/raptor_utf8.c, raptor/raptor_win32.c, raptor/raptor_www.c,
	raptor/raptor_www_curl.c, raptor/raptor_www_libfetch.c,
	raptor/raptor_www_libwww.c, raptor/raptor_www_libxml.c,
	raptor/raptor_www_test.c, raptor/raptor_xml.c,
	raptor/raptor_xml_writer.c, raptor/rdfdump.c,
	raptor/tests/Makefile.am, raptor/tests/empty.c,
	raptor/tests/ex-14.out, raptor/tests/ex-20.out,
	raptor/tests/ex-22.out, raptor/tests/ex-52.out,
	raptor/tests/turtle/Makefile.am, raptor/tests/turtle/README.txt,
	raptor/tests/turtle/rdfq-results.out,
	raptor/tests/turtle/test-00.out, raptor/turtle_common.h,
	raptor/turtle_lexer.l, raptor/turtle_parser.y,
	raptor/win32_raptor_config.h, raptor/Makefile.am,
	raptor/configure.ac, raptor/manifest.pl, raptor/n3_common.h,
	raptor/n3_lexer.l, raptor/n3_parser.y, raptor/ntriples_parse.c,
	raptor/raptor-config.1, raptor/raptor-config.in,
	raptor/raptor-src-config.in, raptor/raptor.h,
	raptor/raptor.rdf.in, raptor/raptor.spec.in,
	raptor/raptor_expat.c, raptor/raptor_general.c,
	raptor/raptor_identifier.c, raptor/raptor_internal.h,
	raptor/raptor_libxml.c: LGPL / Apache 2.0 license

	* raptor/configure.ac: Check for libxml 2.5.10+ for RSS tag soup
	parser requirements, not features.

2004-09-19  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_internal.h:
	Added prototype for rasqal_engine_declare_prefix

	* rasqal/rasqal_engine.c (rasqal_engine_declare_prefix):
	Added to declare a namespace
	prefix/uri once only in a query.
	(rasqal_engine_declare_prefixes): Use above.

	* rasqal/rasqal.h: Added declared field to rasqal_prefix

	* rasqal/brql_parser.y: Initial BRQL updates post DAWG F2F3
	Deleted OPTIONAL, replaced with []s around set of triples
	using new terms LSQUARE and RSQUARE
	Removed USING work and replaced with PREFIX earlier.  Declare
	prefixes as soon as they appear.

	* rasqal/brql_lexer.l: Added PREF state for post-PREFIX word handling
	Define PREFIX, NAME, QNAME more precisely (not checked vs spec)
	Deleted OPTIONAL
	Made "PREFIX"/"prefix" set state PREF
	Added [/LSQUARE and ]/RSQUARE
	Made <PREF> state handle foo: and : names for namespace prefixes

2004-09-16  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_internal.h:
	Added prototype for rasqal_triples_source_next_source

	* rasqal/rasqal.h: Added origin field to rasqal_triple
	Added rasqal_triple_set_origin and rasqal_triple_get_origin
	Made bindings be [4]array
	Added raptor_uri param to rasqal_triples_soruce_factory method
	new_triples_source

	* rasqal/rasqal_redland.c (rasqal_redland_new_triples_match):
	Added origin, not checked

	* rasqal/rasqal_raptor.c (rasqal_new_triples_source):
	Set uri from first in list, call
	updated factory with that uri.
	(rasqal_free_triples_source): Tidy triples source and user data
	only if not alreayd done.
	(rasqal_triples_source_next_source): Added for switching to next
	data source.
	(rasqal_triples_match_bind_match): Handle 4 bindings
	(rasqal_engine_get_next_result): Handle origin queries and switching
	to next data source when current one exhausted (goto restart)

	* rasqal/rasqal_expr.c (rasqal_triple_print): Handle origin.
	(rasqal_triple_set_origin, rasqal_triple_get_origin): Added

	* rasqal/rasqal_engine.c (rasqal_new_triples_source):
	Set uri from first in list, call
	updated factory with that uri.
	(rasqal_free_triples_source): Tidy triples source and user data
	only if not alreayd done.
	(rasqal_triples_source_next_source): Added for switching to next
	data source.
	(rasqal_triples_match_bind_match): Handle 4 bindings
	(rasqal_engine_get_next_result): Handle origin queries and switching
	to next data source when current one exhausted (goto restart)

	* rasqal/brql_parser.y: Added SOURCE ?foo before triple

	* rasqal/tests/brql/Makefile.am, rasqal/tests/brql/E.n3,
	rasqal/tests/brql/Q-SOURCE-1, rasqal/tests/brql/Q-SOURCE-2: tests

2004-09-12  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_literal.c (rasqal_literal_as_string): Handle BLANK

2004-09-11  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal.h: docs

	* rasqal/brql_parser.y (OptionalClause):
	Make print handler for seq of seq.

	* rasqal/rasqal_engine.c (rasqal_engine_assign_variables):
	Handle no selects

	* rasqal/rasqal_raptor.c (rasqal_raptor_new_triples_source):
	Handle no sources

	* rasqal/roqet.c: Use raptor_free_memory on uri_string

	* rasqal/Makefile.am: clean up local_tests

	* rasqal/tests/brql/Makefile.am: fix tool building paths

	* rasqal/rasqal_query_test.c: Use data/dc.rdf

	* rasqal/Makefile.am, rasqal/configure.ac: Added data

	* rasqal/data/Makefile.am, rasqal/data/dc.rdf: data

2004-09-10  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_namespace.c: foo

	* raptor/raptor_namespace.c (raptor_new_namespace):
	Debug message only when level >1

	* rasqal/brql_lexer.l, rasqal/rdql_lexer.l (main):
	Use raptor_free_memory

	* rasqal/tests/brql/Makefile.am: BRQL Makefile

	* rasqal/tests/rdql/Makefile.am: RDQL Makefile

	* rasqal/rasqal_query.c (rasqal_free_query):
	Added describes, optional_triples and constructs.
	(rasqal_query_print): Print describes, optional_triples and
	constructs when present.  Make most things printing only if present.

	* rasqal/Makefile.am: fix line directives in bison generated files

	* rasqal/tests/rdql/testsuite/check-rdql,
	rasqal/tests/rdql/testsuite/tests2turtle.patch: Adjustments for
	dir renaming

	* rasqal/rasqal_internal.h:
	Added constructs, optional_triples, describes sequences
	Added select_is_describe, construct_all flags.
	Declare rasqal_init_query_engine_brql prototype

	* rasqal/rasqal_general.c (rasqal_init):
	Use conditionals for query language inits.

	* rasqal/rasqal_engine.c (rasqal_engine_expand_triple_qnames):
	Don't fail if there are no
	triples.  BRQL doesn't need them.

	* rasqal/tests/brql/D.n3, rasqal/tests/brql/Q-C-1,
	rasqal/tests/brql/Q-C-2, rasqal/tests/brql/Q-D-1,
	rasqal/tests/brql/Q-D-2, rasqal/tests/brql/Q-D-3,
	rasqal/tests/brql/Q-OPT-1, rasqal/tests/brql/Q-OPT-2,
	rasqal/tests/brql/Q-S-1, rasqal/tests/brql/Q-S-2: BRQL tests

	* rasqal/tests/Makefile.am: Switch to just subdirs here

	* rasqal/Makefile.am:
	Split tests into BRQL and RDQL ones enabled separately.
	Use makefile conditionals for sources

	* rasqal/configure.ac:
	Added --enable-query-languages and automake conditionals
	to avoid building them.

	* rasqal/Makefile.am: Remove rdql-testsuite dir.
	Add BRQL sources and tests

	* rasqal/brql_common.h, rasqal/brql_lexer.l, rasqal/brql_parser.y: BRQL

	* rasqal/tests/rdql/dc.rdf, rasqal/tests/rdql/example1.rdql,
	rasqal/tests/rdql/example2.rdql, rasqal/tests/rdql/example3.rdql,
	rasqal/tests/rdql/example4.rdql, rasqal/tests/rdql/example5.rdql,
	rasqal/tests/rdql/example_at_1.rdql,
	rasqal/tests/rdql/example_at_2.rdql,
	rasqal/tests/rdql/example_at_3.rdql,
	rasqal/tests/rdql/example_at_4.rdql,
	rasqal/tests/rdql/example_at_5.rdql,
	rasqal/tests/rdql/example_at_6.rdql,
	rasqal/tests/rdql/example_at_7.rdql,
	rasqal/tests/rdql/example_at_8.rdql,
	rasqal/tests/rdql/note-ex1.rdql, rasqal/tests/rdql/note-ex2.rdql,
	rasqal/tests/rdql/note-ex3.rdql, rasqal/tests/rdql/note-ex4.rdql,
	rasqal/tests/dc.rdf, rasqal/tests/example1.rdql,
	rasqal/tests/example2.rdql, rasqal/tests/example3.rdql,
	rasqal/tests/example4.rdql, rasqal/tests/example5.rdql,
	rasqal/tests/example_at_1.rdql, rasqal/tests/example_at_2.rdql,
	rasqal/tests/example_at_3.rdql, rasqal/tests/example_at_4.rdql,
	rasqal/tests/example_at_5.rdql, rasqal/tests/example_at_6.rdql,
	rasqal/tests/example_at_7.rdql, rasqal/tests/example_at_8.rdql,
	rasqal/tests/note-ex1.rdql, rasqal/tests/note-ex2.rdql,
	rasqal/tests/note-ex3.rdql, rasqal/tests/note-ex4.rdql: Moved to
	rdql subdir

2004-09-09  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/Makefile.am:
	Just link raptor_uri_test, raptor_uri_win32_test with raptor_rfc2396.lo

	* raptor/raptor_uri.c: (main) Don't use raptor_basename

	* raptor/raptor_uri.c:
	Revert wrapping so that -DWIN32 raptor_uri_win32_test can be
	compiled.  OSX 'make check' will have to live with the moans.

	* raptor/raptor_uri.c:
	Wrap functions with #ifndef STANDALONE ... #endif to
	prevent multiple link warnings on OSX with tests.

	* raptor/raptor_uri.c (main):
	Use program and raptor_basename in messages

	* raptor/raptor_sequence.c, raptor/raptor_stringbuffer.c,
	raptor/raptor_xml.c, raptor/raptor_rfc2396.c:
	Wrap functions with #ifndef STANDALONE ... #endif to
	prevent multiple link warnings on OSX with tests.

	* raptor/raptor_rss.c, raptor/raptor_rfc2396.c: Fixes for C++

	* raptor/NOTICE: NOTICE

	* raptor/raptor.spec.in, raptor/Makefile.am: Added NOTICE

	* raptor/raptor.spec.in: Mention atom 0.3

	* raptor/raptor.spec.in: Update for LGPL/Apache 2

	* raptor/raptor_rfc2396.c: Header

2004-09-08  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_rfc2396.c (raptor_new_uri_detail):
	Handle NULL string - failure.
	Increase alloced size to compensate for possibly 5 extra \0s
	for each URI component.
	(main): Check "" URI parses and NULL doesn't crash it.

	* raptor/raptor_internal.h: Added raptor_uri_detail.
	Added internal raptor_basename.

	* raptor/raptor.h: docs

	* raptor/Makefile.am: Added raptor_rfc2396.c and raptor_rfc2396_test
	Link all tests with librdf.la $(LIBS)

	* raptor/raptor_rfc2396.c: RFC2396 URI detail

	* raptor/raptor_uri.c: Remove old URI resolving code.

	* raptor/raptor_xml.c, raptor/raptor_parse.c,
	raptor/raptor_sequence.c, raptor/raptor_set.c,
	raptor/raptor_stringbuffer.c, raptor/raptor_nfc_test.c: Use
	raptor_basename in test code main()

	* raptor/raptor_general.c (raptor_basename): Added

	* raptor/raptor_rdfxml.c: correct comment

	* raptor/Makefile.am:
	Enable raptor_set_test raptor_xml_test tests only when rdf/xml enabled.

	* raptor/raptor_parse.c (raptor_stats_print):
	Only print rdfxml stats if compiled in.

	* raptor/Makefile.am: Change test to be raptor_parse_test
	Use raptor_rdfxml.c only if rdf/xml enabled.

	* raptor/raptor.h: Export raptor_xml_literal_datatype_uri_string_len

	* raptor/raptor_internal.h: Declare raptor_delete_parser_factories.

	* raptor/raptor_parse.c, raptor/raptor_general.c:
	Moved the following parser related functions and methods to
	raptor_parse.c:
	raptor_default_generate_id_handler,
	raptor_delete_parser_factories, raptor_feature_from_uri,
	raptor_features_enumerate, raptor_free_parser, raptor_generate_id,
	raptor_get_feature, raptor_get_label, raptor_get_locator,
	raptor_get_mime_type, raptor_get_name, raptor_get_parser_factory ,
	raptor_guess_parser_name, raptor_new_parser,
	raptor_new_parser_for_content, raptor_parse_abort,
	raptor_parse_chunk, raptor_parse_file, raptor_parse_file_stream,
	raptor_parse_uri, raptor_parse_uri_with_connection,
	raptor_parse_uri_write_bytes, raptor_parser_error,
	raptor_parser_error_varargs, raptor_parser_fatal_error,
	raptor_parser_fatal_error_varargs, raptor_parser_register_factory,
	raptor_parser_simple_error, raptor_parser_warning,
	raptor_parser_warning_varargs, raptor_parsers_enumerate,
	raptor_set_default_generate_id_parameters, raptor_set_error_handler,
	raptor_set_fatal_error_handler, raptor_set_feature,
	raptor_set_generate_id_handler, raptor_set_parser_strict,
	raptor_set_statement_handler, raptor_set_warning_handler,
	raptor_start_parse, raptor_stats_print, raptor_syntax_name_check,
	raptor_syntaxes_enumerate

	* raptor/Makefile.am: -MPL1.1 +Apache2.0

	* raptor/LICENSE-2.0.txt: +Apache2

2004-09-07  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/tests/turtle/test-16.ttl, raptor/tests/turtle/test-16.out:
	10000 triples exactly now

	* raptor/raptor_sequence.c: docs

	* raptor/turtle_parser.y (blank):
	Revert mis-edited triple sequence change.

	* raptor/turtle_parser.y (propertyList):
	Switch to left-recursion to prevent stack problems
	with bison.
	(raptor_turtle_parse_terminate): Call turtle_lexer_lex_destroy properly.

	* rasqal/rdql_parser.y (rasqal_rdql_query_engine_terminate):
	Call rdql_lexer_lex_destroy properly.

	* raptor/tests/turtle/test-14.ttl, raptor/tests/turtle/test-14.out:
	Use exactly 10000 all different triples.

	* raptor/tests/turtle/test-15.out, raptor/tests/turtle/test-15.ttl:
	Use different objects and no collections so there are exactly 10000
	triples, all different.

	* raptor/tests/turtle/test-16.out, raptor/tests/turtle/test-16.ttl:
	Use different objects so all 10000 triples are different

	* raptor/turtle_lexer.l (turtle_token_print):
	Add INTEGER_LITERAL for debugging.

	* raptor/Makefile.am: Make turtle_parser.c appear as C source name

	* raptor/turtle_parser.y (statementList, objectList):
	Switch to using left recursion to
	prevent stack overflow in bison with 10000 statements (possible) or
	objects (rarer).

	* raptor/tests/turtle/Makefile.am,
	raptor/tests/turtle/test-14.out, raptor/tests/turtle/test-14.ttl,
	raptor/tests/turtle/test-15.out, raptor/tests/turtle/test-15.ttl,
	raptor/tests/turtle/test-16.out, raptor/tests/turtle/test-16.ttl:
	Added large turtle tests test-14,15,16

	* raptor/turtle_parser.y (raptor_turtle_parse_chunk):
	Use RAPTOR_REALLOC for massive speed
	improvements on some systems.

	* raptor/raptor_internal.h: Added RAPTOR_REALLOC

2004-09-06  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_engine.c (rasqal_engine_execute_finish):
	Don't free triple_meta before
	checking the columns

	* rasqal/Makefile.am: Added rasqal_query_test to TESTS

	* rasqal/rasqal_engine.c (rasqal_engine_execute_init):
	Init triples_source, triple_meta only
	if not already done.
	(rasqal_engine_execute_finish): Free triple_meta and any variables
	still set if not cleared.

	* rasqal/rasqal_raptor.c (rasqal_raptor_free_triples_source):
	Free the rasqal_triple in the loop.

	* rasqal/rasqal_query.c (rasqal_query_execute): Re-execute if wanted.

	* rasqal/tests/Makefile.am, rasqal/tests/dc.rdf: Added dc.rdf

	* rasqal/Makefile.am, rasqal/rasqal_query_test.c:
	Added rasqal_query_test.c

	* rasqal/rasqal_literal.c (rasqal_literal_expand_qname):
	Zap old string pointer.

	* raptor/raptor_set.c (raptor_free_id_set):
	Free the set after freeing the list.

	* rasqal/rasqal_query.c (rasqal_query_prepare):
	Allow re-prepare when finished or executed.

	* rasqal/rasqal_engine.c (rasqal_engine_execute_init):
	Do not overwrite query->variables on
	a re-execute init.

	* librdf/rdf_log.c (librdf_fatal): Off by 1 in snprintf on OSX

2004-09-02  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/tests/turtle/test-13.out, raptor/tests/turtle/test-13.ttl:
	Make serializable as rdf/xml

2004-09-01  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* utils/rdfproc.c: Init results to NULL

	* raptor/tests/turtle/Makefile.am, raptor/tests/turtle/README.txt:
	Turtle tests readme

2004-08-30  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage_mysql.c (librdf_storage_mysql_get_contexts):
	Removed bogus '+' in the sql statement.  Thanks to DJ Adams for
	finding this.

2004-08-29  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rdql_lexer.l:
	Fix copy_regex_token prototype - delim is not const.

2004-08-27  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_rss.c: compare namespace URIs the cheaper way

	* raptor/raptor_rss.c: Added atom:copyright
	Rewrite atom fields earlier.
	Compare namespaces too, if they have them.

	* raptor/raptor_rss.c: Handle atom 0.3 somewhat.
	- Add atom author type.
	- Add atom 0.3 NS and atom 0.3 properties
	- Add DC Ns and all DC element properties.
	- Always rewrites atom:content into rss:description which is not
	  correct for all situations.
	- Cannot handle multiple <link> with different attributes; just uses
	  rel=alternate ones.
	General changes:
	Use XML_READER type enums.
	Fix copying properties to use RAPTOR_RSS_FIELDS_SIZE.
	Allow item field x to have a URI value in item->uri_fields[x] as well
	as literal in item->fields[x].

2004-08-23  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/turtle_parser.y (blank rule): Do not free a generated id here

2004-08-22  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/configure.ac: Remove old reference to g_utf8_normalize

	* rasqal/tests/example_at_8.rdql: RDQL @semantics example 8

	* rasqal/tests/Makefile.am: Added example_at_8.rdql

	* rasqal/Makefile.am: Re-fix generation of rdql_parser.c

	* rasqal/rdql_parser.y:
	Allow optional comma in prefix declaration lists.

	* rasqal/Makefile.am: Update rdql_parser bison output fix for no .tab.c

2004-08-19  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/Makefile.am: Add libraptor_la_SOURCES += for NFC.

2004-08-18  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_set.c: Wrap main code with #ifndef STANDALONE

	* raptor/raptor_general.c (raptor_init, raptor_finish):
	Use new static raptor_initialised to
	protect these from being run twice.

2004-08-17  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/configure.ac: Give nfc_needed a default

	* raptor/configure.ac, raptor/Makefile.am:
	Added conditional makefile support for XML parsers (expat, libxml),
	selecting RDF parsers (RDF/XML, Turtle, N-Triples, RSS tag soup),
	NFC checking.
	Added new configure argument --enable-parsers to control this.

	* raptor/raptor_utf8.c (raptor_utf8_is_nfc):
	Protect NFC check with define RAPTOR_NFC_CHECK

	* raptor/raptor_locator.c (raptor_update_document_locator):
	Protect RDF/XML bits with define RAPTOR_PARSER_RDFXML

	* raptor/raptor_general.c (raptor_stats_print):
	Protect RDF/XML bits with define RAPTOR_PARSER_RDFXML

	* raptor/raptor.h: Added prototype for raptor_calloc_memory

	* raptor/raptor_set.c, raptor/raptor_nfc.c: Casts for C++

	* rasqal/rasqal_literal.c (rasqal_literal_as_integer,
	rasqal_literal_as_floating): Edit casts near strtol, strtod to
	cause less moaning and still work with C++.

	* librdf/win32_rdf_config.h: 0.9.19

	* raptor/win32_raptor_config.h: 1.3.3

	* rasqal/win32_rasqal_config.h: 0.9.3

	* rasqal/configure.ac: Remove link with expat (!) in posix regex check

2004-08-13  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/win32/Makefile.am: rasqal not raptor

	* rasqal/win32/Makefile.am, rasqal/win32/rasqal.dsp,
	rasqal/win32/rasqal.dsw: win32 build configuration

	* rasqal/configure.ac, rasqal/Makefile.am: Add win32 dir

	* rasqal/roqet.c:
	Use #ifdef HAVE_UNISTD_H ... #endif around include of <unistd.h>

	* rasqal/rasqal_literal.c, rasqal/rasqal_expr.c:
	Use RASQAL_INLINE instead of inline.

	* rasqal/win32_rasqal_config.h: win32 updates from Chris Pointon

	* rasqal/rasqal_internal.h:
	Define RASQAL_INLINE here but don't condition it.

	* rasqal/rasqal_internal.h: Add RASQAL_INLINE, empty on WIN32

	* rasqal/rasqal.h: Export rasqal_set_triples_source_factory

	* raptor/turtle_lexer.l, raptor/n3_lexer.l: grammar

	* rasqal/rdql_parser.y: Use win32_rasqal_config.h

	* rasqal/rdql_lexer.l, rasqal/fix-flex, raptor/turtle_lexer.l,
	raptor/n3_lexer.l, raptor/fix-flex:
	fix-flex now inserts the raptor and win32 config includes block
	at the top of the lexer C.

	* raptor/n3_parser.y, raptor/n3_lexer.l: win32

	* rasqal/rdql_parser.y, rasqal/rdql_lexer.l, rasqal/Makefile.am:
	Do not generate *.tab.[ch] for rdql parser but process and rename
	to make .c, .h.

	* raptor/win32/raptor.dsw, raptor/win32/raptor.dsp:
	win32 updates from Chris Pointon

	* raptor/win32_raptor_config.h:
	No need for #define YY_NO_UNISTD_H here, it's done in the turtle
	lexer and parser C source.

	* raptor/turtle_parser.y, raptor/turtle_lexer.l: Use turtle_parser.h

	* raptor/raptor_xml_writer.c, raptor/raptor_sax2.c,
	raptor/raptor_qname.c, raptor/raptor_parse.c,
	raptor/raptor_namespace.c, raptor/raptor_libxml.c: Calloc fixes.

	* raptor/Makefile.am: Do not generate *.tab.[ch] for turtle parser
	but process and rename to make .c, .h.
	Apply fix-flex to the generated flex header file, to catch another
	unprotected include of unistd.h.

	* raptor/libraptor.3: Document raptor_calloc_memory.

	* raptor/raptor_general.c: Added raptor_calloc_memory

	* raptor/raptor_www_libwww.c:
	Add #ifdef RAPTOR_WWW_LIBWWW ... #endif block around content

	* raptor/raptor_www_libfetch.c:
	Add #ifdef RAPTOR_WWW_LIBFETCH ... #endif block around content
	Use #ifdef HAVE_SYS_PARAM_H for sys/param.h

	* raptor/raptor_www_curl.c:
	Add #ifdef RAPTOR_WWW_LIBCURL ... #endif block around content

	* raptor/win32_raptor_config.h: win32 updates from Chris Pointon

	* raptor/raptor_www.c: Calloc fix.
	(raptor_www_get_connection): Return NULL if no WWW library available.

	* raptor/raptor_internal.h: Correct RAPTOR_CALLOC macro param names.

	* raptor/raptor.h: Export raptor_xml_literal_datatype_uri_string

	* raptor/win32/Makefile.am, raptor/win32/README.txt,
	raptor/win32/README: README renamed to README.txt

	* librdf/rdf_storage_hashes.c, librdf/rdf_storage.c,
	librdf/rdf_parser.c, librdf/rdf_model_storage.c,
	librdf/rdf_model.c: Documentation - Note that the model, storage
	and parser get_feature methods return new librdf_node objects

	* Redland.i: librdf_model_has_arc_in/out return int not an
	librdf_iterator.
	Use %newobject to record that librdf_model_get_feature and
	librdf_parser_get_feature return new librdf_node objects.

2004-08-12  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_model.c (librdf_model_context_add_statement,
	librdf_model_context_add_statements,
	librdf_model_context_remove_statement,
	librdf_model_context_remove_statements,
	librdf_model_context_as_stream, librdf_model_context_serialize):
	Return failure when contexts are not supported, don't just carry on.

	* raptor/raptor_nfc.c: Tidy debug messages.
	Reset prev_class explicitly.

2004-08-11  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_parse.c (raptor_record_ID): c99

	* raptor/raptor_nfc.c: Return 0 from raptor_nfc_check on failure

	* raptor/raptor_nfc_test.c: Raptor NFC test

	* raptor/Makefile.am: Added raptor_nfc_test.c

	* raptor/Makefile.am: Add raptor_nfc_data.c raptor_nfc.c raptor_nfc.h
	Added raptor_nfc_test

	* raptor/raptor_utf8.c (raptor_utf8_is_nfc): Use raptor_nfc_check.

	* raptor/raptor_nfc.c, raptor/raptor_nfc.h: Unicode NFC

	* raptor/raptor_internal.h: Added prototype for raptor_nfc_check

	* raptor/configure.ac:
	Check for lengths of u8, u16, u32, char, short, int, long

	* raptor/raptor_nfc_data.c: Unicode NFC data tables

	* raptor/raptor_parse.c:
	Updated for raptor_set to raptor_id_set renaming.
	(raptor_record_ID): Pass in the base_uri to the raptor_id_set_add, do
	not malloc / free a larger string.

	* raptor/raptor_internal.h:
	Rename the raptor_set* typedef and functions to be raptor_id_set

	* raptor/raptor_set.c:
	Change the implementation to a list of (set of IDs)-per base URI.
	Each time a base URI is checked it is swapped with the first in
	the list.  The set of IDs (raptor_base_id_set) takes a lot less
	memory since it isn't storing the string concat(base URI,ID) but just
	ID.  The capacity and size parts are part of the raptor_base_id_set.
	Rename the structures and functions to be raptor_id_set not raptor_set.

	* raptor/raptor_parse.c (raptor_end_element_grammar):
	Add check for a non-empty property
	element with both a node element <rdf:Description/> child and
	property attributes.  For bad test bad-23.rdf

	* raptor/tests/bad-23.rdf:
	bad-23.rdf - property attributes and node element content check

	* raptor/tests/Makefile.am: Added bad-23.rdf

	* Makefile.am: Add srcdir for Redland.i install

	* Makefile.am: Preserve the Redland.i timestamp on an install, so
	that redland-bindings can build against it reliably, not
	necessarily requiring SWIG to compile.

2004-08-10  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/libraptor.3: Document check_rdf_id feature

2004-08-03  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* configure.ac: Bumped version to 0.9.19

	* Snapshotted redland_0_9_18 for 0.9.18 release

	* librdf/rdf_statement.h, librdf/rdf_statement.c:
	Revert statement usage counting.

	* configure.ac: Bumped version to 0.9.18

	* Snapshotted redland_0_9_17 for 0.9.17 release

	* librdf/rdf_init.c (librdf_free_world): Destroy nodes, statements
	mutexes. 
	(librdf_world_init_mutex): Init nodes, statements mutexes.

	* librdf/rdf_init.h: Added statements mutex

	* librdf/rdf_statement.c: Statements are now usage counted,
	Removed old macros throughout.
	(librdf_new_statement): Set usage to 1.
	(librdf_new_statement_from_statement): Rewrite to use usage.
	(librdf_free_statement): Free when usage is zero, using mutex to
	protect shared structures.

	* librdf/rdf_statement.h: Statements are now usage counted,
	Removed old macros

2004-08-02  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_parser_raptor.c
	(librdf_parser_raptor_parse_as_stream_common,
	librdf_parser_raptor_parse_into_model_common): Add a length parameter,
	calculate it if it is 0.
	(librdf_parser_raptor_parse_uri_as_stream,
	librdf_parser_raptor_parse_string_as_stream): Updates for change above.
	(librdf_parser_raptor_parse_counted_string_as_stream,
	librdf_parser_raptor_parse_counted_string_into_model): Added, taking
	a counted string with length>0, calling one of the common functions
	above.
	(librdf_parser_raptor_register_factory): Register new methods.

	* librdf/rdf_parser.c (librdf_parser_parse_counted_string_as_stream,
	librdf_parser_parse_counted_string_into_model): Added, taking a
	counted string with length>0, calling the new parser factory
	methods.
	(main): Test code updated to test rdfxml, ntriples and turtle
	with four different parsing methods for one parser.  This
	tests - a) memory model checks for same triples
	b) parsing works with four methods
	c) parsing with same parser multiple times works

	* Redland.i: Added librdf_parser_parse_counted_string_as_stream and
	librdf_parser_parse_counted_string_into_model

	* librdf/rdf_parser.h: Added factory methods
	parse_counted_string_into_model, parse_counted_string_as_stream as
	variants of the uncounted versions.  Added prototypes for
	librdf_parser_parse_counted_string_as_stream,
	librdf_parser_parse_counted_string_into_model

2004-07-30  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_internal.h:
	Switch to WWW read buffer size of 4096 (from 256 bytes!)

	* raptor/raptor_general.c: Switch to read buffer size of 4096

2004-07-28  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* autogen.sh, rasqal/autogen.sh, raptor/autogen.sh:
	move 'rm's inside configure.ac loop

	* rasqal/autogen.sh, raptor/autogen.sh, autogen.sh: typo

	* raptor/autogen.sh, rasqal/autogen.sh, autogen.sh:
	Ensure subdirs get config.guess, config.sub

	* librdf/rdf_storage_tstore.c (librdf_storage_list_add_statement):
	Note FIXME - cannot enforce not adding duplicate statements.

	* librdf/rdf_storage_mysql.c (librdf_storage_mysql_add_statement,
	librdf_storage_mysql_add_statements): Enforce not adding duplicate
	statements.

	* librdf/rdf_storage_list.c (librdf_storage_list_add_statement):
	Enforce not adding duplicate statements.
	(librdf_storage_list_add_statements): Enforce not adding duplicate
	statements. Tidy the code.

	* librdf/rdf_storage_hashes.c (librdf_storage_hashes_add_statement):
	Enforce not adding duplicate statements.
	This is not needed for librdf_storage_hashes_add_statements since
	it calls the above method.

	* librdf/rdf_storage.c:
	(librdf_storage_add_statement, librdf_storage_add_statements):
	Document that duplicate statements are ignored on addition.

	* docs/api.sgml.in: In model class intro, document that duplicate
	statements are ignored on adding.

	* librdf/rdf_model.c (librdf_model_add_statement):
	Document that duplicate statements are
	ignored and use librdf_model_contains_statement to enforce it.
	(librdf_model_add_statements): Document that duplicate statements are
	ignored.

	* configure.ac:
	For maintainer-mode, always invoke AC_CONFG_SUBDIR on raptor
	and rasqal.  The extra configures for the maintainer is fine
	and ensures the tarball is made OK.

	* Makefile.am: Zap customised DIST_SUBDIRS again

	* raptor/win32/raptortest.cpp:
	Added raptor_init, raptor_finish (untested).

2004-07-27  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage_mysql.c, raptor/raptor_locator.c: casts for c++

2004-07-27  Morten Frederiksen

	* Updated to latest version of the MySQL storage written
	by Morten Frederiksen

	* librdf/rdf_storage_mysql.c: Add new storage options:
	  bulk - if inserts should be optimized by locking and index
	         optimizations 
	  merge - if a table with merged models should be maintained
	Added a digest object to the storage context for use and re-use
	of MD5 digesting.
	(librdf_storage_mysql_hash): Changed to use context digest option.
	(librdf_storage_mysql_init): Added and documented the bulk and merge
	options.  Document the new option, already implemented, to create
	tables.  Update the MySQL schemas.
	(librdf_storage_mysql_merge): Added, to re/create merged view of all
	models.
	(librdf_storage_mysql_terminate): Tidy up digest from context.
	(librdf_storage_mysql_sync): Added to flush tables.  Now used
	by librdf_storage_mysql_close.
	(librdf_storage_mysql_size, librdf_storage_mysql_node_hash): Updated
	for new schema.
	(librdf_storage_mysql_start_bulk, librdf_storage_mysql_stop_bulk):
	Added, to start and stop bulk op.
	(librdf_storage_mysql_context_add_statements): Add bulk start
	operations when enabled.
	(librdf_storage_mysql_context_add_statement_helper,
	librdf_storage_mysql_contains_statement,
	librdf_storage_mysql_remove_statement): Docucomments.
	Updated for new schema.
	(librdf_storage_mysql_context_remove_statements):
	Updated for new schema.
	(librdf_storage_mysql_serialise,
	librdf_storage_mysql_find_statements,
	librdf_storage_mysql_find_statements_in_context): Docucomments
	(librdf_storage_mysql_find_statements_with_options): Docucomments.
	Updated for new schema.
	(librdf_storage_mysql_find_statements_in_context_next_statement):
	Add checking there is a statement to return.
	(librdf_storage_mysql_get_contexts):
	Updated for new schema.

2004-07-27  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_expr.c: Add #ifndef STANDALONE ... #endif around
	test functions, linked via library.

	* configure.ac: Remove extra -DLIBRDF_DEBUG when using dmalloc

	* rasqal/configure.ac: Remove -DLIBRDF_DEBUG

	* rasqal/configure.ac:
	raptor-config, redland-config --version-decimal 2>/dev/null

	* rasqal/configure.ac:
	Use raptor-config, redland-config --version-decimal

	* rasqal/configure.ac: Remove duplicate redland-config test

	* librdf/rdf_query_rasqal.c, librdf/rdf_parser_raptor.c,
	librdf/rdf_node.c, librdf/rdf_log.c: Casts for C++

	* configure.ac: Added DIST_SUBDIRS for maintainer mode

	* configure.ac, Makefile.am:
	Replace SD_PRE with LOCAL_SUBDIRS to enable make distcheck to work.
	Note that this will create a smaller tarball while doing the 'make
	dist' in the build tree, which should not be used to make the
	release tarball.

	* Makefile.am:
	No need for SD_POST, CONFIG_SUBDIRS (not used here anyway)
	Tidy DIST_SUBDIRS

	* configure.ac: No need for SD_POST

	* configure.ac:
	Do not configure raptor, rasqal directories unless compiling and
	using them.
	That should save a lot of configure time.

2004-07-26  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* AUTHORS: Merged out csharp/AUTHORS

	* raptor/raptor_general.c:
	Add #ifndef STANDALONE ... #endif around body.

2004-07-23  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_parser.c, librdf/rdf_model.c:
	Replace parser name "raptor" with "rdfxml"

	* configure.ac: raptor min version 1.3.2

	* examples/example4.c, examples/example2.c:
	Replace parser name "raptor" with "rdfxml"

2004-07-21  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/strcasecmp.c, rasqal/roqet.c, rasqal/rasqal_redland.c,
	rasqal/rasqal_raptor.c, rasqal/rasqal_query.c,
	rasqal/rasqal_literal.c, rasqal/rasqal_general.c,
	rasqal/rasqal_expr.c, rasqal/rasqal_engine.c, rasqal/Makefile.am,
	rasqal/win32_config.h, rasqal/win32_rasqal_config.h: rename
	win32_config.h to win32_rasqal_config.h

	* raptor/configure.ac: Bumped version to 1.3.3

	* raptor/configure.ac:
	Removed configuration for gnome glib, pkgconfig and glib-config
	to get g_utf8_normalize for Unicode NFC checking.

	* raptor/raptor_utf8.c (raptor_utf8_is_nfc):
	Removed use of g_utf8_normalize for Unicode NFC
	checking, it seems to give false negatives, is also rather slow since
	it does normalization rather than just checking for NFC.

2004-07-19  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* configure.ac: no need for perl dirs

	* librdf/redland.spec.in: remove redland-perl, redland-python

	* redland-src-config.in: Added --libtool-libs

	* docs/Makefile.am, configure.ac, Makefile.am:
	Updates for move of files and dirs to redland-bindings package

	* docs/ruby.html, docs/tcl.html, docs/csharp.html,
	docs/fix-pod-xhtml, docs/fix-python-xhtml, docs/java.html,
	docs/perl.html, docs/php.html, docs/python.html: Moved to
	redland-bindings package

	* Moved csharp, java, perl, php, python, ruby, tcl directories and
	supporting doc files in docs to the redland-bindings package.
	
	* Redland.i:
	Remove #include <rdf_config.h> since this is now a public file.

2004-07-16  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/tests/Makefile.am, raptor/tests/ex-54.out,
	raptor/tests/ex-54.rdf, raptor/tests/warn-03.out,
	raptor/tests/warn-03.rdf: Renamed warn-03 to ex-54 - it is not an
	error or a warning, the data is good
	
2004-07-14  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/tests/Makefile.am, raptor/tests/bad-22.rdf:
	bad-22.rdf testing rdf:li forbidden as a property attribute
	(Graham Klyne)

2004-07-14  Dave Beckett  <Dave.Beckett@bristol.ac.uk>
	
	* raptor/tests/Makefile.am, raptor/tests/bad-22.rdf:
	bad-22.rdf testing rdf:li forbidden as a
	property attribute (Graham Klyne)

2004-07-12  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/redland.spec.in:
	Ship /usr/share/redland/Redland.i in redland-devel

	* redland-src-config.in, redland-config.in:
	Added --swig option to print the path to the SWIG interface file

	* Makefile.am: Install Redland.i in $(pkgdata)

	* Redland.i: Split SWIG bits into general and language-specific
	parts

	* librdf/rdf_query_results.c (librdf_query_results_get_bindings):
	Fix docucomment so jade works again

	* docs/api.sgml.in: id="query-results"

2004-07-09  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* docs/Makefile.am:
	Don't ship old pictures overview.png overview.ps overview.pdf

2004-07-09  Edd Dumbill <edd@usefulinc.com>

	* librdf/rdf_log.c:
	Add accessors for components of the librdf_log_message type.
	Replace librdf.h, raptor.h with redland.h.

	* librdf/rdf_log.h: add accessors for components of the
	librdf_log_message type.

2004-07-09  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/redland.h: Include rasqal.h, reorder so raptor.h is first.

	* librdf/rdf_query_results.c, librdf/rdf_utf8.c, librdf/rdf_uri.c,
	librdf/rdf_stream.c, librdf/rdf_storage_tstore.c,
	librdf/rdf_storage_mysql.c, librdf/rdf_storage_list.c,
	librdf/rdf_storage_hashes.c, librdf/rdf_storage_file.c,
	librdf/rdf_storage.c, librdf/rdf_statement.c,
	librdf/rdf_serializer_rdfxml.c, librdf/rdf_serializer_raptor.c,
	librdf/rdf_serializer.c, librdf/rdf_query_triples.c,
	librdf/ChangeLog, librdf/rdf_query_rasqal.c, librdf/rdf_query.c,
	librdf/rdf_parser_raptor.c, librdf/rdf_parser.c,
	librdf/rdf_node.c, librdf/rdf_model_storage.c, librdf/rdf_model.c,
	librdf/rdf_list.c, librdf/rdf_iterator.c, librdf/rdf_init.c,
	librdf/rdf_heuristics.c, librdf/rdf_hash_memory.c,
	librdf/rdf_hash_cursor.c, librdf/rdf_hash_bdb.c,
	librdf/rdf_hash.c, librdf/rdf_files.c, librdf/rdf_digest_sha1.c,
	librdf/rdf_digest_openssl.c, librdf/rdf_digest_md5.c,
	librdf/rdf_digest.c, librdf/rdf_concepts.c: Use redland.h in all
	files not a selection of librdf.h, raptor.h and rasqal.h

	* librdf/ChangeLog: ChangeLog in CVS now

2004-07-09  Edd Dumbill <edd@usefulinc.com>
	
	* raptor_locator.c: add accessors for parts of the raptor_locator
	struct.
	* raptor.h: add prototypes for the accessors

2004-07-09  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/ChangeLog, ChangeLog, raptor/ChangeLog: ChangeLog in CVS now

2004-07-08  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* examples/example5.c: Updated to use librdf_query_results

	* librdf/rdf_query_results.c (librdf_query_results_get_bindings):
	Added a doc example

	* librdf/rdf_query_results.c: doc

	* librdf/rdf_log.c (librdf_log_simple):
	Use correct user_data.  Patch from René Puls.

	* utils/rdfproc.c (log_handler):
	Added, used to report things here, rather than let the
	default code do it.

	* raptor/raptor_general.c (raptor_parse_uri_with_connection):
	Pass up WWW errors to the parser
	error handler.

	* docs/api.sgml.in: Added QueryResults as a separate file

	* docs/python.html, docs/perl.html, docs/csharp.html:
	Link to docs for query_results.html

	* docs/api.sgml.in: Added QueryResults

	* docs/Makefile.am: Re-add query_results to DOC_CLASSES

	* librdf/rdf_query.h: Added internal librdf_query_add_query_result,
	librdf_query_remove_query_result prototypes

	* librdf/Makefile.am: Added rdf_query_results.c

	* librdf/rdf_query.c, librdf/rdf_query_results.c:
	Moved librdf_query_results to separate file, for doc purposes mostly

	* docs/Makefile.am: remove query_results

	* docs/Makefile.am: added query_results to DOC_CLASSES

2004-07-06  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* configure.ac: formatting

	* configure.ac:
	Added GACUTIL, SN, ILGAC and report ECMA CLI in languages available

	* configure.ac: Added ilgac, gacutil, sn

2004-07-05  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* utils/rdfproc.c: fixes for erroring out on query failure

	* librdf/rdf_storage.c (librdf_storage_node_stream_to_node_create):
	node2 can be NULL such
	as when called by librdf_storage_get_arcs_out,
	librdf_storage_get_arcs_in.

2004-06-30  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/Makefile.am: Added $(DEFS) to test compile & link lines

	* librdf/rdf_types.h: Define u64 for WIN32 as a typedef for __int64

	* librdf/librdf.h:
	Added REDLAND_STATIC to define REDLAND_API to nothing.

	* raptor/configure.ac: Added RAPTOR_PARSER_TURTLE,
	RAPTOR_PARSER_NTRIPLES and RAPTOR_PARSER_RDFXML all set to 1

	* raptor/raptor_general.c (raptor_init):
	Added RAPTOR_PARSER_TURTLE, RAPTOR_PARSER_NTRIPLES and
	RAPTOR_PARSER_RDFXML

	* librdf/Makefile.am: Added win32_rdf_config.h

	* librdf/win32_rdf_config.h: redland WIN32 hard-coded config

	* librdf/rdf_storage.c, librdf/rdf_storage_file.c,
	librdf/rdf_storage_hashes.c, librdf/rdf_storage_list.c,
	librdf/rdf_storage_mysql.c, librdf/rdf_storage_tstore.c,
	librdf/rdf_stream.c, librdf/rdf_uri.c, librdf/rdf_utf8.c,
	librdf/rdf_hash_memory.c, librdf/rdf_heuristics.c,
	librdf/rdf_init.c, librdf/rdf_iterator.c, librdf/rdf_list.c,
	librdf/rdf_log.c, librdf/rdf_model.c, librdf/rdf_model_storage.c,
	librdf/rdf_node.c, librdf/rdf_parser.c,
	librdf/rdf_parser_raptor.c, librdf/rdf_query.c,
	librdf/rdf_query_rasqal.c, librdf/rdf_query_triples.c,
	librdf/rdf_serializer.c, librdf/rdf_serializer_raptor.c,
	librdf/rdf_serializer_rdfxml.c, librdf/rdf_statement.c,
	librdf/rdf_concepts.c, librdf/rdf_digest.c,
	librdf/rdf_digest_md5.c, librdf/rdf_digest_openssl.c,
	librdf/rdf_digest_sha1.c, librdf/rdf_files.c, librdf/rdf_hash.c,
	librdf/rdf_hash_bdb.c, librdf/rdf_hash_cursor.c: Added #include
	<win32_rdf_config.h> when WIN32 defined

	* raptor/win32_raptor_config.h: 1.3.2

	* raptor/turtle_parser.y, raptor/turtle_lexer.l,
	raptor/strcasecmp.c, raptor/rdfdump.c, raptor/raptor_xml_writer.c,
	raptor/raptor_xml.c, raptor/raptor_www_test.c,
	raptor/raptor_www_libxml.c, raptor/raptor_www_libwww.c,
	raptor/raptor_www_libfetch.c, raptor/raptor_www_curl.c,
	raptor/raptor_www.c, raptor/raptor_win32.c, raptor/raptor_utf8.c,
	raptor/raptor_uri.c, raptor/raptor_stringbuffer.c,
	raptor/raptor_set.c, raptor/raptor_sequence.c,
	raptor/raptor_sax2.c, raptor/raptor_rss.c, raptor/raptor_qname.c,
	raptor/raptor_parse.c, raptor/raptor_namespace.c,
	raptor/raptor_locator.c, raptor/raptor_libxml.c,
	raptor/raptor_identifier.c, raptor/raptor_general.c,
	raptor/raptor_expat.c, raptor/ntriples_parse.c,
	raptor/Makefile.am, raptor/win32_raptor_config.h,
	raptor/win32_config.h: Renamed win32_config.h to
	win32_raptor_config.h

2004-06-29  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage.c (librdf_storage_find_statements_in_context):
	When applying map, copy the statement so it can be freed later.

	* librdf/rdf_model.c (librdf_model_find_statements_in_context):
	When applying map, copy the statement so it can be freed later.

2004-06-25  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/ntriples_parse.c (raptor_ntriples_parse_line):
	Make language on a datatyped literal a warning.

2004-06-24  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_general.c: docs

	* raptor/libraptor.3: date

	* raptor/libraptor.3:
	Added raptor_alloc_memory.  Note where and why it and
	raptor_free_memory may need to be used in the descriptiona
	and next to the methods that it applies to.

	* raptor/raptor_general.c: docs

	* raptor/raptor_general.c, raptor/raptor.h: Added raptor_alloc_memory

	* librdf/rdf_node.c (librdf_node_get_li_ordinal):
	if oops, do not always return -1

2004-06-23  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/Makefile.am: Add rule to make libraptor.la

2004-06-22  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_query.h: Added results field to query.
	Added next field to query_results.

	* librdf/rdf_query.c:
	(librdf_query_add_query_result, librdf_query_remove_query_result):
	Now take query_results args.

	* configure.ac: removed --with-libwww - has not been used for
	anything for a long while.

	* librdf/rdf_query.c:
	Added usage counting of query between query & query-results.
	(librdf_query_add_query_result, librdf_query_remove_query_result): Added
	(librdf_free_query, librdf_new_query_from_factory,
	librdf_new_query_from_query): Added usage counts.
	(librdf_query_execute): Link query to query_results on success.
	(librdf_free_query_results): Do not return after factory cleanup but
	continue to clean up more.

	* librdf/rdf_query.h: Added usage count to query

	* librdf/rdf_query_rasqal.c (librdf_query_rasqal_free_results):
	Do not free query_results here,
	it is done by librdf_free_query_results

	* raptor/configure.ac: Added --with-expat-source option to build
	against an external expat source.
	Handle old and new style expat source areas.
	Report expat source dir in summary.
	Tidy up default messages.
	Only use expat subdir if it exists.

	* raptor/tests/Makefile.am:
	AM_LDFLAGS does not need LIBS, libraptor.la includes it all.

2004-06-21  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/configure.ac: Added --with-dmalloc

	* librdf/rdf_query_rasqal.c (librdf_query_rasqal_free_results):
	Free the query_results

	* rasqal/rasqal_redland.c, librdf/rdf_query_rasqal.c
	(rasqal_redland_bind_match): free the literal returned by
	redland_node_to_rasqal_literal since a new one is made by
	rasqal_literal_as_node.

	* librdf/rdf_query.h:
	query factory free_results method returns no value

	* librdf/rdf_query.c (librdf_free_query_results): Add debug assertion

2004-06-17  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/Makefile.am, raptor/Makefile.am: Zap extra $@ on rule line

	* configure.ac: Add CSHARPCFLAGS, CLI_PREFIX

2004-06-17  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* configure.ac: PKG_CONFIG

	* configure.ac: Add CSHARPCFLAGS, CLI_PREFIX

2004-06-13  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* configure.ac: Added csharp/examples dir

	* rasqal/configure.ac: Bumped version to 0.9.2

	* raptor/configure.ac: pkg-config is too noisy on errors

	* rasqal/configure.ac: Require raptor 1.3.1

	* rasqal/docs/Makefile.am: README should be maintainer-clean

	* rasqal/configure.ac: removed dup enable-release

	* rasqal/configure.ac, configure.ac, raptor/configure.ac:
	Only muck about with removing -O2 from flags in maintainer mode.

	* rasqal/librasqal.3:
	Added query results class, moved methods over and renamed.

	* rasqal/librasqal.3: example updated

2004-06-12  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/Makefile.am, raptor/Makefile.am:
	Added local distclean-compile rule to override the insane
	one automake uses by default: rm -f *.tab.c

	* rasqal/librasqal.3: Add 0.9.1 changelog

	* raptor/configure.ac: Bumped version to 1.3.2

	* raptor/tests/Makefile.am: add CLEANFILES

	* raptor/tests/Makefile.am:
	Added TESTS with raptor_empty_test the only one right now.
	Added C include, linking lines

	* raptor/tests/empty.c: Test of empty C file, just using raptor.h work

	* raptor/raptor_uri.c (raptor_uri_filename_to_uri_string, raptor_uri_uri_string_to_filename_fragment):
	Casts and char/unsigned
	char fixes for C++

2004-06-08  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_uri.c (raptor_default_new_uri):
	Avoid free(NULL) for filename.

	* raptor/raptor_general.c (raptor_parse_file):
	Check before fopen that it is not a directory
	attempting to be fopen()ed - unix only, with lstat.

	* raptor/raptor_www.c (raptor_www_file_fetch):
	Check before fopen that it is not a
	directory attempting to be fopen()ed - unix only, with lstat.

	* raptor/rdfdump.c:
	Add error for failure of raptor_uri_filename_to_uri_string

	* raptor/raptor_uri.c (raptor_uri_filename_to_uri_string):
	Unix malloc too large by 2.

	* raptor/raptor_uri.c (raptor_default_new_uri): Zero fragment pointer.

	* raptor/raptor_uri.c (raptor_default_new_uri):
	Do not use a NULL filename.

	* raptor/raptor_uri.c (raptor_uri_uri_string_to_filename_fragment):
	Fail if the URI has no
	path or was going to return an empty string.
	(assert_filename_to_uri): Test code allow checks for NULL.
	(main): Test code for silly URIs that should work or fail.

2004-06-06  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_internal.h: Added RAPTOR_FATAL3

	* raptor/raptor_uri.c:
	Fix win32 file/URI encoding to use file:///name and escape things better.
	(raptor_uri_filename_to_uri_string): Calculate new length correctly,
	with %-escaping.
	(raptor_uri_uri_string_to_filename_fragment): Calculate new format.
	Also do less strlen, strcpy.
	(main): Change tests to match new win32 file URI, test %-escaping
	and %-unescaping correctly.

2004-06-04  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_uri.c:
	NOTE: Not all below is fully working - 3 tests fail at this point.
	(raptor_uri_filename_to_uri_string): %-escape ' ' and '%' at least
	as a minimum.  Document this.  On Windows, generate file:///c:/ ...
	not c|
	(raptor_uri_uri_string_to_filename_fragment): Add %-unescaping.
	(main): Added test cases for %-escaping, %-expanding

	* raptor/Makefile.am: Added raptor_uri_win32_test

2004-06-03  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/tests/turtle/rdfq-results.ttl:
	Updated to http://www.w3.org/2003/03/rdfqr-tests/recording-query-results.html
	CVS $Id: ChangeLog.5,v 1.1 2008-07-08 10:39:41 larsl Exp $

2004-06-01  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_query.c (rasqal_free_query_results,
	rasqal_query_results_get_count, rasqal_query_results_next,
	rasqal_query_results_finished, rasqal_query_results_get_bindings,
	rasqal_query_results_get_binding_value,
	rasqal_query_results_get_binding_name,
	rasqal_query_results_get_binding_value_by_name,
	rasqal_query_results_get_bindings_count): Defensive checking for
	non-NULL query_results.

	* rasqal/docs/kernel-doc, docs/kernel-doc:
	ensure id in the SGML is always same size with md5sum

	* utils/rdfproc.c, Redland.i: Added librdf_query_results.
	Renamed all librdf_query results methods to match (like rasqal 0.9.1)

	* librdf/librdf.h: Added librdf_query_results

	* librdf/rdf_storage.c, librdf/rdf_storage.h:
	Removed librdf_storage_query_as_stream,
	librdf_storage_query_as_bindings and replaced with
	librdf_storage_query_execute

	* librdf/rdf_model_storage.c:
	Removed librdf_model_storage_query_as_stream,
	librdf_model_storage_query_as_bindings and replaced with
	librdf_model_storage_query_execute

	* librdf/rdf_model.c:
	Removed librdf_model_query, librdf_model_query_string,
	librdf_model_query_as_stream, librdf_model_query_as_bindings and
	replaced with librdf_model_query_execute

	* librdf/rdf_model.h:
	In factory, removed query_as_stream, replaced with query_execute.
	Removed librdf_model_query, librdf_model_query_string,
	librdf_model_query_as_stream, librdf_model_query_as_bindings and
	replaced with librdf_model_query_execute

	* librdf/rdf_query_triples.c, librdf/rdf_query_rasqal.c,
	librdf/rdf_query.c, librdf/rdf_query.h: Added librdf_query_results.
	Renamed all librdf_query results methods to match (like rasqal 0.9.1)

	* rasqal/rasqal_query.c (rasqal_query_remove_query_result): Init prev.

	* rasqal/rasqal_query.c:
	(rasqal_query_results_get_binding_value_by_name)
	Renamed from rasqal_query_results_get_binding_by_name.

	* rasqal/rasqal.h: rasqal_query_results_get_binding_by_name to
	rasqal_query_results_get_binding_value_by_name

	* rasqal/roqet.c: Use rasqal_query_results apis

	* configure.ac: require Rasqal 0.9.1

	* rasqal/rasqal_query.c (rasqal_new_query, rasqal_free_query):
	Use usage.
	(rasqal_query_execute): Return a new rasqal_query_results* object
	and add it to the query object with rasqal_query_add_query_result.
	(rasqal_query_add_query_result, rasqal_query_remove_query_result): Added
	(rasqal_free_query_results): Added to destroy rasqal_query_results* object
	Renamings:
	rasqal_query_get_result_count => rasqal_query_results_get_count
	rasqal_query_next_result => rasqal_query_results_next
	rasqal_query_results_finished => rasqal_query_results_finished
	rasqal_query_get_result_bindings => rasqal_query_results_get_bindings
	rasqal_query_get_result_binding_value => rasqal_query_results_get_binding_value
	rasqal_query_get_result_binding_name => rasqal_query_results_get_binding_name
	rasqal_query_get_result_binding_by_name => +rasqal_query_results_get_binding_by_name
	rasqal_query_get_bindings_count => rasqal_query_results_get_bindings_count

	* rasqal/rasqal_internal.h:
	rasqal_query_s: Added usage counts, results pointing to active
	rasqal_query_results* for this query.
	Added rasqal_query_results_s structure.

	* rasqal/rasqal.h: Added rasqal_query_results class.
	Made rasqal_query_execute return a rasqal_query_result*
	Renamed all rasqal_query*result* methods to be rasqal_query_result_*
	Added rasqal_free_query_results to tidy up.

	* rasqal/rasqal_engine.c (rasqal_engine_build_constraints_expression):
	Use AND between constraints.

2004-05-31  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_general.c (raptor_parser_error_varargs,
	raptor_parser_warning_varargs): Chop off trailing \n from
	messages.

	* raptor/raptor_libxml.c (raptor_libxml_error):
	Chop off trailing \n correctly.

2004-05-30  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/turtle_lexer.l: Set the uri union field for ':' qname.

	* raptor/turtle_parser.y (raptor_turtle_parse_start):
	Delete any existing buffer content before
	starting.

	* raptor/raptor_general.c:
	Added feature warn_other_parseTypes, default true in lax mode.

	* raptor/raptor_parse.c:
	Added feature warn_other_parseTypes and used to warn when a parseType
	Literal is assumed.

	* raptor/raptor_internal.h: Added feature warn_other_parsetypes

	* raptor/raptor.h: Aded feature warn_other_parsetypes

	* raptor/tests/warn-07.out, raptor/tests/warn-07.rdf:
	Replaced by warn-07

	* raptor/tests/Makefile.am: Remove ex-50, warn-07 covers it

	* raptor/tests/ex-50.out, raptor/tests/ex-50.rdf: Replaced by warn-07

	* raptor/tests/Makefile.am: Add warn-07
	Check for right values for warning tests, not just presence of a
	warning.

	* rasqal/Makefile.am:
	Don't use RASQAL_INTERNAL_LIBS except in dependencies of librasqal.la

	* utils/Makefile.am, librdf/Makefile.am, examples/Makefile.am:
	Don't use LIBRDF_INTERNAL_LIBS except in dependencies of librdf.la

	* librdf/rdf_log.h: librdf_log_level_func has a return value

	* librdf/rdf_log.c (librdf_log_simple):
	Return if error, warning messages are handled
	by the specific handlers.

	* examples/Makefile.am: Tidy up AM_*FLAGS, remove @LIBRDF_LIBS@

	* utils/Makefile.am: Remove @LIBRDF_LIBS@

	* rasqal/rasqal_internal.h: remove duplicate and broken YYDEBUG lines

	* Makefile.am: Add data to dist subdirs

	* data/dc.rdf moved from old perl dir

	* data/Makefile.am: dc.ttl

	* data/Makefile.am, data/dc.nt, data/dc.rdf, data/dc.ttl: data

	* configure.ac, Makefile.am: Added data dir

2004-05-29  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* autogen.sh, rasqal/autogen.sh, raptor/autogen.sh:
	Add --enable-maintainer-mode

	* raptor/configure.ac:
	Add check for glib-2.0 presence rather than an error barf.

	* librdf/redland.pc.in: Use LIBRDF_PKGCONFIG_LIBS

	* configure.ac: Made RASQAL_MIN_VERSION 0.9.0
	Added LIBRDF_PKGCONFIG_LIBS for redland.pc

	* librdf/redland.pc.in: Replace LIBRDF_LIBS with LIBRDF_EXTERNAL_LIBS

	* librdf/Makefile.am: Remove LIBRDF_LIBS and add LIBRDF_INTERNAL_LIBS

	* redland-src-config.in, redland-config.in: Remove LIBRDF_LIBS

	* configure.ac:
	Remove use of LIBRDF_LIBS - merge into LIBRDF_EXTERNAL_LIBS and do not
	AC_SUBST.
	Always append to LIBRDF_LIBS, LIBRDF_CPPFLAGS rather than prepend,
	append mixtures.

2004-05-28  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* configure.ac: Look for BDB in /usr/local/BerkeleyDB.$version

	* configure.ac: typo: RASQAL_CONFIG

	* raptor/tests/Makefile.am, rasqal/tests/Makefile.am,
	rasqal/rdql-testsuite/Makefile.am: Add set +e, set -e around
	multiple tests so they only fail at the end.

	* docs/Makefile.am:
	do not overwrite redland.3 if not in maintainer mode

	* librdf/Makefile.am: Use automakefile conditional MEMCMP

	* utils/Makefile.am: Use automakefile conditional GETOPT

	* configure.ac: Use automakefile conditionals MEMCMP and GETOPT

	* rasqal/configure.ac: Add flex version check, only in maintainer mode

	* rasqal/Makefile.am: Make lex and yacc rules be maintainer only.

	* raptor/configure.ac: Only check flex version in maintainer mode

	* raptor/Makefile.am: Re-order directives and tidy up.
	Make lex and yacc rules be maintainer only.

	* rasqal/configure.ac:
	Use automakefile conditionals STRCASECMP and GETOPT

	* rasqal/Makefile.am: Use automakefile conditionals STRCASECMP and
	GETOPT for conditional sources.  Re-order the directives slightly.

	* raptor/Makefile.am: Use automakefile conditionals STRCASECMP and
	GETOPT for conditional sources.

	* raptor/configure.ac:
	Use automakefile conditionals STRCASECMP and GETOPT

2004-05-27  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/configure.ac, raptor/configure.ac: check for perl

	* rasqal/Makefile.am, raptor/Makefile.am: Add fix-flex and use it

	* rasqal/fix-flex, raptor/fix-flex: Fix flex output

	* raptor/raptor_internal.h: Added raptor_libxml_free

	* raptor/raptor_parse.c (raptor_xml_parse_start,
	raptor_xml_parse_terminate): Use raptor_libxml_free to tidy up.

	* raptor/raptor_libxml.c (raptor_libxml_free):
	Added to tidy up after a parsing.

	* raptor/raptor_parse.c (raptor_xml_parse_terminate):
	Clean up sax2_element stack after
	errors.

2004-05-26  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/turtle_lexer.l: Allow _ after : in qnames.
	Make bare ':' work.

	* raptor/tests/turtle/rdf-schema.out,
	raptor/tests/turtle/rdf-schema.ttl: RDF namespace document

	* raptor/tests/turtle/rdfs-namespace.out,
	raptor/tests/turtle/rdfs-namespace.ttl: RDFS namespace

	* raptor/tests/turtle/Makefile.am:
	Added test-13, rdf-schema, rdfs-namespace

	* raptor/tests/turtle/test-13.out, raptor/tests/turtle/test-13.ttl:
	test bare :

	* raptor/turtle_parser.y: Fix RAPTOR_DEBUG args in old format.

	* raptor/tests/turtle/Makefile.am: Added test-12

	* raptor/tests/turtle/test-12.out, raptor/tests/turtle/test-12.ttl:
	test for _ after : in qnames

	* raptor/libraptor.3:
	Describe use of UTF-8 for literals and strings

	* raptor/libraptor.3: 1.3.1 changes

2004-05-25  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor.h:
	Added RAPTOR_STATIC for WIN32 when statically linking
	Fix raptor_print_statement arg s/const//

2004-05-24  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_general.c (raptor_free_memory, raptor_system_free):
	Do not return, no return value.

2004-05-21  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/tests/turtle/rdfq-results.ttl,
	raptor/tests/turtle/rdfq-results.out: Replace XML Schema namespace
	with 2001 versi

2004-05-19  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/rdfdump.c: Includes re-order, doc

	* raptor/rdfdump.c: don't do stdarg.h here - it should be in raptor.h

	* raptor/raptor.h:
	Add include for stdarg.h to get va_list for raptor_vsnprintf

	* raptor/raptor_xml.c (raptor_xml_escape_string):
	q should be an unsigned char*

	* raptor/raptor_utf8.c (raptor_unicode_char_to_utf8):
	Cast for unsigned long to unsigned char

	* raptor/raptor_parse.c (raptor_xml_start_element_handler):
	Cast for memcpy.

	* raptor/win32_config.h: patch from Jose for VC6

2004-05-18  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* Redland.i: Fake librdf_new_query taking char* not unsigned char*

	* librdf/rdf_query_rasqal.c:
	Update for renaming of librdf_query_get_result_binding_by_name to
	librdf_query_get_result_binding_value_by_name and factory equiv.

	* librdf/rdf_query.h: Renamed librdf_query_get_result_binding_by_name
	to librdf_query_get_result_binding_value_by_name
	and factory equiv.

	* librdf/rdf_query.c (librdf_query_get_result_binding_value_by_name):
	Renamed from
	librdf_query_get_result_binding_by_name

	* Redland.i: Export librdf_query class and methods.
	Export model methods librdf_model_query_as_stream,
	librdf_model_query_as_bindings

	* raptor/ntriples_parse.c (raptor_ntriples_generate_statement):
	Remove use of ntriples_parser, not used.

2004-05-15  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/configure.ac: Bumped version to 0.9.1

	* rasqal/rasqal.spec.in, raptor/raptor.spec.in: SNAP

	* rasqal/rdql-testsuite/Makefile.am:
	Improve checking works/correct against expected failures.

	* rasqal/rdql-testsuite/Makefile.am:
	Check works/correct RDQL tests against expected failures.

	* rasqal/rdql-testsuite/check-rdql: Use portable diff -u in errors

2004-05-14  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/configure.ac: 0.9.0

	* rasqal/docs/Makefile.am: Added README, README.html

	* rasqal/Makefile.am: Add RELEASE.html

2004-05-13  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_internal.h: Use positive assert enable defines.

	* configure.ac: Turn assert enable options into positive form.

	* rasqal/rasqal_literal.c: docucomments

	* rasqal/fix-groff-xhtml, raptor/fix-groff-xhtml: update for rasqal

	* rasqal/librasqal.3: updated for release

	* rasqal/rasqal.h: dead prototype

	* librdf/rdf_query_rasqal.c (rasqal_redland_bind_match):
	use redland_node_to_rasqal_literal

	* rasqal/rasqal_internal.h, rasqal/rasqal.h:
	Export rasqal_literal_as_node.

	* rasqal/rasqal_redland.c (rasqal_redland_bind_match):
	use redland_node_to_rasqal_literal

	* rasqal/rasqal_literal.c (rasqal_literal_equals):
	Boolean literals compare equal to string
	literals "true" or "false".

	* rasqal/rasqal_literal.c: Throughout - use RASQAL_CALLOC
	(rasqal_literal_as_floating): Added
	(rasqal_literal_compare): Add more debug messages.
	Promote to floating right.
	(rasqal_literal_as_node): Make a new string literal for integer,
	floating here.

	* rasqal/rdql-testsuite/check-rdql:
	Do not hack around roqet emitng integer, floating,
	Do hack around rapper/raptor 1.3.0 bug

	* rasqal/rasqal_literal.c (rasqal_literal_compare):
	In promoting comparisons, check both ways
	round before turning to next type.

	* rasqal/rasqal_raptor.c (rasqal_raptor_bind_match):
	Use rasqal_literal_as_node in setting
	bindings.

	* rasqal/rasqal_internal.h: Add rasqal_literal_as_node

	* rasqal/rasqal_literal.c (rasqal_new_string_literal,
	rasqal_literal_expand_qname): Discard language if datatype is
	given.

	* rasqal/rdql-testsuite/check-rdql:
	Turn internal integer, floating into typed literals.

2004-05-12  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/turtle_parser.y, raptor/turtle_common.h,
	raptor/ntriples_parse.c: Do not allow any language with datatype
	literals.

	* rasqal/rdql-testsuite/check-rdql: report failures

	* raptor/tests/turtle/Makefile.am: add zip, tests.zip targets

2004-05-11  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/configure.ac: Bumped version to 1.3.1

	* raptor/raptor.spec.in: Added RELEASE.html

	* raptor/Makefile.am: Added RELEASE.html

	* raptor/turtle_lexer.l: Allow - in qnames, prefix qnames.

	* raptor/tests/turtle/Makefile.am: Added test-11

	* raptor/tests/turtle/test-11.out, raptor/tests/turtle/test-11.ttl:
	- and _ in qnames, prefixes

	* configure.ac: use = not == in test

	* configure.ac: Make rasqal build internal and external.
	Add ruby test, lib dirs.

2004-05-07  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_query_rasqal.c: New error/warning handler names

	* rasqal/rasqal_query.c (rasqal_query_print):
	Don't try to print NULL sequences.

	* rasqal/docs/Makefile.am,
	rasqal/docs/api.sgml.in, rasqal/docs/build-docs,
	rasqal/docs/kernel-doc: Rasqal docs and API manual

	* rasqal/configure.ac, rasqal/Makefile.am: Added docs

	* rasqal/rasqal_query.c: docucomment

	* rasqal/rasqal_general.c:
	Rename various functions, moved from here to rasqal_query.c:
	rasqal_query_get_name, rasqal_query_get_label,
	rasqal_query_set_fatal_error_handler, rasqal_query_set_error_handler,
	rasqal_query_set_warning_handler, rasqal_query_set_feature

	* rasqal/rasqal_query.c:
	Rename various functions, moved to this rasqal_query.c:
	rasqal_query_get_name, rasqal_query_get_label,
	rasqal_query_set_fatal_error_handler, rasqal_query_set_error_handler,
	rasqal_query_set_warning_handler, rasqal_query_set_feature

	* rasqal/rasqal.h: Renames: Now rasqal_query* for the following name:
	rasqal_get_name, rasqal_get_label,
	rasqal_set_fatal_error_handler, rasqal_set_error_handler,
	rasqal_set_warning_handler, rasqal_set_feature

	* rasqal/rasqal_expr.c: Docucomments for variable class.

	* rasqal/rdql_parser.y (rasqal_rdql_query_engine_prepare):
	Handle NULL query_string.

	* rasqal/rasqal_internal.h:
	Internal: rasqal_literal_as_boolean, rasqal_literal_as_integer

	* rasqal/rasqal.h: Do not export rasqal_literal_as_boolean

	* rasqal/Makefile.am: Add rasqal_literal.c

	* rasqal/rasqal_expr.c, rasqal/rasqal_literal.c:
	Rasqal literal moved from rasqal_expr.c

	* rasqal/rasqal_expr.c: docucomment

	* rasqal/rasqal_expr.c:
	Docucomments for all literal constructors, destructors, methods,
	helpers.

	* rasqal/rasqal_expr.c: code style

	* rasqal/rasqal_query.c (rasqal_query_prepare):
	Note query_string can be NULL.

	* examples/example5.c:
	Error check model or storage failure; make new store.

	* librdf/rdf_parser_raptor.c
	(librdf_parser_raptor_generate_id_handler): Use raptor_free_memory
	to free raptor alloced id

	* librdf/rdf_query.c: Don't use uninitialised names.

	* librdf/rdf_query.c, rasqal/rasqal_query.c: docucomments

	* utils/rdfproc.c:
	Use names/values methods for query results, no need for a static array.

	* rasqal/roqet.c:
	Use names/values methods for results, no need for a static array.

	* librdf/rdf_query_rasqal.c (librdf_query_rasqal_get_result_bindings):
	Use rasqal_query_get_bindings_count.
	(librdf_query_rasqal_get_bindings_count): Added, calling
	rasqal_query_get_bindings_count.

	* librdf/rdf_query.c (librdf_query_get_bindings_count): typo

	* librdf/rdf_query.h: Added get_bindings_count factory method

	* librdf/rdf_query.h: Added librdf_query_get_bindings_count

	* librdf/rdf_query.c (librdf_query_get_bindings_count): Added.

	* rasqal/rasqal_query.c: Docucomments.
	(rasqal_query_get_bindings_count): Added

	* rasqal/roqet.c, utils/rdfproc.c: Don't use uninitialised values.

	* rasqal/roqet.c: Don't use uninitialised names, values.

	* utils/rdfproc.c:
	(query command) Don't use uninitialised names, values, count.
	Run the query(!) before trying to get results.

	* rasqal/rasqal.h: Added rasqal_query_get_bindings_count

	* rasqal/rasqal_query.c (rasqal_query_prepare):
	Free raptor-alloced memory with raptor_free_memory.
	(rasqal_query_get_bindings_count): Added.

	* raptor/raptor_sequence.c, raptor/raptor_internal.h: Add assert macros

	* utils/rdfproc.c:
	Add URI field to query arg, allow - for optional name, URI
	Handle query constructor failing.

	* librdf/rdf_query_rasqal.c (librdf_query_rasqal_error_handler,
	librdf_query_rasqal_warning_handler): Added
	(librdf_query_rasqal_init): Hook up above when initialising a new
	query.

	* librdf/rdf_log.c (librdf_log_simple):
	Too annoying to die for regular errors when debugging.

	* rasqal/roqet.c: Add list of valid inputs for -i/--input errors.

	* rasqal/rasqal_query.c: parameter naming consistency (no code changes)
	docucomments

	* Redland.i: Added librdf_statement_match

	* utils/rdfproc.c:
	Remove check here for contexts and rely on run time warnings from
	model and/or storage classes.

	* librdf/rdf_storage_list.c
	(librdf_storage_list_context_add_statement,
	 librdf_storage_list_context_remove_statement):
	Run time warning if called with a non-NULL context and contexts
	are not supported.
	(librdf_storage_list_context_serialise,
	librdf_storage_list_get_contexts): Run time warning if called
	and contexts are not supported.

	* librdf/rdf_storage_hashes.c (librdf_storage_hashes_get_contexts):
	Run time warning if called
	and contexts are not supported.

	* librdf/rdf_storage_hashes.c
	(librdf_storage_hashes_context_add_statement,
	librdf_storage_hashes_context_serialise):
	Run time warning if called and contexts are not supported.
	(librdf_storage_hashes_context_remove_statement): Run time warning
        if called with a non-NULL context and contexts are not supported.

	* librdf/rdf_model.c (librdf_model_supports_contexts):
	Added helper, internal.
	(librdf_new_model_with_options, librdf_new_model_from_model):
	Initialise supports_contexts.
	(librdf_model_context_add_statement,
	librdf_model_context_add_statements,
	librdf_model_context_remove_statement,
	librdf_model_context_remove_statements,
	librdf_model_context_as_stream,
	librdf_model_context_serialize,
	librdf_model_get_contexts): Run time warning if called and contexts
	are not supported.
	(librdf_model_find_statements_in_context): Run time warning if called
	with a non-NULL context and contexts are not supported.

	* librdf/rdf_model.h: Added supports_contexts internal field.

	* Redland.i: Added librdf_statement_equals

2004-05-06  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_query.c (main): Free model, storage

	* librdf/rdf_query.c: (main) free returned query variable values

	* examples/example5.c, utils/rdfproc.c:
	free returned query variable values

	* examples/example5.c: comments

	* librdf/rdf_parser.h:
	Deleted internal librdf_parser_error and librdf_parser_warning
	Deprecated librdf_parser_set_error and librdf_parser_set_warning.

	* librdf/rdf_parser.c (librdf_parser_error, librdf_parser_warning):
	Deleted - internal and never used.
	(librdf_parser_set_error, librdf_parser_set_warning): Deprecated,
	never worked.

	* librdf/rdf_query.c: docucomments

	* docs/api.sgml.in: remove list

	* docs/api.sgml.in:
	less doc classes; no real need for the implementation classes.
	Removed GFDL.  The docs have the same license as Redland now.

	* docs/Makefile.am:
	less doc classes; no real need for the implementation classes.

	* docs/Makefile.am: Added query_rasqal for docs

	* librdf/rdf_query.c: Added assertions

	* librdf/rdf_query_rasqal.c:
	Renamed librdf_query_rasqal_get_result_binding to
	librdf_query_rasqal_get_result_binding_value.
	Added librdf_query_rasqal_get_result_binding_name

	* librdf/rdf_query.h:
	Renamed librdf_query_get_result_binding to
	librdf_query_get_result_binding_value.
	Added librdf_query_get_result_binding_name
	Changed factory methods to match.

	* librdf/rdf_query.c (librdf_query_get_result_binding_value):
	Renamed from
	librdf_query_get_result_binding.
	(librdf_query_get_result_binding_name): Added.

	* rasqal/rasqal.h: Renamed rasqal_query_get_result_binding to
	rasqal_query_get_result_binding_value.  Added
	rasqal_query_get_result_binding_name

	* rasqal/rasqal_query.c (rasqal_query_get_result_binding_value):
	Renamed from
	rasqal_query_get_result_binding. Fix dubious offset checking.
	(rasqal_query_get_result_binding_name): Added.

	* librdf/rdf_query_triples.h: deleted, not needed

	* librdf/rdf_query.c: docucomment

2004-05-05  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_query.c: add vars

	* librdf/rdf_query.c (main): Added a real query language test.

	* utils/rdfproc.c: Added query, use of query with variable bindings

	* librdf/rdf_model.h:
	Added librdf_model_query_as_stream, librdf_model_query_as_bindings,
	librdf_model_query_string

	* librdf/rdf_model.c (librdf_model_query_as_stream,
	librdf_model_query_as_bindings): Added
	(librdf_model_query_string): Deprecated

	* librdf/rdf_storage.h:
	Added librdf_storage_query_as_stream, librdf_storage_query_as_bindings

	* librdf/rdf_storage.c
	(librdf_storage_query_as_stream,librdf_storage_query_as_bindings):
	Added

	* librdf/rdf_query.h: Substantially changed.
	open, close methods gone.
	Added all the binding access methods from rasqal.

	* librdf/rdf_query.c: Substantially changed.
	open, close gone.
	(librdf_query_run_as_stream,librdf_query_run_as_bindings): Added
	Added all the binding access methods from rasqal.

	* librdf/rdf_query_rasqal.c: Querying with Rasqal

	* librdf/rdf_model_storage.c
	(librdf_model_storage_query_as_stream,
	librdf_model_storage_query_as_bindings): Added.

	* examples/Makefile.am: Added example5

	* examples/example5.c: query example

	* librdf/rdf_query_triples.c: Remove open, close methods.
	Rename run method.

	* librdf/rdf_init.h: added query_factories to world

	* librdf/Makefile.am:
	Removed rdf_query_triples.h, added rdf_query-rasqal.c

	* rasqal/rasqal.h:
	Added rasqal_query_get_user_data and rasqal_query_set_user_data

	* rasqal/rasqal_query.c
	(rasqal_query_get_user_data,rasqal_query_set_user_data): Added

	* rasqal/rasqal_query.c: docucumments

	* rasqal/rasqal.spec.in: date

	* rasqal/rasqal.spec.in, rasqal/rasqal.pc.in, rasqal/configure.ac:
	Use new @RAPTOR_MIN_VERSION@ subst.

	* rasqal/Makefile.am: Install roqet

	* rasqal/Makefile.am: Added roqet.1 and roqet.html, add fix-groff-xhtml

	* rasqal/roqet.1: roqet man page

	* configure.ac: make PHP_INCLUDES even without --with-php (ie PHP)

	* rasqal/configure.ac: SUBST with_raptor

	* rasqal/rasqal-src-config.in: sigh, rasqal uses raptor

	* rasqal/rasqal-src-config.in, redland-src-config.in:
	One more remaining bad raptor cut'n' paste

	* rasqal/rdql-testsuite/Makefile.am: Add check-rdql to dist

	* rasqal/configure.ac: Added build summary.

	* rasqal/rasqal_raptor.c: (raptor_statement_as_rasqal_triple) C99.

	* rasqal/configure.ac: Try to find raptor sources better.

	* configure.ac: assign rasqal_dir for SD_PRE

	* Makefile.am: Added ChangeLog.4

	* librdf/rdf_internal.h: Removed LIBRDF_DEBUG macros

	* librdf/rdf_init.h:
	Removed librdf_error, librdf_warning as no longer used.

	* librdf/rdf_log.c (librdf_log_simple):
	When debugging, all errors are fatal.
	(librdf_error, librdf_warning): Removed, no longer used.

	* librdf/rdf_stream.c, librdf/rdf_storage_tstore.c,
	librdf/rdf_storage_list.c, librdf/rdf_storage_hashes.c,
	librdf/rdf_storage.c, librdf/rdf_statement.c,
	librdf/rdf_serializer_rdfxml.c, librdf/rdf_serializer_raptor.c,
	librdf/rdf_query.c, librdf/rdf_parser_raptor.c, librdf/rdf_node.c,
	librdf/rdf_model.c, librdf/rdf_list.c, librdf/rdf_hash_memory.c,
	librdf/rdf_hash_bdb.c, librdf/rdf_hash.c, librdf/rdf_digest.c:
	Replace LIBRDF_DEBUG macro uses with librdf_log

	* librdf/redland.spec.in, librdf/redland.pc.in, configure.ac:
	SUBST raptor, rasqal min versions and use in build, packaging files.

	* librdf/redland.pc.in: added rasqal

	* redland-src-config.in: more with_rasqal fixes

	* configure.ac: SUBST with_rasqal

	* redland-src-config.in, librdf/redland.spec.in: added rasqal

	* configure.ac: report rasqal source in summary

	* librdf/Makefile.am, configure.ac: added rasqal

	* Makefile.am: Added rasqal

2004-05-04  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/libraptor.3: rewordings

	* rasqal/rasqal_raptor.c, rasqal/rasqal_expr.c:
	raptor now exports raptor_xml_literal_datatype_uri_string

	* raptor/raptor_general.c, raptor/raptor.h:
	Export raptor_xml_literal_datatype_uri_string

	* raptor/raptor_internal.h:
	raptor_xml_literal_datatype_uri_string now exported.

	* raptor/libraptor.3: Added 1.3.0 items

	* raptor/raptor_general.c (raptor_parse_uri_with_connection):
	Document the Accept: header malarky.
	Only send it if connection is NULL.  Use Accept: MIME-TYPE,*/*;q=0.1

	* raptor/raptor_www_curl.c (raptor_www_curl_fetch):
	append to slist right

	* raptor/raptor_general.c (raptor_parse_uri_with_connection):
	Send "Accept: MIME-TYPE ;*/*"
	to prefer the specified one rather than accept only that.

	* raptor/raptor.h: Added raptor_get_mime_type

	* raptor/raptor_general.c (raptor_parse_uri_with_connection):
	Set Accept header with mime type
	of this syntax if there is one

	* raptor/raptor_www.c (raptor_www_set_http_accept):
	Make accept value overwrite \0 from
	Accept:

	* raptor/configure.ac: make raptor.rdf

	* raptor/turtle_parser.y, raptor/raptor_www_libxml.c,
	raptor/raptor_parse.c, raptor/ntriples_parse.c: Fixes for c++

	* raptor/Makefile.am: added raptor.rdf.in

	* raptor/raptor.rdf.in: DOAP

2004-05-02  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/turtle_parser.y:
	Add xml_literal_datatype_uri to parser context.
	(raptor_turtle_parse_init,raptor_turtle_parse_terminate): use above
	(raptor_turtle_generate_statement): Use above to remove language
	from all literals except xml literals.

	* raptor/turtle_common.h:
	Add xml_literal_datatype_uri to parser context.

	* raptor/ntriples_parse.c:
	Add xml_literal_datatype_uri to parser context.
	(raptor_ntriples_parse_init,raptor_ntriples_parse_terminate): use
	above
	(raptor_ntriples_generate_statement): Use above to remove language
	from all literals except xml literals.

	* raptor/raptor_identifier.c (raptor_identifier_print):
	Use raptor_xml_literal_datatype_uri_string
	and save a string.

2004-04-29  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/rdfdump.c (main):
	Use raptor_free_memory to free memory allocated in libraptor.

	* raptor/raptor_www_libxml.c (raptor_www_libxml_fetch):
	Free content type using libxml's xmlFree
	since it was allocated there.

	* raptor/raptor_www_libxml.c, raptor/raptor_www_curl.c
	(raptor_www_libxml_fetch): Make headers for User-Agent: and/or
	Accept: if they were set in the raptor_www.

	* raptor/raptor_www.c (raptor_www_set_http_accept): Added.

	* raptor/raptor_internal.h: Added http_accept to raptor_www

	* raptor/raptor.h: Added raptor_www_set_http_accept

2004-04-27  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* Redland.i: Added output typemap for ruby returning char NULL.
	Added some more model api calls used by ruby-rdf

2004-04-25  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_node.c (librdf_node_get_blank_identifier): Assert typo.

2004-04-15  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_general.c (raptor_guess_parser_name):
	use strrchr to find *last* .

2004-04-14  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_node.c (librdf_node_to_counted_string):
	Encode language and datatype for
	literal strings.

	* raptor/raptor_sequence.c (raptor_new_sequence): Zap sequence field.

	* raptor/raptor_xml_writer.c (raptor_xml_writer_cdata):
	Do not copy more bytes than allowed.

	* raptor/Makefile.am: Added raptor_expat.c

	* raptor/raptor_parse.c: Export some expat-only handlers:
	raptor_xml_unparsed_entity_decl_handler,
	raptor_xml_external_entity_ref_handler.
	(raptor_xml_parse_init): Do not call expat init code here.
	(raptor_xml_parse_start): Call new aptor_expat_init to initialise
	parser state.

	* raptor/raptor_internal.h: Added RAPTOR_XML_EXPAT only exports
	including raptor_expat_init prototype.

	* raptor/raptor_expat.c: raptor expat parser

2004-04-13  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor.h: Added xsd and owl namespace URIs

	* raptor/raptor_namespace.c (raptor_namespaces_init):
	Define xsd, owl when defaults is 2+

2004-04-12  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/Makefile.am:
	Apply local cppflags to AM_CFLAGS, for building tests

2004-04-11  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_parse.c:
	(raptor_xml_parse_start) Free expat/libxml contexts from an
	earlier parsing to ensure resetting of state

	* librdf/rdf_parser.c (main):
	Need to init node, concepts before parser.

	* Redland.i: set default args on librdf_model_load

	* Redland.i: Updated to use librdf_test_error and
	librdf_test_warning for testing errors.

	* librdf/rdf_log.h, librdf/rdf_log.c
	(librdf_test_error,librdf_test_warning): Added for testing errors.

	* Redland.i, librdf/rdf_model.h: Added librdf_model_load

	* librdf/rdf_model.c (librdf_model_load):
	Added, using parser guessing via
	raptor_guess_parser_name if no name is given.

	* librdf/rdf_parser_raptor.c:
	Move raptor_new_parser to the init factory method rather than making
	a new one for each parsing.  Add a raptor_parser* rdf_parser field
	to the context structure.
	(librdf_parser_raptor_get_feature): Call raptor_get_feature if it is
	not known here.
	(librdf_parser_raptor_set_feature): Call raptor_set_feature.

	* raptor/raptor_stringbuffer.c
	(raptor_stringbuffer_prepend_string_common): Added
	(raptor_stringbuffer_prepend_counted_string,
	raptor_stringbuffer_prepend_string): Added, implemented by above
	internal function.
	(main): Added tests for prepending.

	* raptor/raptor.h: Add RAPTOR_API for newly exported functions.
	Add raptor_stringbuffer_prepend_counted_string,
	raptor_stringbuffer_prepend_string

	* raptor/raptor_stringbuffer.c: (main) printf arg

	* raptor/raptor_internal.h, raptor/raptor.h:
	Moved raptor_stringbuffer to public API

	* raptor/raptor_stringbuffer.c
	(raptor_stringbuffer_append_stringbuffer): Added.
	(main): Updated test code for
	raptor_stringbuffer_append_stringbuffer

2004-04-10  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_general.c, raptor/raptor.h (raptor_guess_parser_name):
	Added new public class method.
	(raptor_new_parser_for_content): Now uses above.

	* raptor/raptor_internal.h, raptor/raptor.h:
	Move raptor_unicode_char_to_utf8, raptor_utf8_to_unicode_char to
	public API.

	* raptor/tests/Makefile.am: fix result codes for split off NFC warnings

	* raptor/tests/Makefile.am:
	Split off NFC warnings so they can fail noisily when glib isn't
	present to do the check.

	* raptor/rapper.1:
	Document -g/--guess flag to guess the parser to use from the
	identifier (URI or file name).

	* raptor/rdfdump.c:
	Added -g/--guess flag to use raptor_new_parser_for_content guessing
	the parser to use from the identifier (URI or file name).

	* raptor/turtle_parser.y, raptor/raptor_rss.c,
	raptor/raptor_parse.c, raptor/ntriples_parse.c: Added scoring
	factory method recognise_syntax for rdfxml, ntriples, rss, turtle
	parsers.

	* raptor/raptor_internal.h:
	Added parser scoring factory method recognise_syntax.

	* raptor/raptor_general.c (raptor_new_parser_for_content):
	Added, guessing which parser to
	instance using scoring factory method recognise_syntax.

	* raptor/raptor.h: Added raptor_new_parser_for_content

2004-04-10  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_sequence.c: cast for c++

2004-04-09  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_parse.c: Removed use of raptor_print_statement_detailed

	* raptor/raptor_internal.h:
	Removed raptor_print_statement_part_as_ntriples, made static

	* raptor/raptor.h: Deprecate raptor_print_statement_detailed

	* raptor/raptor_general.c (raptor_print_statement_detailed):
	Restored, was in raptor.h but useless.

	* raptor/raptor_general.c: dates, docucomments
	(raptor_print_statement_detailed): Deleted - never publically
	documented or used.

2004-04-09  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_uri.c, librdf/rdf_storage_tstore.h,
	librdf/rdf_storage_tstore.c, librdf/rdf_storage_mysql.h,
	librdf/rdf_storage_mysql.c, librdf/rdf_storage_list.h,
	librdf/rdf_storage_list.c, librdf/rdf_storage_hashes.h,
	librdf/rdf_storage_hashes.c, librdf/rdf_storage_file.c,
	librdf/rdf_storage.h, librdf/rdf_storage.c,
	librdf/rdf_serializer.c, librdf/rdf_query_triples.h,
	librdf/rdf_query_triples.c, librdf/rdf_query.h,
	librdf/rdf_query.c, librdf/rdf_parser.c, librdf/rdf_node.c,
	librdf/rdf_model_storage.h, librdf/rdf_model_storage.c,
	librdf/rdf_model.h, librdf/rdf_model.c, librdf/rdf_internal.h,
	librdf/rdf_hash.c, librdf/rdf_digest.c, librdf/rdf_concepts.c: Add
	world field to all LIBRDF_FATAL1 calls.  Add world parameter to
	all factory registrations.

	* librdf/rdf_log.h: Added more log facilities.

	* librdf/rdf_digest.h: Added world field

	* librdf/rdf_internal.h, librdf/rdf_query.c: zap LIBRDF_FATAL2

2004-04-08  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/Makefile.am:
	raptor_sequence_test needs to link with libraptor.la

	* raptor/turtle_parser.y: rename
	raptor_free_handler,raptor_print_handler -> as raptor_sequence...

	* raptor/raptor.h, raptor/raptor_internal.h: Move sequence class
	to public api.

	* raptor/raptor_sequence.c: rename
	raptor_free_handler,raptor_print_handler -> as raptor_sequence...
	(raptor_sequence_print_uri): Added.
	(raptor_sequence_set_print_handler): Added.

	* raptor/raptor_internal.h, raptor/raptor.h:
	Export raptor_vsnprintf public.

	* configure.ac: require raptor 1.3.0

	* librdf/rdf_serializer_rdfxml.c
	(librdf_serializer_rdfxml_raptor_error_handler): Just pass message
	on to librdf_log_simple as a single string, don't add a prefix.

	* librdf/rdf_parser_raptor.c:
	(librdf_parser_raptor_error_handler,
	librdf_parser_raptor_warning_handler): Just pass message on to
	librdf_log_simple with locator, don't add a prefix.

	* librdf/rdf_storage_mysql.c, librdf/rdf_storage_file.c,
	librdf/rdf_query_triples.c, librdf/rdf_hash_bdb.c: Replace
	librdf_error and some LIBRDF_ERROR2 with librdf_log.

	* librdf/redland.h: Compiling with Redland requires raptor.h

	* librdf/librdf.h: Use rdf_log.h

	* librdf/rdf_init.h: Use rdf_log structs inside world.
	Added librdf_world_set_logger.
	Deprecated older internal librdf_error/librdf_warning.

	* librdf/rdf_init.c: Moved error/warning code to rdf_log.c/.h
	(librdf_world_set_logger): Added.

	* librdf/Makefile.am: Added rdf_log.c rdf_log.h

	* librdf/rdf_log.c, librdf/rdf_log.h: RDF logging

	* Redland.i:
	Add typemap for ruby inStrOrNull for certain functions that can take
	an optional string.  Additionally, add default parameters for those
	functions: librdf_new_node_from_literal,
	librdf_new_node_from_typed_literal and
	librdf_new_node_from_blank_identifier.

2004-04-06  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/turtle_parser.y (turtle_parse): Remove un-necessary cast.

	* raptor/turtle_parser.y (turtle_parse): Free lexer

2004-04-05  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/rdfdump.c:
	Added HELP_PAD to format long help description over multiple lines.

	* raptor/TODO.html: docs

2004-03-30  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/tests/turtle/test-00.out: Updated base uri

	* raptor/tests/turtle/Makefile.am: Added rdfq-results

	* raptor/tests/turtle/rdfq-results.out,
	raptor/tests/turtle/rdfq-results.ttl: RDF Query result set example
	from
	http://www.w3.org/2003/03/rdfqr-tests/recording-query-results.html

2004-03-27  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_general.c, raptor/turtle_parser.y, raptor/rdfdump.c:
	casts for C++

	* utils/Makefile.am: redland-db-upgrade doesn't take gnu opts

	* configure.ac:
	Do not -Wall automake, override is needed in language dirs.
	List specific warnings.

	* configure.ac, autogen.sh: Use some AM_INIT_AUTOMAKE options.
	Require automake1.7, which requires autoconf 2.54

	* redland-src-config.in, redland-config.in:
	Support --help, emit to stdout and exit 0.

	* raptor/configure.ac, raptor/autogen.sh:
	Use some AM_INIT_AUTOMAKE options.
	Require automake1.7, which requires autoconf 2.54

	* raptor/examples/Makefile.am:
	Drop $(shell .. ) which is not portable between makes

	* raptor/raptor-src-config.in, raptor/raptor-config.in:
	emit --help usage to stdout

	* raptor/raptor-src-config.in, raptor/raptor-config.in:
	Support --help and exit 0.

2004-03-26  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/rapper.1: Document -f

	* raptor/tests/Makefile.am: Add bad-21

	* raptor/tests/bad-21.rdf:
	Check non-namespaced attributes on a property are reported

	* raptor/raptor_parse.c (raptor_xml_start_element_handler):
	Check element, attributes for
	non-namespaces once we know we are in rdf processing.
	Check all named attributes for lack of namespace, error and zap
	if found.
	(raptor_process_property_attributes): Skip any deleted attributes.

2004-03-25  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/tests/Makefile.am: Added warn-05, warn-06

	* raptor/tests/warn-05.out, raptor/tests/warn-06.out,
	raptor/tests/warn-05.rdf, raptor/tests/warn-06.rdf: Check for
	warning for unknown rdf namespaced property element, attributes

	* raptor/raptor_parse.c (raptor_process_property_attributes):
	Generate an error for forbidden
	rdf names, warning for unknown rdf names.

	* raptor/raptor_parse.c:
	Merged rdf_attr_info into rdf_syntax_terms_info.
	Now we can check for unknown rdf: names
	(raptor_forbidden_nodeElement_name,
	raptor_forbidden_propertyElement_name,
	raptor_forbidden_propertyAttribute_name): Return -1 on unknown name.
	(raptor_start_element_grammar): Generate an error for forbidden
	rdf names, warning for unknown rdf names.

	* raptor/tests/Makefile.am: Added warn-04

	* raptor/tests/warn-04.out, raptor/tests/warn-04.rdf:
	Check for warning for unknown rdf namespaced node element

	* raptor/tests/turtle/Makefile.am, raptor/tests/Makefile.am:
	fix grep for Warning output

	* raptor/raptor_general.c, raptor/raptor.h:
	Added raptor_free_memory to dealloc memory returned by raptor
	functions - some systems need this due to having multiple heaps.

	* raptor/raptor_general.c (raptor_default_generate_id_handler): doh

	* raptor/raptor_general.c (raptor_default_generate_id_handler):
	Rework not to use tmpid before
	initialising it.

	* raptor/raptor_general.c (main): Free returned uri

	* raptor/raptor.h: Added raptor_feature_from_uri

	* raptor/Makefile.am: Added raptor_general_test

	* raptor/raptor_general.c (raptor_feature_from_uri):
	Turn a feature URI into a feature number.
	(main): Added, testing feature enumerations.

	* raptor/rdfdump.c: note feature values in -f help

	* raptor/rdfdump.c: More help message tidying.

	* raptor/rdfdump.c:
	Alter HELP_TEXT macro so short arg isn't auto-quoted.
	Use this to add short option options arg to help.

2004-03-24  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_general.c (raptor_default_generate_id_handler):
	Don't bump default genid
	counter when a user_bnodeid is present.

	* raptor/rdfdump.c:
	Allow setting feature optional values -f NAME=VALUE (integer).

	* raptor/raptor_general.c, raptor/raptor.h:
	Use raptor_feature type for enumeration calls.

	* raptor/raptor_general.c: Tidy feature labels

	* raptor/rdfdump.c: Tidy -f help message.

	* raptor/rdfdump.c:
	Re-ordered long_options to be alphabetical by option char.
	Added -f/--feature FEATURE to set a parser feature.
	With the value 'help', lists them all using raptor_features_enumerate.

	* raptor/raptor.h: Added raptor_get_feature, raptor_features_enumerate.
	raptor_set_feature gets a return value.

	* raptor/raptor_general.c (raptor_set_feature):
	Delete docs, now has an API.  Return a failure value.
	raptor_features_list - static added.
	(raptor_features_enumerate): Added, to allow returning
	of parser feature name, URI and/or label.
	(raptor_get_feature): Added.

2004-03-23  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/TODO.html: Add turtle use of raptor_generate_id

	* raptor/turtle_parser.y (blank):
	Use raptor_generate_id when a blank identifier name is
	given, to allow application to change it.

2004-03-21  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/tests/turtle/test-10.out,
	raptor/tests/turtle/test-09.out, raptor/turtle_parser.y: Make
	Turtle integers emit xsd:integer

2004-03-19  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_parse.c: Twice.

	* raptor/raptor_parse.c: Remove FIXME for other rdf:parseType
	values - just fall through to Literal

	* raptor/raptor_parse.c: FIXME not relevant.

	* raptor/ntriples_parse.c (raptor_ntriples_generate_statement):
	Kill a FIXME, fail with an error on bad rdf:_n property.

	* raptor/tests/Makefile.am: Added bad-06.nt

	* raptor/tests/bad-06.nt: bad rdf:_n in ntriples

2004-03-18  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/turtle_parser.y: Added INTEGER_LITERAL.
	Turn it into a xsd:nonNegativeInteger

	* raptor/turtle_lexer.l: Added INTEGER_LITERAL.

	* raptor/tests/turtle/Makefile.am: Added test-09 test-10

	* raptor/tests/turtle/test-09.out,
	raptor/tests/turtle/test-09.ttl, raptor/tests/turtle/test-10.out,
	raptor/tests/turtle/test-10.ttl: Integer literal tests

	* raptor/tests/Makefile.am, raptor/Makefile.am:
	Ensure rapper is up-to-date and built before tests are run.

2004-03-16  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_parser_raptor.c, librdf/rdf_parser.c: docs

2004-03-15  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/tests/warn-03.out, raptor/tests/warn-03.rdf:
	Added warn-03 warning not dieing on NFC in XML literals

	* raptor/tests/Makefile.am: Added warn-03

	* raptor/raptor_parse.c (raptor_end_element_grammar):
	For NFC problems in an XML literal,
	take notice of feature_non_nfc_fatal which defaults to warning,
	rather than given an error.

2004-03-10  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/redland.pc.in: Use -lrdf (patch from Curtis Hovey)

2004-02-26  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* redland-config.in: Use LIBRDF_VERSION_DECIMAL

	* configure.ac: Subsitute LIBRDF_VERSION_DECIMAL

	* raptor/tests/turtle/Makefile.am: Added bad-04.ttl

	* raptor/tests/turtle/bad-04.ttl: Check , in collection items fails

	* raptor/tests/turtle/test-07.ttl: Remove , between items - forbidden.

	* raptor/turtle_parser.y (objectList):
	Remove optional commas for triple objects.
	(itemList): Added with no commas.
	(collection): Use itemList not objectList.

	* raptor/tests/turtle/Makefile.am: remove test-09.ttl

	* raptor/tests/turtle/test-09.out, raptor/tests/turtle/test-09.ttl:
	Comma is required or not in collections, not optional

2004-02-24  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor.spec.in: Export library la files

	* raptor/turtle_parser.y (objectList):
	Allow optional commas in lists of objects - such as in
	all triple objects and collections.

	* raptor/tests/turtle/test-09.out, raptor/tests/turtle/test-09.ttl:
	Added test for optional comms in a collection

	* raptor/tests/turtle/Makefile.am: Added test-09.ttl

	* configure.ac: Bumped version to 0.9.17

	* Snapshotted redland_0_9_16 for 0.9.16 release (on branch
	redland_0_9_15-patches)

	* RELEASE.html, NEWS.html:
	Updated to 0.9.16 (from CVS branch redland_0_9_15-patches)

	* librdf/librdf.h, raptor/raptor.h: Add stdio.h

2004-02-23  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* RELEASE.html, NEWS.html: Updates for 0.9.16

	* configure.ac: Bumped version to 0.9.16

	* raptor/raptor.h: Add stdio.h

	* librdf/rdf_uri.h: Remove #include <rdf_digest.h>
	Make librdf_uri_get_digest internal.

	* librdf/rdf_node.h: Make librdf_node_get_digest internal.

	* librdf/librdf.h: Add stdio.h

	* redland-src-config.in: Make --run not discard spaces in arguments.

	* redland-src-config.in: Don't destroy whitespace in args with --run

	* librdf/rdf_uri.h:
	Remove include rdf_digest.h - an internal header, should not be called
	from a public one.
	Make librdf_uri_get_digest internal.

	* librdf/rdf_node.h: Make librdf_node_get_digest internal.

2004-02-19  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/n3_lexer.l, raptor/turtle_lexer.l (main):
	Don't re-reset the scanner to it's address.

	* raptor/n3_lexer.l, raptor/turtle_lexer.l: Remove RAPTOR_IN_REDLAND

	* raptor/turtle_parser.y (main): Use lineno.

	* raptor/turtle_parser.y: comment

	* INSTALL.html: No expat shipped.

	* INSTALL.html: Try to improve --with-LANGUAGE args docs

2004-02-16  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* python/RDF.py (Node.__init__): Use ._reduri for datatype uri arg

2004-02-02  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* perl/Makefile.am: fix test-perl

	* perl/Makefile.am: delete first test-perl

	* Redland.i (librdf_call_perl_message):
	Remove ENTER / LEAVE from perl - since
	swig now undefines ENTER.
	Add %newobject for all constructors and methods returning new
	objects - all returning librdf_stream, librdf_biterator,
	librdf_node.

	* docs/Makefile.am: Add api.html and fragments

	* docs/api.html.in: Skeleton html API manual

	* librdf/rdf_stream.c, librdf/rdf_storage_mysql.c,
	librdf/rdf_parser_raptor.c, librdf/rdf_node.c, librdf/rdf_model.c,
	librdf/rdf_iterator.c, librdf/rdf_init.c, librdf/rdf_heuristics.c:
	Docucomment fixes - missing args, renamed args.

	* docs/kernel-doc: Update to kernel-doc 2003-12-18

2004-02-01  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_stream.c, librdf/rdf_statement.c,
	librdf/rdf_iterator.c: Note explicitly that iterator/stream return
	SHARED pointers to the current object(or statement), context node

2004-01-31  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* configure.ac: Bumped version to 0.9.16

	* Snapshotted redland_0_9_15 for 0.9.15 release
	
	* redland-src-config.in: add raptor-config libs dir if building
	against system raptor

	* redland-src-config.in:
	Set library paths search, don't delete any existing ones.

	* tcl/Makefile.am ruby/Makefile.am, python/Makefile.am,
	php/Makefile.am, perl/Makefile.am, java/Makefile.am,
	csharp/Makefile.am: Use redland-src-config --run COMMAND to run
	test programs with the shared libraries built in the source tree.

	* redland-src-config.in:
	Add --run COMMAND to run programs with the shared libraries
	built in the source tree.

	* librdf/rdf_parser_raptor.c (librdf_parser_raptor_constructor):
	Use raptor_syntaxes_enumerate.

	* python/Makefile.am: PYTHON_INCLUDES

	* configure.ac: Improve python includes, libs checking.
	Report what's found.

2004-01-30  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* utils/Makefile.am, raptor/Makefile.am: deps

	* raptor/fix-groff-xhtml: words

	* raptor/rapper.1: fix changelog

	* raptor/Makefile.am: Make rapper.html

	* raptor/fix-groff-xhtml: Fix to strict

	* utils/Makefile.am: Use fix-groff-xhtml in the raptor src

	* librdf/rdf_storage_tstore.c: Switch to use option database, not db.

	* utils/Makefile.am: Added rdfproc.html fix-groff-xhtml

	* utils/rdfproc.1: fix storage args urls

	* raptor/rapper.1: urls

	* docs/Makefile.am: Added storage.html

	* librdf/rdf_hash_bdb.c (librdf_hash_bdb_open):
	Check identifier is not NULL.

	* librdf/redland.spec.in: Build with mysql, without threestore,
	  Update deps, perl >=5.8.0, python >=2.2.0, require Raptor 1.2.0+

	* librdf/redland.spec.in: Fix install for python, remove setup.py

	* python/setup.cfg, python/setup.py: Junk distutils

	* python/Makefile.am: Junk distutils.

	* configure.ac: Get python_include, python_lib and substitute.

2004-01-29  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* java/org/librdf/redland/Model.java (findStatements):
	Added with context_node.
	(getContexts): Added.

	* docs/redland.pod: Updated
	Model: Added librdf_model_find_statements_in_context,
	librdf_model_find_statements_with_options, librdf_model_get_contexts,
	librdf_model_get_feature, librdf_model_set_feature.
	Parser: Changed librdf_parser_get_feature, librdf_parser_set_feature
	args to nodes.
	Serializer: Added, was missing.

2004-01-25  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* utils/rdf-digest.c, utils/rdf-load.c: removed rdf-digest rdf-load

	* utils/Makefile.am: Remove rdf-load rdf-digest

	* librdf/rdf_storage_file.c (librdf_storage_file_init): Cast for URI.

	* librdf/rdf_storage_hashes.c
	(librdf_storage_hashes_get_contexts_get_method): World in error arg.

	* librdf/rdf_storage_list.c
	(librdf_storage_list_get_contexts_get_method): World in error arg.

	* configure.ac: Added --disable-assert and --disable-assert-messages to
	prevent (default) compilation of assertion code and outputing
	of messages when the assertions fail.

	* librdf/rdf_internal.h:
	Made assertions print out, but not abort in standard compile.
	Added LIBRDF_DISABLE_ASSERT_MESSAGES to prevent the output code.
	Added LIBRDF_DISABLE_ASSERT to prevent the assertions entirely.

	* librdf/rdf_storage_tstore.c: Use storage usage tracking.
	(librdf_storage_tstore_serialise,
	librdf_storage_tstore_serialise_finished): Add/remove storage usage.
	(librdf_storage_tstore_find_statements,
	librdf_storage_tstore_find_finished): Add/remove storage usage.

	* librdf/rdf_storage_mysql.c: Use storage usage tracking.
	(librdf_storage_mysql_find_statements_with_options,
	librdf_storage_mysql_find_statements_in_context_finished): Add/remove
	storage usage.
	(librdf_storage_mysql_get_contexts,
	librdf_storage_mysql_get_contexts_finished): Add/remove storage usage.

	* librdf/rdf_storage_list.c: Use storage usage tracking.
	(librdf_storage_list_serialise,
	librdf_storage_list_serialise_finished): Add/remove storage usage.
	(librdf_storage_list_context_serialise,
	librdf_storage_list_context_serialise_finished): Add/remove
	storage usage.
	(librdf_storage_list_get_contexts_finished,
	librdf_storage_list_get_contexts): Add/remove storage usage.

	* librdf/rdf_storage_hashes.c: Use storage usage tracking.
	(librdf_storage_hashes_serialise_common,
	librdf_storage_hashes_serialise_finished): Add/remove storage usage.
	(librdf_storage_hashes_node_iterator_finished,
	librdf_storage_hashes_node_iterator_create): Add/remove storage usage.
	(librdf_storage_hashes_context_serialise,
	librdf_storage_hashes_context_serialise_finished): Add/remove
	storage usage.
	(librdf_storage_hashes_get_contexts,
	librdf_storage_hashes_get_contexts_finished): Add/remove storage
	usage.

	* perl/lib/RDF/Redland/Storage.pm, perl/lib/RDF/Redland/Model.pm
	(DESTROY): Remove debug message fixme.

	* librdf/rdf_model_storage.c (librdf_model_storage_create,
	librdf_model_storage_destroy): Add and release a reference to the
	used storage.

	* librdf/rdf_storage.h: Add usage tracking to librdf_model.
	Added librdf_storage_add_reference, librdf_storage_remove_reference

	* librdf/rdf_storage.c: Add usage tracking.
	(librdf_new_storage_from_storage,librdf_new_storage_from_factory): Set
	usage to 1 on creation.
	(librdf_free_storage): Decrement usage, free if 0.
	(librdf_storage_add_reference,librdf_storage_remove_reference): Added.
	(librdf_storage_stream_to_node_iterator_finished,
	librdf_storage_node_stream_to_node_create); Add storage usage tracking.

	* librdf/rdf_model.h: Add usage tracking to librdf_model.
	Added librdf_model_add_reference, librdf_model_remove_reference

	* librdf/rdf_model.c: Add usage tracking.
	(librdf_new_model_with_options,librdf_new_model_from_model): Set
	usage to 1 on creation.
	(librdf_free_model): Decrement usage, free if 0.
	(librdf_model_add_reference,librdf_model_remove_reference): Added.

	* raptor/raptor_general.c (raptor_delete_parser_factories):
	Free alias if it was set.

2004-01-24  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* configure.ac: RAPTOR_MIN_VERSION=1.2.0

	* Makefile.am: Add Changelog.1-3 to dist

	* raptor/rdfdump.c:
	Don't print (default) when listing valid args for -i

	* raptor/rdfdump.c:
	Use raptor_syntax_name_check to check name; don't make/destroy a
	parser.

	* raptor/raptor_general.c (raptor_syntax_name_check):
	Added, to check names.

	* raptor/raptor.h: Added raptor_syntax_name_check

	* raptor/rdfdump.c: Make -i try to make a parser, don't hardcode names.

	* raptor/rdfdump.c: Use raptor_syntaxes_enumerate in -i error

	* raptor/rdfdump.c: Use raptor_syntaxes_enumerate in usage -i help

	* raptor/rapper.1: Updated to mention Turtle.

	* raptor/configure.ac: Bumped version to 1.3.0

	* raptor/libraptor.3: Updated for 1.2.0

	* librdf/rdf_storage_mysql.c:
	Change schema. Table Literals, column Language remove default ''

	* librdf/rdf_storage_mysql.c:
	Change schema. Table Literals, column Language varchar(6) to text.

2004-01-22  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_model.c (librdf_model_get_source,
	librdf_model_get_arc, librdf_model_get_target): Fail if iterator
	returns NULL.

	* raptor/configure.ac: words

	* raptor/configure.ac:
	Use AC_PROG_LEX and handle when there is no lex or flex gracefully.
	AM_PROG_LEX set LEX to a value that caused odd configure output.

2004-01-21  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* configure.ac: If /sw/bin, add to END of PATH for OSX

2004-01-20  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* utils/rdfproc.c:
	Added match command, doing a match-substring search using the model
	find_statements with that option.

	* librdf/rdf_storage_mysql.c: Literal matching seems to be working.

	* librdf/rdf_storage_mysql.c:
	Added basic (LIKE) literal searching when option match-substring=true

	* librdf/rdf_storage_mysql.c
	(librdf_storage_mysql_find_statements_with_options): Added, making
	this the general query method renamed from
	librdf_storage_mysql_find_statements_in_context, not using the
	options just yet.

	* librdf/rdf_model_storage.c
	(librdf_model_storage_find_statements_with_options): Added,
	passing it through to the model storage.

	* librdf/rdf_model.c (librdf_model_find_statements_with_options):
	Added, optional.

	* librdf/rdf_model.h: Added factory method find_statements_with_options
	Added librdf_model_find_statements_with_options
	Added option LIBRDF_MODEL_FIND_OPTION_MATCH_SUBSTRING_LITERAL

	* librdf/rdf_storage.c (librdf_storage_find_statements_with_options):
	Added, optional.

	* librdf/rdf_storage.h:
	Added factory method find_statements_with_options
	Added librdf_storage_find_statements_with_options

	* raptor/configure.ac:
	Updated output files check from n3/ntriples plus to turtle

	* raptor/turtle_parser.y, raptor/raptor_rss.c,
	raptor/raptor_parse.c, raptor/ntriples_parse.c:
	Update to use raptor_parser_register_factory alias argument
	to register any old or alternate names.

	* raptor/raptor_internal.h: Add alias field to raptor_parser_factory_s.
	Add alias argument to raptor_parser_register_factory prototype.

	* raptor/raptor_general.c (raptor_parser_register_factory,
	raptor_get_parser_factory): Added an
	alias argument, used to register a alternate name which is
	never used or returned in parser enumerations.

	* raptor/examples/grapper.c:
	Added a tooltip for the errors/warnings output box.

	* raptor/examples/grapper.c: Use G_TYPE_INT for column 1 of errors

	* raptor/examples/grapper.c:
	Added errors/warnings box, updated with results of parsing.

	* raptor/Makefile.am: Added ChangeLog.1

2004-01-19  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_general.c:
	Define raptor_system_malloc, raptor_system_free

	* raptor/raptor_internal.h: RAPTOR_... not LIBRDF_

	* raptor/raptor_utf8.c (raptor_utf8_is_nfc): Use SYSTEM_FREE

	* raptor/raptor_internal.h: Define SYSTEM_MALLOC, SYSTEM_FREE

2004-01-18  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/turtle_parser.y: fix double free of first_identifier

	* raptor/turtle_parser.y: Collections generating triples.

	* raptor/turtle_common.h: Add nil/first/rest_uri fields

	* raptor/tests/turtle/test-07.out: Updated as a collection test result.

	* raptor/tests/turtle/Makefile.am: Added test-08

	* raptor/tests/turtle/test-08.out,
	raptor/tests/turtle/test-08.ttl, raptor/tests/turtle/test-07.ttl:
	collection test

	* raptor/turtle_lexer.l: Added '(' and ')' for collections.

	* raptor/turtle_parser.y:
	Added collection grammar parts, triples not right yet.

	* raptor/raptor_identifier.c (raptor_copy_identifier):
	Copy literal languages correctly.

	* raptor/tests/turtle/test-00.out,
	raptor/tests/turtle/Makefile.am, raptor/tests/Makefile.am,
	raptor/turtle_parser.y, raptor/turtle_lexer.l,
	raptor/turtle_common.h, raptor/raptor_internal.h,
	raptor/raptor_general.c, raptor/configure.ac, raptor/Makefile.am:
	N-Triples Plus to Turtle, n3_ in filenames to turtle_, .ntp to .ttl

	* raptor/rdfdump.c: indenting

	* raptor/rdfdump.c: Allow turtle, don't document ntriples-plus

	* raptor/n3_parser.y, raptor/turtle_parser.y:
	Register under the name turtle

2004-01-17  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* python/RDF.py: Added FileStorage

	* csharp/Makefile.am: touch stamp after build

	* csharp/Makefile.am: Update clean

	* csharp/Makefile.am: Update fakery

	* perl/Makefile.PL: Stop perl linking to destdir

	* python/setup.py: Tidy, add more libraries

	* utils/rdfproc.c: Use librdf_storage_enumerate in help

	* librdf/rdf_storage_tstore.c, librdf/rdf_storage_mysql.c,
	librdf/rdf_storage_list.c, librdf/rdf_storage_hashes.c,
	librdf/rdf_storage_file.c: Updated to add store labels.

	* librdf/rdf_storage.h: Added label to librdf_storage_factory
	librdf_storage_register_factory gains label arg
	Added librdf_storage_enumerate prototype.

	* librdf/rdf_storage.c: Added labels to factory.
	(librdf_storage_register_factory): Added label arg.
	(librdf_storage_enumerate): Added, to get basic store info.

	* librdf/rdf_storage_file.c (librdf_storage_file_size):
	For consistency, use the model call.

	* librdf/rdf_storage.h, librdf/rdf_storage.c:
	Added librdf_init_storage_file

	* librdf/Makefile.am: Added rdf_storage_file.c

	* utils/rdfproc.c: Some C++ casts.
	Init rc correctly.
	Correct indenting to follow logic near CMD_SERIALIZE.

	* librdf/rdf_storage_file.c: Persistent store in file (r/w) and uri (r)

	* librdf/rdf_serializer.h: Re-export librdf_serializer_serialize_model

2004-01-16  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_serializer.c (librdf_serializer_serialize_model):
	re-export

	* librdf/rdf_serializer.c (librdf_serializer_serialize_model):
	static, internal.

	* librdf/rdf_serializer.h:
	Do not export librdf_serializer_serialize_model

2004-01-15  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* java/Makefile.am:
	More OSX-only things; the JNI libs install with a different name!

	* python/RDF.py (Model.get_contexts): Fix Iterator call.

	* java/Makefile.am:
	Add DYLD_LIBRARY_PATH to try to make 'make check' work on OSX.

	* configure.ac: Add OSX dirs to JDK search guesses

	* ruby/Makefile.am: Try to find the right libruby another way

	* librdf/rdf_storage_hashes.c (librdf_storage_hashes_get_contexts):
	Added, implementing get_contexts for hashes storage implementation.

	* python/RDF.py: Export NS class.
	(Parser. parse_string_as_stream): Promote string URI to a Redland Uri.

2004-01-14  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_serializer_raptor.c
	(librdf_serializer_print_statement_as_ntriple): Emit literal
	datatype URI in N-Triples encoding.

	* librdf/rdf_serializer_raptor.c
	(librdf_serializer_print_statement_as_ntriple): break

	* librdf/rdf_serializer_raptor.c
	(librdf_serializer_print_statement_as_ntriple): Emit subject and
	predicate URIs in N-Triples encoding.  Add some checks.

	* librdf/rdf_serializer_raptor.c
	(librdf_serializer_print_statement_as_ntriple): Emit URIs in UTF-8

	* librdf/rdf_uri.c, librdf/rdf_storage_hashes.c,
	librdf/rdf_storage.c, librdf/rdf_statement.c,
	librdf/rdf_serializer.c, librdf/rdf_query.c,
	librdf/rdf_parser_raptor.c, librdf/rdf_parser.c,
	librdf/rdf_node.c, librdf/rdf_model.c, librdf/rdf_internal.h,
	librdf/rdf_hash_bdb.c, librdf/rdf_hash.c, librdf/rdf_digest.c:
	LIBRDF_DEBUG* lose their function arg

	* configure.ac: help message consistency again

	* configure.ac: help message consistency.

	* librdf/rdf_storage_mysql.c, librdf/rdf_storage_list.c,
	librdf/rdf_storage_hashes.c, librdf/rdf_parser_raptor.c: Various
	casts for C++ (g++) to be happier.

	* raptor/raptor_xml_writer.c, raptor/raptor_uri.c,
	raptor/raptor_rss.c, raptor/raptor_qname.c, raptor/raptor_parse.c,
	raptor/raptor_namespace.c, raptor/raptor_internal.h,
	raptor/raptor_general.c, raptor/ntriples_parse.c: RAPTOR_ERROR*
	and RAPTOR_FATAL* lose their function arg, using __func__

	* php/redland_wrap.c.patch:
	Add librdf_php_world_finish() to PHP_MSHUTDOWN_FUNCTION(redland)

	* php/test.php:
	Remove world startup/shutdown, now handled by the module.
	use $world=librdf_php_get_world()

	* php/Makefile.am: Ensure the .orig is around for patching.

	* Redland.i: For PHP, initialise the world when the module starts up.
	Add librdf_serializer definition.

	* examples/Makefile.am: Restore example4

	* librdf/rdf_uri.c, librdf/rdf_stream.c,
	librdf/rdf_storage_tstore.c, librdf/rdf_storage_mysql.c,
	librdf/rdf_storage_list.c, librdf/rdf_storage_hashes.c,
	librdf/rdf_storage.c, librdf/rdf_statement.c,
	librdf/rdf_serializer_rdfxml.c, librdf/rdf_serializer.c,
	librdf/rdf_query.c, librdf/rdf_parser_raptor.c,
	librdf/rdf_parser.c, librdf/rdf_node.c, librdf/rdf_model.c,
	librdf/rdf_list.c, librdf/rdf_internal.h,
	librdf/rdf_hash_memory.c, librdf/rdf_hash_bdb.c,
	librdf/rdf_hash.c, librdf/rdf_digest.c, librdf/rdf_concepts.c:
	LIBRDF_ERROR* and LIBRDF_FATAL* lose their function arg

	* librdf/rdf_serializer.c, librdf/rdf_parser.c, librdf/rdf_storage.c:
	Add a bunch of LIBRDF_ASSERT* for object pointers.

	* librdf/rdf_node.c (librdf_node_get_literal_value_is_wf_xml):
	Only check non-NULL
	datatype URIs.

	* librdf/rdf_node.c (librdf_new_node_from_blank_identifier):
	Removed assertion, can be NULL.

	* librdf/rdf_model.c:
	Add a bunch of LIBRDF_ASSERT* for object pointers.

	* librdf/rdf_internal.h: fix macros again for not debugging.

	* librdf/rdf_internal.h: fix macros for not debugging.

	* librdf/rdf_statement.c:
	Add a bunch of LIBRDF_ASSERT* for object pointers.

	* librdf/rdf_internal.h: Assert macros tweaks.

	* librdf/rdf_node.c, librdf/rdf_uri.c:
	Add a bunch of LIBRDF_ASSERT* for object pointers.

	* librdf/rdf_internal.h (LIBRDF_ASSERT_RETURN, LIBRDF_ASSERT_OBJECT_POINTER_RETURN, LIBRDF_ASSERT_OBJECT_POINTER_RETURN_VALUE):
	Added macros.
	(LIBRDF_ERROR1,LIBRDF_ERROR2,LIBRDF_ERROR3,LIBRDF_FATAL1,LIBRDF_FATAL2):
	Use ANSI C99 __func__ rather than the function arg, renamed them to
	"notused" for now.

	* examples/example4.c: Code now demonstrates serializing.

	* librdf/rdf_uri.c (librdf_new_uri):
	Return NULL if string is NULL or empty (0 length).

	* raptor/raptor_general.c (raptor_finish):
	Remove direct call of raptor_terminate_parser_rdfxml

	* raptor/raptor_parse.c (raptor_xml_parse_finish_factory): Renamed from
	raptor_terminate_parser_rdfxml and now static.

	* raptor/raptor_internal.h: finish_factory returns void

	* raptor/raptor_internal.h:
	Added finish_factory factory cleanup method.
	Removed raptor_terminate_parser_rdfxml.

	* raptor/raptor_general.c (raptor_delete_parser_factories):
	Free mime type, URI string.  Call
	new finish_factory factory method.

	* librdf/rdf_init.c (librdf_free_world, librdf_world_open):
	Add raptor dependency notes.

2004-01-13  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* java/org/librdf/redland/Serializer.java,
	java/org/librdf/redland/Parser.java,
	java/org/librdf/redland/Model.java: Updated
	Model/Parser/Serializer get/setFeature methods to use Node not
	String.

	* librdf/Makefile.am: Add LIBRDF_EXTERNAL_CPPFLAGS for rdf_uri_test

	* utils/Makefile.am: Add LIBRDF_EXTERNAL_CPPFLAGS/LIBS

	* php/redland_wrap.c.patch: offsets

	* python/RDF.py (Model.find_statements): Add optional context arg.

	* perl/lib/RDF/Redland/Model.pm (find_statements):
	Add optional CONTEXT arg and call
	librdf_model_find_statements_in_context if given.

	* Redland.i: Added librdf_model_find_statements_in_context
	Added librdf_model_get_feature, librdf_model_set_feature.
	Adjust librdf_serializer_get_feature,
	librdf_serializer_set_feature to use librdf_node not strings.

	* librdf/rdf_serializer.h, librdf/rdf_serializer.c:
	Adjust librdf_serializer_get_feature,
	librdf_serializer_set_feature to use librdf_node not strings.

	* perl/lib/RDF/Redland/Model.pm: Added contexts method.

	* python/RDF.py (Model): Added get_contexts

	* Redland.i: Added librdf_model_get_contexts

	* python/RDF.py (Model): Added get_feature, set_feature
	(Parser): Updated get_feature, set_feature for using node values.

	* perl/lib/RDF/Redland/Model.pm: (feature) Added

	* perl/Makefile.PL:
	Add CFLAGS to dynamic_lib to get -g when it is enabled.

	* perl/Makefile.PL: CORE_PACKAGE must be in main namespace

	* perl/lib/RDF/Redland/Parser.pm (feature): Use/return nodes.

	* Redland.i:
	Adjust librdf_parser_get_feature, librdf_parser_set_feature to use
	librdf_node not strings.

	* utils/rdfproc.c: Check contexts return value.
	Tidy error, warning count nodes, uris.

	* librdf/rdf_storage_mysql.c (librdf_storage_mysql_get_feature):
	Added, to return contexts always.

	* librdf/rdf_storage_list.c (librdf_storage_list_get_feature):
	Added, to return contexts or not.

	* librdf/rdf_storage_hashes.c (librdf_storage_hashes_get_feature):
	Added, to return contexts or not.

	* utils/rdfproc.c:
	Use librdf_model_get_feature to find out if contexts are supported.

	* librdf/rdf_model_storage.c (librdf_model_storage_set_feature):
	Added, calling librdf_storage_set_feature

	* librdf/rdf_model_storage.c (librdf_model_storage_get_feature):
	Added, calling librdf_storage_get_feature

	* librdf/rdf_storage.h:
	Added storage methods, factory methods get_feature, set_feature now
	with librdf_uri* for feature property name, librdf_node* for values.

	* librdf/rdf_storage.c (librdf_storage_get_feature,librdf_storage_set_feature):
	Added

	* librdf/rdf_model.c (librdf_model_get_feature,librdf_model_set_feature):
	Added

	* librdf/rdf_model.h:
	Added parser methods, factory methods get_feature, set_feature now
	with librdf_uri* for feature property name, librdf_node* for values.

	* librdf/rdf_parser_raptor.c, librdf/rdf_parser.h, librdf/rdf_parser.c:
	parser methods, factory methods get_feature, set_feature now use
	librdf_node* for values.

	* configure.ac: check for getenv

	* utils/rdfproc.1:
	Document environment variables RDFPROC_STORAGE_OPTIONS and
	RDFPROC_STORAGE_TYPE

	* utils/rdfproc.c:
	Use environment variables RDFPROC_STORAGE_OPTIONS and
	RDFPROC_STORAGE_TYPE to provide default storage options (-t) 
	and type (-s)
	Apply in order environment variables, options, storage options.

2004-01-12  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage_mysql.c
	(librdf_storage_mysql_find_statements_in_context):
	Copy the query statement and/or query context_node so that they
	live during the streaming.
	(librdf_storage_mysql_find_statements_in_context_finished): Free them.

	* librdf/rdf_storage_mysql.c:
	(librdf_storage_mysql_find_statements_in_context_next_statement):
	Clear current_context pointer after free.

	* configure.ac: MySQL store works with V3.23.58 and maybe others?

	* librdf/rdf_storage_mysql.c: fix

	* librdf/rdf_storage_mysql.c (librdf_storage_mysql_init):
	Default to port 3306.

	* librdf/rdf_storage_mysql.c:
	(librdf_storage_mysql_get_contexts_next_context) row=

	* librdf/rdf_storage_mysql.c:
	(librdf_storage_mysql_find_statements_in_context_next_statement):
	Allow a NULL context to be returned.

2004-01-11  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* utils/rdfproc.c: contexts commands has no args

	* librdf/rdf_storage_list.c
	(librdf_storage_list_get_contexts_get_method): Use icontext in
	debug arg.

	* utils/rdfproc.1:
	Add find with contexts, contexts, parse-stream with contexts.

	* utils/rdfproc.c:
	Added CONTEXT arg to parse-stream to parse into a context.
	Fixed contexts command, now working.

	* utils/rdfproc.c: Added contexts command to list all contexts.
	Tidied warnings about using context commands with contexts disabled.

	* utils/rdfproc.c:
	Added 4th arg to find command, to find in a particular context
	invoking librdf_model_find_statements_in_context

	* librdf/rdf_storage_hashes.c
	(librdf_storage_hashes_context_serialise): Return NULL if no contexts.

	* utils/rdf-tree.c:
	V0.4 Removed id option Added -m/model, -q/quiet options.
	Now doesn't follow objects of rdf:type.

	* utils/rdf-load.c:
	Removed options id, rdf-parser. Added options input, model, quiet.
	read password from stdin

	* librdf/rdf_model_storage.c (librdf_model_storage_get_contexts):
	Added, implementing get_contexts for model_storage implementation.

	* librdf/rdf_storage_list.c (librdf_storage_list_get_contexts):
	Added to implement get_contexts
	along with:
	(librdf_storage_list_get_contexts_is_end
	librdf_storage_list_get_contexts_next_method
	librdf_storage_list_get_contexts_get_method
	librdf_storage_list_get_contexts_finished): Helper functions for
	the get_contexts method.

	* librdf/rdf_storage_hashes.c:
	Deleted librdf_storage_hashes_find_map and share the same code now in
	librdf_stream_statement_find_map

	* librdf/rdf_stream.h:
	Added prototoype for librdf_stream_statement_find_map

	* librdf/rdf_stream.c (librdf_stream_statement_find_map):
	Added, formerly librdf_storage_list_find_map

	* librdf/rdf_model.h:
	Add factory methods find_statements_in_context, get_contexts.
	Add prototypes for librdf_model_find_statements_in_context and
	librdf_model_get_contexts

	* librdf/rdf_model.c (librdf_model_find_statements_in_context):
	Added, calling
	the factory method otherwise using
	librdf_stream_statement_find_map over a stream of the
	statements in the context.
	(librdf_model_get_contexts): Added.
	(main): Test code, add a get_contexts call; does not yet work
	on memory, hashed stores.

	* librdf/rdf_storage.c (librdf_storage_stream_in_context_map): Deleted.
	(librdf_storage_find_statements_in_context): Do not use the above but
	use librdf_stream_statement_find_map over a stream of the
	statements in the context.

	* librdf/rdf_storage_list.c (librdf_storage_list_find_map): Renamed to
	librdf_stream_statement_find_map and moved to rdf_stream.c

	* librdf/rdf_storage_mysql.c:
	Enable factory methods find_statements_in_context, get_contexts.

	* librdf/rdf_storage.h:
	Add factory methods find_statements_in_context, get_contexts.
	Add prototypes for librdf_storage_find_statements_in_context and
	librdf_storage_get_contexts

	* librdf/rdf_storage.c (librdf_storage_stream_in_context_map):
	Added, helper for
	librdf_storage_find_statements_in_context when not in the factory.
	(librdf_storage_find_statements_in_context): Added.
	(librdf_storage_get_contexts): Added.

	* librdf/rdf_storage_list.c:
	(librdf_storage_list_find_map, librdf_storage_list_find_statements):
	Update to new stream map API.

	* librdf/rdf_storage_hashes.c:
	(librdf_storage_hashes_find_map, librdf_storage_hashes_find_statements):
	Update to new stream map API.

	* librdf/rdf_stream.h, librdf/rdf_stream.c:
	Change stream mapping to use a list of maps, matching the iterator
	code exactly except using librdf_statement*, not void*.
	Add typedefs librdf_stream_map_handler,
	librdf_stream_map_free_context_handler.
	Add librdf_stream_map internal structure.
	Change stream interals to use librdf_stream_map.
	Deleted librdf_stream_set_map.
	Added librdf_stream_add_map using typedefs.

	* librdf/rdf_iterator.h:
	Add free_context handler to librdf_iterator_map
	Define typedefs librdf_iterator_map_handler and
	librdf_iterator_map_free_context_handler
	Change librdf_iterator_add_map to have free_context handler arg.

	* librdf/rdf_iterator.c (librdf_iterator_free_iterator_map):
	Use free_context handler.
	(librdf_iterator_add_map): Add optional free_context handler,
	use typedefs.

	* librdf/rdf_storage_mysql.c: year 2004
	assgment in if()s fixes for gcc warnings.

	* librdf/rdf_storage_mysql.c: Import from morten 2004-01-11

2004-01-08  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* utils/rdfproc.1: Added remove-context command.

	* utils/rdfproc.c:
	Use parser features LIBRDF_PARSER_FEATURE_ERROR_COUNT
	LIBRDF_PARSER_FEATURE_WARNING_COUNT
	to get and report error and warning counts after parsing,
	if either of them is not 0.

2004-01-07  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_parser_raptor.c: Handle LIBRDF_PARSER_FEATURE_ERROR_COUNT
	LIBRDF_PARSER_FEATURE_WARNING_COUNT
	to return error and warning counts after (during?) a parser.
	Since the first error is fatal, it will either be 0 or 1.
	Warnings can be larger.
	(librdf_parser_raptor_get_feature): Added.

	* librdf/rdf_parser.h: Added
	LIBRDF_PARSER_FEATURE_ERROR_COUNT
	LIBRDF_PARSER_FEATURE_WARNING_COUNT

	* perl/lib/RDF/Redland/Parser.pm (parse_string_into_model):
	Fix to call the right function
	librdf_parser_parse_string_into_model

	* librdf/rdf_types.h, configure.ac: Restore u64 tests

	* utils/rdfproc.c: add missing closing }

	* librdf/rdf_storage.h, librdf/rdf_storage.c, librdf/rdf_model.c:
	Documentation: Note that context methods with a NULL context are
	equivalent to the equivalent methods without the context argument.

	* utils/rdfproc.c: On error, free(storage_password) only if set.

	* utils/rdfproc.c: de-torture some logic

	* utils/rdfproc.c:
	Tidy a lot of output and debug messages, s/model/graph/.
	Add command remove-context to invoke
	librdf_model_context_remove_statements

	* utils/rdfproc.1: Note the -p/--password.

	* utils/rdfproc.c:
	Added -p/--password to read a password as storage option 'password'
	from standard input.

	* utils/rdfproc.1: Note the -o/--output FORMAT

	* utils/rdfproc.c:
	Added -o FORMAT to set the output triples format.  Presently just for
	the find command but will apply later to query and others.

	* utils/Makefile.am: Remove update-api-0912.pl

	* utils/update-api-0912.pl: Old api script

	* utils/rdfproc.1: Note blank node, URI, literal syntax.

	* utils/rdfproc.c:
	Use librdf_heuristic_is_blank_node, librdf_heuristic_get_blank_node
	for arcs-in/out, has-arc-in/out

	* utils/rdfproc.c: add a mini rdf notation to rdfproc help
	Use librdf_heuristic_is_blank_node, librdf_heuristic_get_blank_node
	for context nodes with add, add-typed, remove commands.

	* utils/rdfproc.c:
	Use librdf_heuristic_is_blank_node, librdf_heuristic_get_blank_node
	and extend so all source/target/arc &+s commands use them
	as appropriate so blank nodes can be used wherever.

	* librdf/rdf_heuristics.h, librdf/rdf_heuristics.c:
	Added librdf_heuristic_is_blank_node, librdf_heuristic_get_blank_node

	* utils/rdfproc.c:
	Allow _:ABC for blank nodes in subject or object of statements.

2004-01-05  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* perl/Makefile.am:
	Don't pass on PACKAGE variable, Makefile.PL doesn't use it

	* perl/Makefile.PL:
	Don't use PACKAGE envariable; the name isn't changing now!
	Hard code CORE name also.

	* php/redland_wrap.c.patch: offsets again

	* librdf/rdf_model_storage.c
	(librdf_model_storage_context_serialize): Use
	librdf_storage_context_as_stream

	* librdf/rdf_storage_hashes.c: Add some int to
	librdf_statement_part casts.

	* librdf/redland.spec.in: - added redland-python package
	- export some more docs

2004-01-04  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* Redland.i: Remove deprecated librdf_iterator_have_elements

	* docs/redland.pod: Update to match current state; not yet automated.

	* librdf/rdf_stream.h: Make librdf_new_stream_from_node_iterator
	final arg be the enum.

	* librdf/rdf_iterator.h: note deprecation of
	librdf_iterator_have_elements

	* docs/Makefile.am: correctly substitute version in redland.3

	* Makefile.am: Make generated text files keep their links.  Only
	do the generation in maintainer mode.

	* examples/Makefile.am: Some reordering of arguments.
	Add building raptor rule, if needed

	* examples/Makefile.am: Do not ship example4

	* Redland.i: PHP also pollutes the auto* defines into public
	include files.

	* php/redland_wrap.c.patch: Updated

	* php/Makefile.am:
	Put the patching rules in the Makefile, maintainer mode

	* Redland.i: Add some extra prototypes for swig python

	* Redland.i: Do not export deprecated functions: librdf_init_world,
	librdf_destroy_world, librdf_model_serialise,
	librdf_model_context_serialize

	* librdf/rdf_serializer.h, librdf/rdf_parser.h, librdf/rdf_digest.h:
	Change void *c to void *_context in prototypes.  Helps
	remove some declaration shadowing warnings.

	* perl/Makefile.PL: Perl 5.8 is $]=5.008

	* librdf/rdf_uri.h, librdf/rdf_stream.h, librdf/rdf_stream.c,
	librdf/rdf_storage.h, librdf/rdf_storage.c,
	librdf/rdf_statement.h, librdf/rdf_statement.c,
	librdf/rdf_serializer.h, librdf/rdf_query.h, librdf/rdf_parser.h,
	librdf/rdf_node.h, librdf/rdf_model.h, librdf/rdf_iterator.h,
	librdf/rdf_init.h, librdf/rdf_concepts.h: Tidy up the headers,
	split internal/public stuff more clearly.  Export public functions
	with REDLAND_API

	* librdf/librdf.h: Moved internal stuff to rdf_internal.h; include it.

	* librdf/Makefile.am:
	Made rdf_hash.h rdf_digest.h rdf_types.h rdf_model_storage.h
	rdf_heuristics.h rdf_list.h rdf_hash_bdb.h rdf_hash_memory.
	rdf_files.h rdf_storage_list.h rdf_storage_hashes.h
	rdf_query_triples.h source-only headers, never installed.

	* librdf/rdf_storage_mysql.h, librdf/rdf_storage_tstore.h: Restored

	* librdf/rdf_internal.h: rdf_internal.h

2004-01-03  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_iterator.c (librdf_iterator_update_current_element):
	Fix iteration when using a
	list of map functions.
	(librdf_iterator_map_remove_duplicate_nodes): Deleted, never used.

	* librdf/rdf_storage.c (librdf_storage_node_stream_to_node_create):
	and nearby, remove
	prototypical duplicate removing options since it never worked and
	changing it now would confuse.

	* librdf/rdf_storage.c: Removed rdf_storage_mysql/tstore.h

	* librdf/rdf_storage.h: Moved mysql, tstore prototypes here.

	* librdf/rdf_storage_tstore.c: Removed rdf_storage_tstore.h

	* librdf/rdf_storage_tstore.h, librdf/rdf_storage_mysql.h:
	1 function defined here moved to rdf_storage.h

	* librdf/librdf.h: restore accidently deleted #endif

	* librdf/librdf.h: No longer NEED_EXPAT_SOURCE

	* librdf/redland.spec.in, librdf/redland.pc.in: name

	* librdf/librdf.h: comment

	* Makefile.am: Make TODO up to date

	* librdf/rdf_parser_raptor.c: Correctly use SYSTEM_FREE

	* librdf/rdf_parser_raptor.c:
	Remove some FIXMEs; replacing LIBRDF_FREE with SYSTEM_FREE now that
	raptor is never compiled with redland internals enabled even when in
	the source tree.

2004-01-02  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_parser_raptor.c (librdf_parser_raptor_parse_file_as_stream):
	Use pcontext->parser_name with raptor_new_parser.
	(librdf_parser_raptor_constructor): Register the default parser
	last always (rdfxml) and preserve the raptor old name as a true
	alias.

2004-01-01  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_general.c: casts for string ops

	* raptor/raptor_www.c, raptor/raptor_internal.h, raptor/configure.ac:
	Added WWW access with BSD libfetch.

	* raptor/raptor_www_libfetch.c: WWW access with BSD libfetch

